package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.Iterator;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTreeMap;

public class Dailyattendance extends Memployee {
	
	MyTreeMap hm_ta = new MyTreeMap(); //红ѹӧҹ
	MyTreeMap hm_value = new MyTreeMap(); 
	CscCalendar csStart = new CscCalendar();
	CscCalendar csEnd = new CscCalendar();
	MyHashMap hm_hol = new MyHashMap(); //红ѹشġ
	MyTreeMap swipeTime = new MyTreeMap(); //红šٴѵ
	
	/*
	 * ҧ field Ѻ Hash 
	 *  getString դ ʴ "" ᷹͡
	 */
	private void initialColumn() {		
		for (int i=1; i<=40; i++) {
			for (int j=1; j<=11; j++) {
				this.hm_value.put("col"+i+"_"+j,"");
			}
			for (int k=5; k<=10; k++) {
				this.hm_value.put("col"+i+"_"+k+"h","");
			}
		}
	}	
	
	/*
	 *  param ҡ˹ҨѹͧҢš÷ӧҹ
	 * ˹ҨѺ Month  Year
	 */
	private void setCalendar() {
		MyLog.debug(this, "CODEID==="+this.param.get("CODEID"));
		MyLog.debug(this, "MONTH==="+this.param.get("MONTH"));
		MyLog.debug(this, "YEAR==="+this.param.get("YEAR"));					
		 
		this.csStart = new CscCalendar((String)this.param.get("YEAR")+"-"
			+(String)this.param.get("MONTH")+"-01");
		this.csEnd = new CscCalendar((String)this.param.get("YEAR")+"-"
				+(String)this.param.get("MONTH")+"-"+csStart.getEndDateOfMonth());
	}
	
	/*
	 * 纤ҵҧ ͧ÷ӧҹ 1 record ŧ MyHashMap
	 * ͹㹵͹ save 
	 */
	private MyHashMap getEmpData(Simttime_current12 rec) {
		MyHashMap prop = new MyHashMap();
		try {			
			prop.put("dateid",rec.getString("dateid"));
			prop.put("m_tm_bg",rec.getString("m_tm_bg"));
			prop.put("m_tm_en",rec.getString("m_tm_en"));
			prop.put("time0id",rec.getString("time0id"));
			prop.put("tr_type",rec.getString("ty_type"));
			prop.put("eventgrp",rec.getString("eventgrp"));
			prop.put("lt",rec.getString("lt"));
			prop.put("col01",rec.getString("col01"));
			prop.put("col02",rec.getString("col02"));
			prop.put("col03",rec.getString("col03"));
			prop.put("col04",rec.getString("col04"));
			prop.put("data01",rec.getString("data01"));
			prop.put("data02",rec.getString("data02"));
			prop.put("data03",rec.getString("data03"));
			prop.put("data04",rec.getString("data04"));
			prop.put("dataEtc",rec.getString("dataEtc"));
			
			prop.put("forget_in",rec.getString("forget_in"));
			prop.put("forget_out",rec.getString("forget_out"));
		} catch (Exception e) {
			MyLog.error(this, e);			
		}			
		return prop;
	}
	
	/*
	 * 红š÷ӧҹ/ ŧ MyHashMap hm_ta
	 * ͹硡Ѻѹ͹͡ çѺš÷ӧҹ
	 */
	private void initialEmpWorkingTime() {
		try {				
			String sql="employeeid='"+this.getString("employeeid")+"' and " +
					"(dateid between '"+this.csStart.getYYYYMMDD()+"' and '"+this.csEnd.getYYYYMMDD()+"')";
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Simttime_current12", sql, "");
			inq.setColumn("*");
			inq.refresh();
			int i=1;
			String tmp="";
			while (inq.next()) {
				MyTreeMap tr;
				Simttime_current12 rec = (Simttime_current12) inq.getCurrentDbRecord();
				CscCalendar csc = new CscCalendar(rec.getString("dateid"));
				if (csc.getYYYYMMDD().equals(tmp)) {
					tr = (MyTreeMap) this.hm_ta.get(csc.getYYYYMMDD());					
				} else {
					i=1;
					tr = new MyTreeMap();
				}								
				tr.put(String.valueOf(i), this.getEmpData(rec));
				this.hm_ta.put(csc.getYYYYMMDD(), tr);
				i++;
				tmp = csc.getYYYYMMDD();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	/*
	 * ŴšŧҢͧѡҹ
	 * ǧѹ˹
	 */
	private void getSwipeTime() {
		try {
			String tmp=""; 
			int i=1;
			MyTreeMap trSwipeData = new MyTreeMap();
			String sql="employeeid='"+this.getString("employeeid")+"' and " +
				"(swipedate between '"+this.csStart.getYYYYMMDD()+"' and '"+this.csEnd.getYYYYMMDD()+"')";
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Ttimetemp", sql, "employeeid, swipedate, swipetime");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				if (i==1) {
					tmp = inq.getString("swipedate");
					trSwipeData.put(new Double(inq.getString("swipetime")), new Double(inq.getString("swipetime")));					
				}
				
				if (!tmp.equals(inq.getString("swipedate"))) {
					this.swipeTime.put(tmp, trSwipeData);
					trSwipeData = new MyTreeMap();
					trSwipeData.put(new Double(inq.getString("swipetime")), new Double(inq.getString("swipetime")));
				} else {
					trSwipeData.put(new Double(inq.getString("swipetime")), new Double(inq.getString("swipetime")));
				}			
				
				i++;
				tmp = inq.getString("swipedate");
			}
			
			if (!trSwipeData.isEmpty()) {
				this.swipeTime.put(tmp, trSwipeData);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/*
	 * Ӣš÷ӧҹ hm_ta ѹ͡Ҩҡ˹Ҩ
	 * ҡѹçѹ put š÷ӧҹŧ hm_value
	 * ҡçѹ put ѹŧ hm_value
	 */
	private void mapWorkingData() {
		DecimalFormat df = new DecimalFormat("0.00");
		CscCalendar dateStart = new CscCalendar(this.csStart.getYYYYMMDD());
		CscCalendar dateEnd = new CscCalendar(this.csEnd.getYYYYMMDD());
		int i=1;
		while (dateStart.beforeEqualsDate(dateEnd)) {
			if (this.hm_ta.containsKey(dateStart.getYYYYMMDD())) {			
				 /* 
				 * բš÷ӧҹ put š÷ӧҹ͡
				 * ŧ MyHashMap hm_value
				 */
				
				MyTreeMap tr = (MyTreeMap) this.hm_ta.get(dateStart.getYYYYMMDD());
				Iterator it = tr.keySet().iterator();
				while (it.hasNext()) {
					String code = (String) it.next();					
					try {
						MyHashMap hRec = (MyHashMap) tr.get(code);
						this.hm_value.put("col"+i+"_1", dateStart.getDDMMYYYY());
						this.hm_value.put("col"+i+"_2", hRec.getString("time0id"));
						if (hRec.getString("m_tm_bg").equals(hRec.getString("m_tm_en"))) {
							if (hRec.getString("forget_in").equals("1") && hRec.getString("forget_out").equals("1")) {
								this.hm_value.put("col"+i+"_3", "");				
 								this.hm_value.put("col"+i+"_4", "");
							} else if (hRec.getString("forget_in").equals("0") && hRec.getString("forget_out").equals("1")) {
								this.hm_value.put("col"+i+"_3", df.format(hRec.getDouble("m_tm_bg")));				
 								this.hm_value.put("col"+i+"_4", "");
							} else if (hRec.getString("forget_in").equals("1") && hRec.getString("forget_out").equals("0")) {
								this.hm_value.put("col"+i+"_3", "");				
 								this.hm_value.put("col"+i+"_4", df.format(hRec.getDouble("m_tm_en")));
 							} else {
 								this.hm_value.put("col"+i+"_3", "");				
 								this.hm_value.put("col"+i+"_4", "");
 							}
						} else if (hRec.getString("tr_type").indexOf("A")>-1) {
							this.hm_value.put("col"+i+"_3", df.format(hRec.getDouble("c_tm_bg")));
							this.hm_value.put("col"+i+"_4", df.format(hRec.getDouble("c_tm_en")));
						} else {
							this.hm_value.put("col"+i+"_3", df.format(hRec.getDouble("m_tm_bg")));
							this.hm_value.put("col"+i+"_4", df.format(hRec.getDouble("m_tm_en")));
						}
                        this.hm_value.put("col"+i+"_5", df.format(Double.parseDouble(hRec.getString("lt"))));
                        this.hm_value.put("col"+i+"_6", hRec.getString("data01"));
                        this.hm_value.put("col"+i+"_7" ,hRec.getString("data02"));
                        this.hm_value.put("col"+i+"_8", hRec.getString("data03"));
                        this.hm_value.put("col"+i+"_9", hRec.getString("data04"));
                        this.hm_value.put("col"+i+"_10", hRec.getString("dataEtc"));                    

                        if(!hRec.getString("lt").equals(""))
                            this.hm_value.put("col"+i+"_5", df.format(Double.parseDouble(hRec.getString("lt"))));                            
                        if(!hRec.getString("data01").equals(""))
                            this.hm_value.put("col"+i+"_6", df.format(Double.parseDouble(hRec.getString("data01"))));
                        if(!hRec.getString("data02").equals(""))
                            this.hm_value.put("col"+i+"_7" , df.format(Double.parseDouble(hRec.getString("data02"))));
                        if(!hRec.getString("data03").equals(""))
                            this.hm_value.put("col"+i+"_8", df.format(Double.parseDouble(hRec.getString("data03"))));
                        if(!hRec.getString("data04").equals(""))
                            this.hm_value.put("col"+i+"_9", df.format(Double.parseDouble(hRec.getString("data04"))));
                        if(!hRec.getString("dataEtc").equals(""))
                            this.hm_value.put("col"+i+"_10", df.format(Double.parseDouble(hRec.getString("dataEtc"))));
                        
						//this.hm_value.put("col"+i+"_11", this.chkDayType(dateStart.getYYYYMMDD(), dateStart.getCSCDOW())); //ͧѹ
                        //this.hm_value.put("col"+i+"_10", hRec.getString("dataEtc"));
	                    String sign = this.chkDayType(dateStart.getYYYYMMDD(), dateStart.getCSCDOW());
	                    if (sign.equals("@")) {
	                    	this.hm_value.put("col"+i+"_11", sign); //ͧѹ
	                    } else { 
	                    	if (hRec.getString("eventgrp").equals("H")) {
	                    		this.hm_value.put("col"+i+"_11", "*");
	                    	} else  this.hm_value.put("col"+i+"_11", sign); //ͧѹ
						}
						/*
						 * col 5h-10h put  column ŧ 
						 */
						this.hm_value.put("col"+i+"_5h", "");
						this.hm_value.put("col"+i+"_6h", hRec.getString("col01"));
						this.hm_value.put("col"+i+"_7h" ,hRec.getString("col02"));
						this.hm_value.put("col"+i+"_8h", hRec.getString("col03"));
						this.hm_value.put("col"+i+"_9h", hRec.getString("col04"));
						this.hm_value.put("col"+i+"_10h", "");		
						
					} catch (Exception e) {
						MyLog.error(this, e);	
					}			
					i++;
				}				
			} else {
				/*
				 * բš÷ӧҹ put ѹ
				 * ŧ MyHashMap hm_value
				 * ǹͧ  "" 
				 */
				MyLog.debug(this, "::: NOT MAP ::: "+dateStart.getDDMMYYYY());
				if (this.swipeTime.containsKey(dateStart.getYYYYMMDD())) {					
					MyTreeMap tr = (MyTreeMap) this.swipeTime.get(dateStart.getYYYYMMDD());
					System.out.println("::: NOT MAP ::: "+dateStart.getDDMMYYYY()+" : "+tr.keySet());
					if (tr.size()==1) {
						for (Iterator IT = tr.keySet().iterator(); IT.hasNext();) {						
							this.hm_value.put("col"+i+"_3", df.format((Double) IT.next()));
						}						
					} else if (tr.size()==2) {
						for (Iterator IT = tr.keySet().iterator(); IT.hasNext();) {				
							this.hm_value.put("col"+i+"_3", df.format((Double) IT.next()));
							this.hm_value.put("col"+i+"_4", df.format((Double) IT.next()));
						}
					} else if (tr.size()>=3) {
						String t1 = "";
						String t2 = "";						
						int loop = 1;
						for (Iterator IT = tr.keySet().iterator(); IT.hasNext();) {
							if (loop==1) {
								t1 = df.format((Double) IT.next());
							}
							t2 = df.format((Double) IT.next());
							loop++;
						}
						this.hm_value.put("col"+i+"_3", t1);
						this.hm_value.put("col"+i+"_4", t2);
					}
				}
				
				this.hm_value.put("col"+i+"_1", dateStart.getDDMMYYYY());
				if (this.chkDayType(dateStart.getYYYYMMDD(), dateStart.getCSCDOW()).equals("@")) {
					this.hm_value.put("col"+i+"_11", "@"); //ͧѹ
				} else this.hm_value.put("col"+i+"_11", "*"); //ͧѹ
				i++;
			}			
			dateStart.incDate();
		}
	}

	/*
	 * չӧҹѹ
	 * I = ѹشġ
	 * * = ѹش -
	 * Y = ѹӧҹ
	 */
	private String chkDayType(String date ,int type) {		
		if (this.hm_hol.containsKey(date)) {
			return "I";
		} 
		//else if (type==6 || type==7) {
		//	return "*";
		//} 
		return "";		
	}
	
	/*
	 * ŴѹشġͧФ MyHashMap
	 * ͹ѹӧҹѹشġ
	 */
	private void setHoliday() {		
		try {
			DbInquiry inqChild = new InitialInquiry(this.userPro).getDbInquiry();
			inqChild.setParam(this.param);
			inqChild.setSchemaName(this.userPro.getSchemaName());						
			inqChild.initMyTable("Mholiday1", "", "");
			inqChild.setColumn("holidayid, hdate");
			
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());						
			inq.initMyTable("Mtime0", "time0id='"+this.getString("time0")+"'", "");
			inq.setColumn("time0id, companyid, holidaycode");
			inq.putChild(inqChild);
			inq.refresh();
			if (inq.next()) {
				DbInquiry child = (DbInquiry) inq.getChild("Mholiday1");
				do {
					CscCalendar cs = new CscCalendar(inqChild.getCurrentDbRecord().getString("hdate"));
					this.hm_hol.put(cs.getYYYYMMDD(), cs.getYYYYMMDD());					
				} while (child.next());				
			}
		} catch(Exception e) {
			MyLog.error(this, e);
}		
	}
	
	public void postInqNext() {		
		if (this.foundData) {
			super.postInqNext();	
			this.hm_ta.clear();
			this.hm_value.clear();
			this.hm_hol.clear();
			this.swipeTime.clear();
			this.initialColumn();
			this.setCalendar();
			this.setHoliday();		
			this.getSwipeTime();
			this.initialEmpWorkingTime();
			this.mapWorkingData();
			System.out.println(this.swipeTime);
			System.out.println(this.hm_ta);
			System.out.println(this.hm_value);			
		}		
	}
	
	public String getString(String fieldName) {
		if (fieldName.indexOf("$") >= 0) {
			return this.getStringHash(fieldName);
		} else if (this.hm_value.containsKey(fieldName)) {
			return this.hm_value.get(fieldName).toString();
		} else return super.getString(fieldName);
	}

	private String getStringHash(String fieldName) {
		if (fieldName.indexOf("$") >= 0) {
			String fname = fieldName.substring(0, fieldName.indexOf("$"));
			String lname = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hm_value.containsKey(lname)) {				
				return (String) this.hm_value.get(lname);
			} else return super.getString(fieldName);
		} else return super.getString(fieldName);		
	}
}
