package com.csc.library.databean;

import java.text.DecimalFormat;
import java.util.Iterator;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

/*
 * class ʴŧҧҹͧѡҹͺ 1 ͹
 */
public class Dailyswipetime extends Memployee {
	
	MyTreeMap hm_ta = new MyTreeMap(); //红ѹӧҹ
	MyTreeMap hm_value = new MyTreeMap(); 
	CscCalendar csStart = new CscCalendar();
	CscCalendar csEnd = new CscCalendar();
	MyHashMap hm_hol = new MyHashMap(); //红ѹشġ
	MyHashMap hm_hol_desc = new MyHashMap(); //红´ѹشġ
	MyHashMap hm_event = new MyHashMap(); //红Żѹ
	MyTreeMap swipeTime = new MyTreeMap(); //红šٴѵ
	
	DbInquiry inqTime = null;
	DbInquiry inqEvent = null;
	DbInquiry inqMtime = null;
	DbInquiry inqSwipeTime = null;
	
	/*
	 * ҧ field Ѻ Hash 
	 *  getString դ ʴ "" ᷹͡
	 */
	private void initialColumn() {		
		for (int i=1; i<=40; i++) {
			for (int j=1; j<=11; j++) {
				this.hm_value.put("col"+i+"_"+j,"");
			}
		}
	}	
	
	/*
	 *  param ҡ˹ҨѹͧҢš÷ӧҹ
	 * ˹ҨѺ Month  Year
	 */
	private void setCalendar() {
		MyLog.debug(this, "MONTH==="+this.param.get("MONTH"));
		MyLog.debug(this, "YEAR==="+this.param.get("YEAR"));					
		 
		this.csStart = new CscCalendar((String)this.param.get("YEAR")+"-"
			+(String)this.param.get("MONTH")+"-01");
		this.csEnd = new CscCalendar((String)this.param.get("YEAR")+"-"
				+(String)this.param.get("MONTH")+"-"+csStart.getEndDateOfMonth());
	}
	
	/*
	 * 红š÷ӧҹ/ ŧ MyHashMap hm_ta
	 * ͹硡Ѻѹ͹͡ çѺš÷ӧҹ
	 */
	private void initialEmpWorkingTime() {
		try {				
			String filter="employeeid='"+this.getString("employeeid")+"' and " +
					"(dateid between '"+this.csStart.getYYYYMMDD()+"' and '"+this.csEnd.getYYYYMMDD()+"')";
			if (this.inqTime == null) {
				this.inqTime = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTime.setParam(this.param);
				this.inqTime.setSchemaName(this.userPro.getSchemaName());
				this.inqTime.initMyTable("Ttime_current1", "", "");
				this.inqTime.setColumn("*");
			}
			this.inqTime.setFilter(filter);
			this.inqTime.refresh();
			int i=1;
			String tmp="";
			while (this.inqTime.next()) {
				MyTreeMap tr;
				Ttime_current1 rec = (Ttime_current1) this.inqTime.getCurrentDbRecord();
				CscCalendar csc = new CscCalendar(rec.getString("dateid"));
				if (csc.getYYYYMMDD().equals(tmp)) {
					tr = (MyTreeMap) this.hm_ta.get(csc.getYYYYMMDD());					
				} else {
					i=1;
					tr = new MyTreeMap();
				}								
				tr.put(String.valueOf(i), this.getEmpData(rec));
				this.hm_ta.put(csc.getYYYYMMDD(), tr);
				i++;
				tmp = csc.getYYYYMMDD();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}
	
	private MyHashMap getEmpData(Ttime_current1 rec) {
		MyHashMap prop = new MyHashMap();
		try {			
			prop.put("dateid", rec.getString("dateid"));
			prop.put("m_tm_bg", rec.getString("m_tm_bg"));
			prop.put("m_tm_en", rec.getString("m_tm_en"));
			prop.put("time0id", rec.getString("time0id"));
			prop.put("tr_type", rec.getString("tr_type"));
			prop.put("eventgrp", rec.getString("eventgrp"));
			prop.put("lt", rec.getString("lt"));		
			prop.put("ac_ot", rec.getString("ac_ot"));		
			prop.put("hour_d", rec.getString("hour_d"));		
			prop.put("forget_in", rec.getString("forget_in"));
			prop.put("forget_out", rec.getString("forget_out"));
		} catch (Exception e) {
			MyLog.error(this, e);			
		}			
		return prop;
	}
	
	/*
	 * չӧҹѹ
	 * I = ѹشġ
	 * * = ѹش -
	 * Y = ѹӧҹ
	 */
	private String chkDayType(String date ,int type) {		
		if (this.hm_hol.containsKey(date)) {
			return "I";
		} 
		return "";		
	}
	
	/*
	 * ŴѹشġͧФ MyHashMap
	 * ͹ѹӧҹѹشġ
	 */
	private void setHoliday() {		
		try {
			if (this.inqMtime == null) {
				DbInquiry inqChild = new InitialInquiry(this.userPro).getDbInquiry();
				inqChild.setParam(this.param);
				inqChild.setSchemaName(this.userPro.getSchemaName());						
				inqChild.initMyTable("Mholiday1", "", "");
				inqChild.setColumn("holidayid, hdate, companyid, tdesc, edesc");
				
				this.inqMtime = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqMtime.setParam(this.param);
				this.inqMtime.setSchemaName(this.userPro.getSchemaName());						
				this.inqMtime.initMyTable("Mtime0", "", "");
				this.inqMtime.setColumn("time0id, companyid, holidaycode");
				this.inqMtime.putChild(inqChild);
			}
			
			this.inqMtime.setFilter("time0id='"+this.getString("time0")+"'");
			this.inqMtime.refresh();
			if (this.inqMtime.next()) {
				DbInquiry child = (DbInquiry) this.inqMtime.getChild("Mholiday1");
				do {
					CscCalendar cs = new CscCalendar(child.getString("hdate"));
					this.hm_hol.put(cs.getYYYYMMDD(), cs.getYYYYMMDD());	
					if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
						this.hm_hol_desc.put(cs.getDDMMYYYY(), child.getString("tdesc"));
					} this.hm_hol_desc.put(cs.getDDMMYYYY(), child.getString("edesc"));
				} while (child.next());				
			}
		} catch(Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	/*
	 * ŴŻѹ ͹㹡ʴŵ
	 */
	private void setEvent() {		
		try {
			if (this.hm_event.isEmpty()) {
				if (this.inqEvent == null) {
					this.inqEvent = new InitialInquiry(this.userPro).getDbInquiry();
					this.inqEvent.setParam(this.param);
					this.inqEvent.setSchemaName(this.userPro.getSchemaName());						
					this.inqEvent.initMyTable("Meventgrp", "", "");
					this.inqEvent.setColumn("eventgrpid, companyid, tdesc, edesc");
				}
				this.inqEvent.refresh();
				while (this.inqEvent.next()) {
					if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
						this.hm_event.put(	this.inqEvent.getString("eventgrpid"), this.inqEvent.getString("tdesc"));
					} else this.hm_event.put(this.inqEvent.getString("eventgrpid"), this.inqEvent.getString("edesc"));
				}
			}
		} catch(Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	/*
	 * ֧´ѹ Ŵ
	 */
	private String getEventDesc(String event) {
		if (this.hm_event.containsKey(event)) {
			return this.hm_event.getString(event);
		} else return "";
	}
	
	/*
	 * ֧ѹشġ Ŵ
	 */
	private String getHolidayDesc(String csDate) {
		if (this.hm_hol_desc.containsKey(csDate)) {
			return this.hm_hol_desc.getString(csDate);
		} else return "";
	}
	
	/*
	 * ŴšŧҢͧѡҹ
	 * ǧѹ˹
	 */
	private void getSwipeTime() {
		try {
			String tmp=""; 
			int i=1;
			MyTreeMap trSwipeData = new MyTreeMap();
			String filter = "employeeid='"+this.getString("employeeid")+"' and " +
				"(swipedate between '"+this.csStart.getYYYYMMDD()+"' and '"+this.csEnd.getYYYYMMDD()+"')";
			if (this.inqSwipeTime == null) {
				this.inqSwipeTime = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqSwipeTime.setParam(this.param);
				this.inqSwipeTime.setSchemaName(this.userPro.getSchemaName());
				this.inqSwipeTime.initMyTable("Ttimetemp", "", "employeeid, swipedate, swipetime");
				this.inqSwipeTime.setColumn("*");
			}
			this.inqSwipeTime.setFilter(filter);
			this.inqSwipeTime.refresh();
			while (this.inqSwipeTime.next()) {
				if (i==1) {
					tmp = this.inqSwipeTime.getString("swipedate");
					trSwipeData.put(new Double(this.inqSwipeTime.getString("swipetime")), new Double(this.inqSwipeTime.getString("swipetime")));					
				}
				
				if (!tmp.equals(this.inqSwipeTime.getString("swipedate"))) {
					this.swipeTime.put(tmp, trSwipeData);
					trSwipeData = new MyTreeMap();
					trSwipeData.put(new Double(this.inqSwipeTime.getString("swipetime")), new Double(this.inqSwipeTime.getString("swipetime")));
				} else {
					trSwipeData.put(new Double(this.inqSwipeTime.getString("swipetime")), new Double(this.inqSwipeTime.getString("swipetime")));
				}			
				
				i++;
				tmp = this.inqSwipeTime.getString("swipedate");
			}
			
			if (!trSwipeData.isEmpty()) {
				this.swipeTime.put(tmp, trSwipeData);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/*
	 * Ӣš÷ӧҹ hm_ta ѹ͡Ҩҡ˹Ҩ
	 * ҡѹçѹ put š÷ӧҹŧ hm_value
	 * ҡçѹ put ѹŧ hm_value
	 */
	private void mapWorkingData() {
		DecimalFormat df = new DecimalFormat("0.00");
		CscCalendar dateStart = new CscCalendar(this.csStart.getYYYYMMDD());
		CscCalendar dateEnd = new CscCalendar(this.csEnd.getYYYYMMDD());
		int i=1;
		while (dateStart.beforeEqualsDate(dateEnd)) {
			if (this.hm_ta.containsKey(dateStart.getYYYYMMDD())) {			
				 /* 
				 * բš÷ӧҹ put š÷ӧҹ͡
				 * ŧ MyHashMap hm_value
				 */
				
				MyTreeMap tr = (MyTreeMap) this.hm_ta.get(dateStart.getYYYYMMDD());
				Iterator it = tr.keySet().iterator();
				while (it.hasNext()) {
					String code = (String) it.next();					
					try {
						MyHashMap hRec = (MyHashMap) tr.get(code);
						this.hm_value.put("col"+i+"_1", dateStart.getDDMMYYYY());
						this.hm_value.put("col"+i+"_2", hRec.getString("time0id"));
						if (hRec.getString("m_tm_bg").equals(hRec.getString("m_tm_en"))) {
							if (hRec.getString("forget_in").equals("1") && hRec.getString("forget_out").equals("1")) {
								this.hm_value.put("col"+i+"_3", "");				
 								this.hm_value.put("col"+i+"_4", "");
							} else if (hRec.getString("forget_in").equals("0") && hRec.getString("forget_out").equals("1")) {
								this.hm_value.put("col"+i+"_3", df.format(hRec.getDouble("m_tm_bg")));				
 								this.hm_value.put("col"+i+"_4", "");
							} else if (hRec.getString("forget_in").equals("1") && hRec.getString("forget_out").equals("0")) {
								this.hm_value.put("col"+i+"_3", "");				
 								this.hm_value.put("col"+i+"_4", df.format(hRec.getDouble("m_tm_en")));
 							} else {
 								this.hm_value.put("col"+i+"_3", "");				
 								this.hm_value.put("col"+i+"_4", "");
 							}
						} else if (hRec.getString("tr_type").indexOf("A")>-1) {
							this.hm_value.put("col"+i+"_3", df.format(hRec.getDouble("c_tm_bg")));
							this.hm_value.put("col"+i+"_4", df.format(hRec.getDouble("c_tm_en")));
						} else if (hRec.getString("tr_type").indexOf("H")>-1) {
							this.hm_value.put("col"+i+"_3", "");
							this.hm_value.put("col"+i+"_4", "");
						} else {
							this.hm_value.put("col"+i+"_3", df.format(hRec.getDouble("m_tm_bg")));
							this.hm_value.put("col"+i+"_4", df.format(hRec.getDouble("m_tm_en")));
						}
                        this.hm_value.put("col"+i+"_5", df.format(Double.parseDouble(hRec.getString("lt"))));        
                        this.hm_value.put("col"+i+"_6", df.format(Double.parseDouble(hRec.getString("hour_d"))));        
                        this.hm_value.put("col"+i+"_7", df.format(Double.parseDouble(hRec.getString("ac_ot"))));        
                        
                        if(!hRec.getString("lt").equals(""))
                            this.hm_value.put("col"+i+"_5", df.format(Double.parseDouble(hRec.getString("lt"))));     
                        if(!hRec.getString("hour_d").equals(""))
                            this.hm_value.put("col"+i+"_6", df.format(Double.parseDouble(hRec.getString("hour_d"))));   
                        if(!hRec.getString("ac_ot").equals(""))
                            this.hm_value.put("col"+i+"_7", df.format(Double.parseDouble(hRec.getString("ac_ot"))));   
                        
                        this.hm_value.put("col"+i+"_8", this.getEventDesc(hRec.getString("eventgrp")));     
                        this.hm_value.put("col"+i+"_9", this.getHolidayDesc(dateStart.getDDMMYYYY()));     
                        
	                    String sign = this.chkDayType(dateStart.getYYYYMMDD(), dateStart.getCSCDOW());
	                    if (sign.equals("@")) {
	                    	this.hm_value.put("col"+i+"_11", sign); //ͧѹ
	                    } else { 
	                    	if (hRec.getString("eventgrp").equals("H")) {
	                    		this.hm_value.put("col"+i+"_11", "*");
	                    	} else  this.hm_value.put("col"+i+"_11", sign); //ͧѹ
						}						
					} catch (Exception e) {
						MyLog.error(this, e);						
					}			
					i++;
				}				
			} else {
				/*
				 * բš÷ӧҹ put ѹ
				 * ŧ MyHashMap hm_value
				 * ǹͧ  "" 
				 */
				MyLog.debug(this, "::: NOT MAP ::: "+dateStart.getDDMMYYYY());
				if (this.swipeTime.containsKey(dateStart.getYYYYMMDD())) {					
					MyTreeMap tr = (MyTreeMap) this.swipeTime.get(dateStart.getYYYYMMDD());
					System.out.println("::: NOT MAP ::: "+dateStart.getDDMMYYYY()+" : "+tr.keySet());
					if (tr.size()==1) {
						for (Iterator IT = tr.keySet().iterator(); IT.hasNext();) {						
							this.hm_value.put("col"+i+"_3", df.format((Double) IT.next()));
						}						
					} else if (tr.size()==2) {
						for (Iterator IT = tr.keySet().iterator(); IT.hasNext();) {				
							this.hm_value.put("col"+i+"_3", df.format((Double) IT.next()));
							this.hm_value.put("col"+i+"_4", df.format((Double) IT.next()));
						}
					} else if (tr.size()>=3) {
						String t1 = "";
						String t2 = "";						
						int loop = 1;
						for (Iterator IT = tr.keySet().iterator(); IT.hasNext();) {
							if (loop==1) {
								t1 = df.format((Double) IT.next());
							}
							t2 = df.format((Double) IT.next());
							loop++;
						}
						this.hm_value.put("col"+i+"_3", t1);
						this.hm_value.put("col"+i+"_4", t2);
					}
				}
				
				this.hm_value.put("col"+i+"_1", dateStart.getDDMMYYYY());
				if (this.chkDayType(dateStart.getYYYYMMDD(), dateStart.getCSCDOW()).equals("@")) {
					this.hm_value.put("col"+i+"_11", "@"); //ͧѹ
				} else this.hm_value.put("col"+i+"_11", "*"); //ͧѹ
				i++;
			}			
			dateStart.incDate();
		}
	}
	
	public void postInqNext() {		
		if (this.foundData) {
			super.postInqNext();	
			this.hm_ta.clear();
			this.hm_value.clear();
			this.hm_hol.clear();
			this.swipeTime.clear();
			this.initialColumn();
			this.setCalendar();
			this.setEvent();
			this.setHoliday();		
			this.getSwipeTime();
			this.initialEmpWorkingTime();
			this.mapWorkingData();
			System.out.println(this.swipeTime);
			System.out.println(this.hm_ta);
			System.out.println(this.hm_value);			
		}		
	}
	
	public String getString(String fieldName) {
		if (fieldName.indexOf("$") >= 0) {
			return this.getStringHash(fieldName);
		} else if (this.hm_value.containsKey(fieldName)) {
			return this.hm_value.get(fieldName).toString();
		} else return super.getString(fieldName);
	}

	private String getStringHash(String fieldName) {
		if (fieldName.indexOf("$") >= 0) {
			String fname = fieldName.substring(0, fieldName.indexOf("$"));
			String lname = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hm_value.containsKey(lname)) {				
				return (String) this.hm_value.get(lname);
			} else return super.getString(fieldName);
		} else return super.getString(fieldName);		
	}
	
}
