package com.csc.library.databean;

import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;

/*
 * 㹡ʴӹǹ边ѡҹͺ 1 բͧ Ƿ
 */
public class Mempl_late_yearsummary_nstda extends Memployee {
	
	private MyHashMap hmDataMonth = new MyHashMap();
	private DbInquiry inqC = null;
	private DbInquiry inqH = null;
	
	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			this.initDataColunm(this.hmDataMonth);
			this.setData();						
			MyLog.debug(this, "MONTH DATA==="+this.hmDataMonth);
		}
		return temp;
    }
	
	/*
	 * ˹͹
	 */
	private void initDataColunm(MyHashMap hm) {
		CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
		CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
		int m = Integer.parseInt(cscStart.getMM());
		int i=1;
		while (i<=12) {
			String id = String.valueOf(i);
			CscCalendar csc = new CscCalendar("01-"+id+"-"+cscStart.getYear());
            this.hmDataMonth.put("col"+id+"_name",csc.getEngShortMonth());
			if (this.getUProfile().get("lang").equals("THA")){
	            this.hmDataMonth.put("col"+id+"_name",csc.getThaiShortMonth());			    
			}
			this.hmDataMonth.put("col"+id+"_used",new Double(0));
			this.hmDataMonth.put("col"+id+"_count",new Integer(0));
			i++;
		}	
		this.hmDataMonth.put("used_total",new Double(0));
		this.hmDataMonth.put("count_total",new Integer(0));
	}
	
	/*
	 * ӡúǡӹǹ边ѡҹ ¡͹ӹǹ 1 
	 * ҢҨҡ ttime_current1  ttime_history1
	 */
	private void setData() {
		/*
		 * DayType = 7		Vacation
		 * DayType = LT		Late
		 * DayType other 	Leave  
		 */
		CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
		CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
		String leave = (String) this.param.get("LEAVETYPE");
		String filter = "employeeid='"+this.getString("employeeid")+"'" +
		" and (dateid between '"+cscStart.getYYYYMMDD()+"' and '"+cscEnd.getYYYYMMDD()+"')" +
		" and lt>0";
		try {		
			//š÷ӧҹ㹻Ѩغѹ
			if (this.inqC==null) {
				this.inqC = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqC.setSchemaName(this.userPro.getSchemaName());						
				this.inqC.initMyTable("Ttime_current1", "", "employeeid,dateid");
				this.inqC.setColumn("*");
			}
			this.inqC.setFilter(filter);
			this.inqC.refresh();
			while (this.inqC.next()) {
				DbRecord rec = this.inqC.getCurrentDbRecord();
				CscCalendar c = new CscCalendar(rec.getString("dateid"));
				String id = "col"+Integer.parseInt(c.getMM());
				if (this.hmDataMonth.containsKey(id+"_name")) {
					int count = this.hmDataMonth.getInt(id+"_count");
					float used = this.hmDataMonth.getFloat(id+"_used");
					count = count+1;
					CscTime ct = new CscTime(used);
					ct.add(rec.getFloat("lt"));
					used = ct.getFloat();
					
					this.hmDataMonth.put(id+"_used", new Float(used));
					this.hmDataMonth.put(id+"_count", new Integer(count));
				}			
				
				//ӡúǡ駻
				int count_total = this.hmDataMonth.getInt("count_total");
				float used_total = this.hmDataMonth.getFloat("used_total");
				count_total = count_total+1;
				CscTime ct = new CscTime(used_total);
				ct.add(rec.getFloat("lt"));
				used_total = ct.getFloat();
				
				this.hmDataMonth.put("count_total", new Integer(count_total));
				this.hmDataMonth.put("used_total", new Float(used_total));
			}			
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		
		try {		
			//š÷ӧҹ㹻ѵԡ÷ӧҹ
			if (this.inqH==null) {
				this.inqH = new InitialInquiry(this.userPro).getDbInquiry();			
				this.inqH.setSchemaName(this.userPro.getSchemaName());						
				this.inqH.initMyTable("Ttime_history1", "", "employeeid,dateid");
				this.inqH.setColumn("*");
			}
			this.inqH.setFilter(filter);
			this.inqH.refresh();
			while (this.inqH.next()) {
				DbRecord rec = this.inqH.getCurrentDbRecord();
				CscCalendar c = new CscCalendar(rec.getString("dateid"));
				String id = "col"+Integer.parseInt(c.getMM());
				if (this.hmDataMonth.containsKey(id+"_name")) {
					int count = this.hmDataMonth.getInt(id+"_count");
					float used = this.hmDataMonth.getFloat(id+"_used");
					count = count+1;
					CscTime ct = new CscTime(used);
					ct.add(rec.getFloat("lt"));
					used = ct.getFloat();
					
					this.hmDataMonth.put(id+"_used", new Float(used));
					this.hmDataMonth.put(id+"_count", new Integer(count));
				}			
				
				//ӡúǡ駻
				int count_total = this.hmDataMonth.getInt("count_total");
				float used_total = this.hmDataMonth.getFloat("used_total");
				count_total = count_total+1;
				CscTime ct = new CscTime(used_total);
				ct.add(rec.getFloat("lt"));
				used_total = ct.getFloat();
				
				this.hmDataMonth.put("count_total", new Integer(count_total));
				this.hmDataMonth.put("used_total", new Float(used_total));
			}			
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	public String getString(String fieldName) {		
		if (fieldName.indexOf("$") > 0) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}
	
	private String getStringChild(String fieldName) {
		if (fieldName.indexOf("$") > 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hmDataMonth.get(fName) != null) {
				return this.hmDataMonth.getString(fName);
			} else super.getString(fieldName);
		}
		return super.getString(fieldName);
	}
}