package com.csc.library.databean;

import com.csc.library.utilities.MyLog;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;

import std.library.DataTable;

import com.csc.entity.DataBMPBean;
import com.csc.library.database.CscConnection;
import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;

/*
 * Ѻúѹ֡šŧһШ͹
 * ¡͡ŧ͹ ͧ͡ѹ 
 */
public class Memployee_swipetime extends Memployee {
	
	//static int maxSwipeRec = 5; // 1 ѹ ʴŧҨӹǹ Record
	static int maxSwipeRec = 8; // 1 ѹ ʴŧҨӹǹ Record [for PG site]
	MyHashMap hmField = new MyHashMap();
	MyHashMap hmDateName = new MyHashMap();
	MyHashMap hmSwipeData = new MyHashMap();
	String column="";
	 
	/*
	 * ӡô֧šŧҢͧѡҹǧҷ
	 * ѹ ѹŧ˹ҧ
	 */
	private MyTreeMap getSwipeData(CscCalendar cs1, CscCalendar cs2) {
		MyTreeMap tr = new MyTreeMap();
		try {
			int i=0;
			CscCalendar tmp = null;
			MyTreeMap detail = new MyTreeMap();
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Ttimetemp","employeeid='"+this.getString("employeeid")+
					"' and (swipedate between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"')", "swipedate,swipetime");
			inq.setColumn("employeeid, swipedate, swipetime, companyid,source");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord();
				if (tmp == null) {
					detail = new MyTreeMap(); //红šŧѹ
					tmp = rec.getCscCalendar("swipedate");
					detail.put(Double.valueOf(rec.getString("swipetime")), Double.valueOf(rec.getString("swipetime")));
				} else if (!tmp.equalsDate(rec.getCscCalendar("swipedate"))) { //ѹ¹ ҧ treemap  红šŧ
					tr.put(tmp.getDDMMYYYY(), detail);
					detail = new MyTreeMap(); //红šŧѹ
					detail.put(Double.valueOf(rec.getString("swipetime")), Double.valueOf(rec.getString("swipetime")));
					tmp = rec.getCscCalendar("swipedate");
				} else { //ѹӢšŧŧ tree map 
					detail.put(Double.valueOf(rec.getString("swipetime")), Double.valueOf(rec.getString("swipetime")));
				}	
				i++;
				
			} 
			if (i!=0) {
				tr.put(tmp.getDDMMYYYY(), detail);
			}
		} catch (Exception e) {
			//MyLog.error(this, e);
		}
		finally {
			try{
				inq.closeConnection();
			}catch(Exception e){
				MyLog.error("!! Can not close connection in Memployee_swipetime.getSwipeData() !!");
			}
		}
		return tr;
	}
	
	/*
	 * ӡҧ field 红šŧҢͧѡҹ 1 ͹
	 * ҧѹҡѺӹǹ maxSwipeRec
	 */
	private void initialField(CscCalendar cs1, CscCalendar cs2) {
		CscCalendar csStart = new CscCalendar(cs1.getYYYYMMDD());
		CscCalendar csEnd = new CscCalendar(cs2.getYYYYMMDD());
		int d=1;
		while (csStart.beforeEqualsDate(csEnd)) {
			for (int i=1;i<=this.maxSwipeRec;i++) {
				String fmName = csStart.getDDMMYYYY()+"_"+i;
				FieldManager fm = this.initField("String", fmName, 20, 0, "Date");
				fm.setWorking(true);
				fm.setDefault("");
				fm.setName(fmName);
				fm.setComType("text");
				fm.setProperty("dir","rtl");
				fm.setWidth(5);
				fm.set("");
				this.hmField.put(fmName, fm);				
				this.hmSwipeData.put("col_"+d+"_"+i, "");
			}
			this.hmDateName.put("header_"+d, csStart.getDDMMYYYY());
			csStart.incDate();
			d++;
		}
	}
	
	/*
	 * ӡ set ҡŧѺ field ŧѹ
	 * ӡҧ
	 */
	public void setSwipeRecord() {
		DecimalFormat df = new DecimalFormat("0.00");
		DecimalFormat dfReport = new DecimalFormat("00.00");
		int month = 0, year = 0;
		if (this.param.containsKey("__month") && this.param.containsKey("__year")) {
			month = Integer.parseInt((String)this.param.get("__month"));
			year = Integer.parseInt((String)this.param.get("__year"));
		} else if (this.param.containsKey("MONTH") && this.param.containsKey("YEAR")) {
			month = Integer.parseInt((String)this.param.get("MONTH"));
			year = Integer.parseInt((String)this.param.get("YEAR"));			
		}
		
		CscCalendar cs1 = null;
		CscCalendar cs2 = null;
		//int month = 2;
		//int year = 2007;
		
		/**
		 * @author aGaziin
		 * for get component from print page condition [START_SWIPEDATE] [END_SWIPEDATE]
		 * 
		 */
		if (this.param.containsKey("__start_date") && this.param.containsKey("__end_date")) {
			cs1 = new CscCalendar((String) this.param.get("__start_date"));		
			cs2 = new CscCalendar((String) this.param.get("__end_date"));		
		} else if(this.param.containsKey("START_SWIPEDATE") && this.param.containsKey("END_SWIPEDATE")){
			cs1 = new CscCalendar((String) this.param.get("START_SWIPEDATE"));		
			cs2 = new CscCalendar((String) this.param.get("END_SWIPEDATE"));	 
		} else if(month!=0 && year!=0){
			cs1 = new CscCalendar("01-"+month+"-"+year);		
			cs2 = new CscCalendar(cs1.getEndDateOfMonth()+"-"+month+"-"+year);
		} else {
			cs1 = new CscCalendar();		
			cs2 = new CscCalendar();
		}
		
		int d=1;
		this.initialField(cs1, cs2); //˹Ѻ Field
		MyTreeMap tr = this.getSwipeData(cs1, cs2); //֧šٴѵ÷
		while (cs1.beforeEqualsDate(cs2)) {
			if (tr.containsKey(cs1.getDDMMYYYY())) { //Ӣ tr  set Ѻ Field ѹ
				MyTreeMap detail = (MyTreeMap) tr.get(cs1.getDDMMYYYY());
				
				int rec = 1;
				Iterator it = detail.keySet().iterator();
				while (it.hasNext() && rec<=this.maxSwipeRec) {
					Double data = (Double) detail.get(it.next());
					FieldManager fm = (FieldManager) this.hmField.get(cs1.getDDMMYYYY()+"_"+rec);
					if (!data.equals("")) {
						fm.setProperty("initvalue", df.format(data)); //纤ҡŧҷŴŧ property ͹㹡 save Ҥ ѺҷѺҨҡ˹Ҩ͵çѹ
					} else fm.setProperty("initvalue", String.valueOf(data));
					fm.set(df.format(data.doubleValue()));					
					this.hmField.put(fm.getName(), fm);
					this.hmSwipeData.put("col_"+d+"_"+rec, dfReport.format(data.doubleValue()));
					rec++;
				}
			}
			cs1.incDate();
			d++;
		}
	}
	
	public String getString(String fieldName) {
		String result = super.getString(fieldName);
		if (this.hmDateName!=null && this.hmDateName.containsKey(fieldName)) {
			result = (String) this.hmDateName.get(fieldName);
		} else if (this.hmSwipeData!=null && this.hmSwipeData.containsKey(fieldName)) {
			result = (String) this.hmSwipeData.get(fieldName);
		}
		return result;
	}
	
	public FieldManager getField(String fieldName) {
		FieldManager fm;
		if (this.hmField!=null && this.hmField.containsKey(fieldName)) {
			fm = (FieldManager) this.hmField.get(fieldName);
		} else fm = super.getField(fieldName);
		return fm;
	}
	
	public void postInqNext(){
		this.hmField.clear();
		this.hmSwipeData.clear();
		this.hmDateName.clear();
		this.setSwipeRecord();
	}

	public int search() {
		int find = super.search();
		this.hmField.clear();
		this.hmSwipeData.clear();
		this.hmDateName.clear();
		if (find == 1) {
			this.setSwipeRecord();
			//this.param.put("hmField", this.hmField.clone());
			//this.userPro.put("hmField", this.hmField.clone());
		}
		return find;
	}
	
	protected boolean preUpdateTrigger() {
		boolean result = super.preUpdateTrigger();
		try {
			//this.hmField = (HashMap) this.userPro.get((Object) "hmField");
			this.column = this.getFieldList();
			//this.setColumn("employeeid,companyid");
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("Ttimetemp");					
					
			CscCalendar cs1 = null;
			CscCalendar cs2 = null;
			//int month = 2;
			//int year = 2007;
			if (this.param.containsKey("__start_date") && this.param.containsKey("__end_date")) {
				cs1 = new CscCalendar((String) this.param.get("__start_date"));		
				cs2 = new CscCalendar((String) this.param.get("__end_date"));		
			} else {
				int month = Integer.parseInt((String) this.param.get("__month"));
				int year = Integer.parseInt((String) this.param.get("__year"));
				cs1 = new CscCalendar("01-"+month+"-"+year);		
				cs2 = new CscCalendar(cs1.getEndDateOfMonth()+"-"+month+"-"+year);
			}		
			
			while (cs1.beforeEqualsDate(cs2)) {	
				for (int i=1;i<=this.maxSwipeRec;i++) {
					rec.clearField();
					String field = cs1.getDDMMYYYY()+"_"+i;
					FieldManager fm = (FieldManager) this.hmField.get(field);
					
					if (!fm.getProperty("initvalue").equals(this.getParam("__"+field))) { //Ҥ Ф ҡѹ ӡ save					
						if (!fm.getProperty("initvalue").trim().equals("")) { //ҡ͹˹ҹդ ź
							rec.set("employeeid", this.getString("employeeid"));
							rec.set("companyid", this.getString("companyid"));
							rec.set("swipedate", cs1.getYYYYMMDD());
							rec.set("swipetime", fm.getProperty("initvalue"));
							rec.delete();
						}
						
						if (!this.getParam("__"+field).trim().equals("")) { //Ҥ (ҷ param) դӡ save ŧ ttimetemp
							rec.set("employeeid", this.getString("employeeid"));
							rec.set("companyid", this.getString("companyid"));
							rec.set("swipedate", cs1.getYYYYMMDD());
							rec.set("swipetime", this.getParam("__"+field));
							rec.save();
						}						
					}
				}
				cs1.incDate();			
			}				
		} catch (Exception ex) {
			//MyLog.error(this, ex);
		}
		return result;
	}
	
	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();
		//this.setColumn(this.column);
	}
	
	/**=====================Nuiss Code=====================
	 * @Author : Nuiss
	 * @Date : 24/03/2553
	 * @Logic : ͧҡٴѵҨҡ   Ҩҡٴ ͧǾѡҹͧ
	 * <br> Ҩҡ ҧ͡ٴ   Ҩҡ÷ HR ͡
	 */
	 public DataTable getSwipeCardEnv(UProfile userProfile,String employeeid,String startDate,String endDate){
		 DataTable dtbSwipeEnv =null;
		 if(userProfile==null || (employeeid==null ||employeeid.equals(""))){
			 return dtbSwipeEnv;
		 }
		 String sqlQuery = "SELECT sw.employeeid,sw.swipedate,sw.swipetime" +
		 		",sw.source,sw.machinno,sw.docid,f1.remark " +
		 		" FROM ttimetemp sw left outer join tforgetcard1 f1 on (sw.docid=f1.fscardid) " +
		 		" WHERE sw.employeeid='"+employeeid+"' " +
		 		" and sw.swipedate >='"+startDate+"' " +
		 		" and sw.swipedate <='"+endDate+"' ";
		 CscConnection conn = null; 
		 Statement statement =null;
		 ResultSet rs=null;
		 try{
				conn = (CscConnection) StaticProperties.myConnection.getConnection(userProfile.get("dbname"));
				statement = conn.createStatement();
 	 			rs = statement.executeQuery(sqlQuery);
 	 			dtbSwipeEnv = new DataTable(rs,true);
			}catch(Exception ex){
				System.out.print(">>>>>Error on Memployee_swipetime.getSwipecardEnv()..."+ex.toString())	;
			}finally{
				try {
					rs.close();
					if(statement!=null){
						statement.close();
					}
					conn.close();			
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}//end try
			}//end try
		 
		 return dtbSwipeEnv;
	 }//end method getSwipecardEnv
	 /**=====================Nuiss Code=====================*/
	 
}//end class Memployee_swipetime
