package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.database.FieldManager;
import com.csc.library.session.DbRecord;
import com.csc.library.session.RecordCmp;

public class Meventgrp extends RecordCmp implements DbRecord {

	public Meventgrp (){
		super ("Meventgrp","Meventgrp Table");
	}
	
	public FieldManager getField(String fieldName) {
		FieldManager fm = super.getField(fieldName);
		if (fieldName.equalsIgnoreCase("requestbefore")) {
			String data="";
			fm = this.initField("String", "", 100, 0, "");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
				fm.setDescription("ͧǧ˹");
				if (this.getInt("DATEBEFOREREQUEST")>0) {
					data = "ͧǧ˹ "+this.getInt("DATEBEFOREREQUEST")+" ѹ";
				}
			} else {
				fm.setDescription("Day Before Request");
				if (this.getInt("DATEBEFOREREQUEST")>0) {
					data = "Day Before Request "+this.getInt("DATEBEFOREREQUEST")+" Days";
				}
			}
			fm.setName("requestbefore");
			fm.set(data);
		} 
		return fm;
	}	
	
	protected boolean preUpdateTrigger() throws Exception {
		return super.preUpdateTrigger();
	}
	
	@Override
	protected boolean preInsertTrigger() throws Exception {
		return super.preInsertTrigger();
	}
	
}
