package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.database.FieldManager;
import com.csc.library.session.DbRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscCalendar;

public class Mholiday1 extends RecordCmp implements DbRecord {

	public Mholiday1 (){
		super ("Mholiday1","Mholiday1 Table");
	}
	
	public FieldManager getField(String fieldName) {
		if (fieldName.equalsIgnoreCase("fullthaidate")) {
			FieldManager fm = this.initField("String", "fullthaidate", 40, 0, "Full Thai Date");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);			
			CscCalendar c = new CscCalendar(this.getString("hdate"));
			fm.set("ѹ "+c.getLongThiDOW()+"  "+c.getDD()+" "+c.getThaiLongMonth()+" "+c.getThaiYYYY());
			return fm;
		} else return super.getField(fieldName);
	}
}
