package com.csc.library.databean;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.MyLog;

public class Mtime2_gmplan extends Mtime2 {

	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());	
			inq.initMyTable("Mtime0", "time0id='"+this.getString("time0id")+"'", "");
			inq.setColumn("time0id, companyid");
			inq.refresh();
			if (inq.next()) {
				return true;				
			} else return false;		
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return result;
	}
	
}
