package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AdjustResult;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;

/*
 * NOT USED 2008/09/15
 */
public class Tbossabsentdate0 extends RecordCmp {
	
	DbTable dbChild=null;
	
	public Tbossabsentdate0() {
		super("Tbossabsentdate0", "Tbossabsentdate0 Table");
	}
	
	private void updateReturnDocument() {
		try {
			HashMap cparam = (HashMap) this.param.clone();
			cparam.put("returnstatus","true");
			cparam.put("__wf_status","8");
			cparam.put("wf_command","delete");
			cparam.remove("__oldWF");
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TBOSSABSENTDATE0");			
			rec.setParam(cparam);
			rec.setColumn(rec.getListKey()+",wf_status");
			rec.set("absentid",(String)cparam.get("__oldDocumentID"));
			rec.set("companyid",this.userPro.get("companyid"));
			rec.setWFOff();
			rec.save();
		} catch (Exception e) {
			MyLog.error(this, e);	
		}
	}
	
	private void setEmployeeDetail(){
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Memployee", " employeeid='"+this.getString("emp_request")+"'", "");
			inq.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, " +
					"salatype, workarea,  emp_position, emp_group, companyid");	 
			inq.refresh();
			while (inq.next()) {
				this.set("bu1",inq.getString("bu1"));
				this.set("bu2",inq.getString("bu2"));
				this.set("bu3",inq.getString("bu3"));
				this.set("bu4",inq.getString("bu4"));
				this.set("bu5",inq.getString("bu5"));
				this.set("job",inq.getString("job"));
				this.set("emp_group",inq.getString("emp_group"));
				this.set("emp_position",inq.getString("emp_position"));
				this.set("branch",inq.getString("branch"));
				this.set("bossid",inq.getString("bossid"));
				this.set("salatype",inq.getString("salatype"));
				this.set("workarea",inq.getString("workarea"));			
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	protected boolean preInsertTrigger() throws Exception {
		boolean result = super.preInsertTrigger();	
		
		if (!this.getString("emp_request").equals("")) {
			this.setEmployeeDetail();
		}
		
		if (this.param.containsKey("__oldWF")) {
			if (((String) this.param.get("__oldWF")).equals("7")) {
				this.updateReturnDocument();
			}
		}
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
		
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }
		
		this.updateWFChild(this.getString("wf_status"));
		return result;
	}
	
	protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")
				|| this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
            this.setWFOff();
        }
		
		if (!this.getString("wf_status").equalsIgnoreCase("9")) {
            this.preProcessWf();
        }	
		if (this.getString("wf_status").equalsIgnoreCase("8") || 
				this.getString("wf_status").equalsIgnoreCase("7") || 
				this.getString("wf_status").equalsIgnoreCase("B")) {		
			this.setColumn(this.getListKey()+",wf_status");
			dbChild = (DbTable) this.getChild("Tbossabsentdate1");
			this.removeChild("Tbossabsentdate1");
		}		
		
		if (this.getString("wf_status").equalsIgnoreCase("4")||this.getString("wf_status").equalsIgnoreCase("6")) {
			this.setEmployeeDetail();
		} 
		
		this.updateWFChild(this.getString("wf_status"));
		return result;
	}

	protected void postInsertTrigger() throws Exception {		
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}
		super.postInsertTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord();
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
	}

	protected void postUpdateTrigger() throws Exception {	
		if (this.param.containsKey("__wfcmd")) {
			if (this.param.get("__wfcmd").equals("true")) {
				this.setWFOn();			
			} else this.setWFOff();
		}		
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.delDataAdjTime0();
			this.genRecord();			
		} else if (this.getString("wf_status").equalsIgnoreCase("8") || this.getString("wf_status").equalsIgnoreCase("9")) {
			this.delDataAdjTime0();
		}
	}
	
	protected void postDeleteTrigger() throws Exception {		
		super.postDeleteTrigger();
		this.delDataAdjTime0();
	}
	
	private void updateWFChild(String wf) {
		try {
			if (this.dbChild != null) {
				this.putChild(this.dbChild);
			}
			if (this.getChild("Tbossabsentdate1")!=null) {
				DbTable db = (DbTable) this.getChild("Tbossabsentdate1");
				db.first();
				do{				
					DbRecord rec = (DbRecord) db.getCurrentRecordManager();				
					rec.set("WF_STATUS",wf);
					db.next();				
				} while (!db.eof());		
				//db.save();
			} else {			
				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.setParam(this.param);
				inq.setSchemaName(this.userPro.getSchemaName());
				inq.initMyTable("Tbossabsentdate1","", "");
				inq.setColumn("ABSENTID, COMPANYID, LINE_NO, WF_STATUS");			
				this.putChild(inq);
				this.refreshChild();
				DbInquiry inqChild = (DbInquiry) this.getChild("Tbossabsentdate1");
				inqChild.refresh();
				while (inqChild.next()) {
					DbRecord rec = inqChild.getCurrentDbRecord().cloneRecord(true);					
					rec.set("wf_status",wf);
					rec.save();
				}
				this.removeChild("Tbossabsentdate1");
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	private void delDataAdjTime0() {
		try {			
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Tadjtime0","docid='"+this.getString("absentid")+"' and doctype='BA'", "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}

	private TimeZone getDocTimeZone(Shift shCheck, String date, float startTime, float endTime) {
		TimeZone tz = new TimeZone();		
		CscCalendar cs1 = new CscCalendar(date);
		CscCalendar cs2 = new CscCalendar(date);
		if (startTime < shCheck.get_c_dt_in().getCSCTime()) {
			cs1.incDate();
		}
		if (endTime < shCheck.get_c_dt_in().getCSCTime()) {
			cs2.incDate();
		}
		try {
			cs1.setCSCTime(startTime);
			cs2.setCSCTime(endTime);
		} catch (Exception e) {
			MyLog.error(this, e);	
		}
		tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
		tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
		MyLog.debug(this, ">>> RESULT TIMEZONE="+tz);
		return tz;
	}

	private void genRecord() {
		try {
			DbTable db;
			
			if (this.dbChild != null) {
				this.putChild(this.dbChild);
			}
			if (this.getChild("Tbossabsentdate1")!=null) {
				db = (DbTable) this.getChild("Tbossabsentdate1");
				db.first();
			} else {			
				db = new InitialTable(this.userPro).getDbTable("Tbossabsentdate1");
				db.setColumn("*");
				this.putChild(db);
				this.refreshChild("Tbossabsentdate1");
				db.first();
			}
			
			//ӡ Adjust šҷк÷Ѵ child
			do {
				DbRecord recChild = db.getCurrentRecordManager();
				
				DbInquiry inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
				inqEmp.setParam(this.param);
				inqEmp.setSchemaName(this.userPro.getSchemaName());
				inqEmp.initMyTable("Memployee", "employeeid='" + recChild.getString("employeeid") + "'", "");
				inqEmp.setColumn("employeeid, time0, companyid, status, startdate, resigndate");
				inqEmp.refresh();
				while (inqEmp.next()) {
					Mtime0 recTime = (Mtime0) new InitialRecord(this.userPro).getDbRecord("Mtime0");
					recTime.set("time0id", inqEmp.getString("time0"));
					recTime.set("companyid", this.userPro.get("companyid"));
					recTime.search();

					CscCalendar cs1 = new CscCalendar(recChild.getString("start_date"));
					cs1.decDate();
					CscCalendar cs2 = new CscCalendar(recChild.getString("end_date"));
					cs2.incDate();
					
					recTime.setEmpRec(inqEmp.getCurrentDbRecord().cloneRecord(false));
					WorkingShift ws = recTime.genWorkingShift(new CscCalendar(cs1.getYYYYMMDD()), 
							new CscCalendar(cs2.getYYYYMMDD()));
					
					if (!ws.isEmpty()) {					
						ws.setUProfile(this.userPro);
						ws.setEmployeeid(inqEmp.getString("employeeid"));
						ws.adjustLeave();
						ws.overlapChecking();
						ws.createLink();
						
						WorkingShift wsCheck = (WorkingShift) ws.clone();
						Vector vAdjust = new Vector();
						
						//Check Shift is Null;
						Shift shCheck=null;
						CscCalendar cscStart=new CscCalendar(recChild.getString("start_date"));
						CscCalendar cscEnd=new CscCalendar(recChild.getString("end_date"));					
						while (cscEnd.afterEquals(cscStart)) {
							Iterator itDS = (Iterator) wsCheck.keySet().iterator();	
							if (itDS.hasNext()) {
								DayShift dsCheck = (DayShift) wsCheck.get(cscStart.getYYYYMMDD());
								if (!dsCheck.isEmpty()) {
									Iterator itSH = (Iterator) dsCheck.keySet().iterator();
									if (itSH.hasNext()) {
										shCheck = (Shift) dsCheck.get((String) itSH.next());
									}
								}
							}					
							
							try {
								vAdjust = ws.genSubShiftTrans(this.getDocTimeZone(shCheck, cscStart.getDDMMYYYY(), recChild.getFloat("start_time"), recChild.getFloat("end_time")));
								MyLog.debug(this, "\n\n<<<<<<<<<<<< Display Data To Save >>>>>>>>>>>>>");
								Iterator it = vAdjust.iterator();			
								while (it.hasNext()) {
									AdjustResult result = (AdjustResult) it.next();	
									
									if (!result.getEventGroup().substring(0,1).equalsIgnoreCase("O")) {
										MyLog.debug(this, result.toString());
										DbRecord rec = new InitialRecord(this.userPro).getDbRecord("TadjTime0");
										rec.set("COMPANYID", this.getString("companyid"));
										rec.set("DOCID", this.getString("absentid"));
										rec.set("DOCTYPE", "BA");
										rec.set("DT_BG", result.get_DT_BG().getYYYYMMDD());
										rec.set("TM_BG", result.get_DT_BG().getCSCTime());
										rec.set("DT_EN", result.get_DT_EN().getYYYYMMDD());
										rec.set("TM_EN", result.get_DT_EN().getCSCTime());
										rec.set("UPDTYPE", result.getType());
										rec.set("DOCDATE", result.getAdjDate()	.getYYYYMMDD());
										rec.set("EMPLOYEEID", recChild.getString("employeeid"));
										rec.set("TIME0ID", result.getTimeCode());
										if (result.getType().equalsIgnoreCase("A")) {
											rec.set("EVENTGRP", recChild.getString("type_absent"));
										} else rec.set("EVENTGRP", "T");
										rec.set("OLDTIME0ID", "");
										rec.set("OLDEVENTGRP", "");
										rec.set("LV_TY", this.getString("type_absent"));
										rec.set("LV", this.getHourDAdjust(result.getTimeCode(), rec));
										rec.set("TR_TYPE", result.getEventGroup());
										rec.set("PRIORITY", "1");	
										rec.save();
									}
								}
							} catch (Exception e1) {
								MyLog.error(this, e1);								
							}						
							cscStart.incDate();						
						}
					}
				}
				
				db.next();
			} while (!db.eof());
				
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private float getHourDAdjust(String timeCode, DbRecord recChild) {
		float hour = 0; 
		try {			
			float break_hour = 0;
			CscCalendar cs1=null, cs2=null;
			CscCalendar cs = new CscCalendar(recChild.getString("dt_bg"));
			String filter = "time0id='"+timeCode+"' and dayweekid='"+cs.getCSCDOW()+"'";
			DbInquiry inqTime1 = new InitialInquiry(this.userPro).getDbInquiry();
			inqTime1.setParam(this.param);
			inqTime1.setSchemaName(this.userPro.getSchemaName());
			inqTime1.initMyTable("Mtime1", filter, "");
			inqTime1.setColumn("time0id, dayweekid, hour_d, companyid, timein1, timein2, timeout1, timeout2");
			inqTime1.refresh();
			if (inqTime1.next()) {
				DbRecord rec = inqTime1.getCurrentDbRecord();				
				//Break Hour
				cs1 = new CscCalendar(recChild.getString("dt_bg"));
				cs1.setCSCTime(rec.getFloat("timeout1"));
				cs2 = new CscCalendar(recChild.getString("dt_en"));
				cs2.setCSCTime(rec.getFloat("timein2"));
				if (rec.getFloat("timein2") < rec.getFloat("timeout1")) {
					cs2.incDate();
				}
				//MyLog.debug(this, ">>> BREAK HOUR >>> cs1="+cs1.getTimestamp()+" >>> cs2="+cs2.getTimestamp());
				break_hour = cs2.subForHour(cs1);
				//Working Hour
				CscCalendar cs3 = new CscCalendar(recChild.getString("dt_bg"));
				cs3.setCSCTime(rec.getFloat("timein1"));
				CscCalendar cs4 = new CscCalendar(recChild.getString("dt_en"));
				cs4.setCSCTime(rec.getFloat("timeout2"));
				if (rec.getFloat("timeout2") < rec.getFloat("timein1")) {
					cs4.incDate();
				}
				//MyLog.debug(this, ">>> WORKING HOUR >>> cs3="+cs3.getTimestamp()+" >>> cs4="+cs4.getTimestamp());
				//MyLog.debug(this, ">>> WORKING >>> "+cs4.subForHour(cs3));
				//MyLog.debug(this, ">>> BREAK >>> "+break_hour);
				//hour = cs4.subForHour(cs3) - break_hour;				
				CscTime c = new CscTime(cs4.subForHour(cs3));
				c.sub(break_hour);
				hour = c.getFloat();				
			}
			
			CscCalendar c_dt_in = new CscCalendar(recChild.getString("dt_bg"));
			c_dt_in.setCSCTime(recChild.getFloat("tm_bg"));
			CscCalendar c_dt_out = new CscCalendar(recChild.getString("dt_en"));
			c_dt_out.setCSCTime(recChild.getFloat("tm_en"));
			float hourCom = c_dt_out.subForHour(c_dt_in);
			
			if (cs1!=null&&cs2!=null) {
				if (cs1.afterEquals(c_dt_in)&&cs2.beforeEquals(c_dt_out)) {
					CscTime c = new CscTime(hourCom);
					c.sub(break_hour);
					hourCom = c.getFloat();
				}
			}		
			
			if (hourCom<hour) {
				hour=hourCom;
			}
			
 		} catch (Exception e) {
			MyLog.error(this, e);

		} 		
		return hour;
	}

	//	 Day Type 繡ҷѺ - 
	private String getDayType() {
		String result="";
		try {			
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Meventgrp", "EVENTGRPID='"+this.getString("TYPE_ABSENT")+"'", "");
			inq.setColumn("eventgrpid, companyid, day_type");
			inq.refresh();
			while (inq.next()) {
				result = inq.getCurrentDbRecord().getString("day_type");
			}
		} catch (RemoteException e) {
			MyLog.error(this, e);
		}
		return result;
	}
}
