package com.csc.library.databean;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;


public class Ttimetemp_import extends Ttimetemp{
	
	private DbInquiry inqEmp  = null;
	private DbInquiry inqEmpCardTmp  = null;
	private String swipeCard ="";
	
	
	public boolean set (String field, String data) {
		boolean result = super.set(field, data);
		if (field.equalsIgnoreCase("SWIPECARDID")) {
			swipeCard = data;
			return true;
		}
		return result;
	}
	
	public void setSwipeCard2TimeTmp() {
		if(!swipeCard.equals("")){
			try {
				/** Retrieve */
				if (inqEmp == null){
					inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
					inqEmp.setSchemaName(this.userPro.getSchemaName());
					inqEmp.setParam(this.param);
					inqEmp.initMyTable("memployee", "", "");
					inqEmp.setColumn("employeeid,swipecardid,companyid");
				}//end if 
				
				inqEmp.setFilter("swipecardid='" + swipeCard + "'");
				inqEmp.refresh();

				if (inqEmp.next()) {
					this.set("employeeid", inqEmp.getString("employeeid"));
				}else{
					if (inqEmpCardTmp == null){
						inqEmpCardTmp = new InitialInquiry(this.userPro).getDbInquiry();
						inqEmpCardTmp.setSchemaName(this.userPro.getSchemaName());
						inqEmpCardTmp.setParam(this.param);
						inqEmpCardTmp.initMyTable("mempl_cardtemp1", "", "");
						inqEmpCardTmp.setColumn("swipecardid,employeeid,companyid,dateid");
					}//end if 
					
					CscCalendar  _swipedate = new CscCalendar(this.getString("swipedate"));
					
					inqEmpCardTmp.setFilter("swipecardid='" + swipeCard + "'"
							+" and dateid='"+ _swipedate.getYYYYMMDD() +"'");
					
					inqEmpCardTmp.refresh();
					
					if (inqEmpCardTmp.next()) {
						this.set("employeeid", inqEmpCardTmp.getString("employeeid"));
					}//end if 
					
				}// end if
			} catch (Exception ex) {
				
			}// end try
		}//end if 
		
  		//return result;
	}//end method 
	
    protected boolean preInsertTrigger() throws Exception {
    	boolean result = super.preInsertTrigger();
		 this.setSwipeCard2TimeTmp();
		return result;
	}
    
    protected boolean preUpdateTrigger() throws Exception {
		boolean result = super.preUpdateTrigger();	
		this.setSwipeCard2TimeTmp();
		return result;
	}
}
