package com.csc.library.dwr;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

import java.text.DecimalFormat;

import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Tabsentdate0;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.utilities.CscCalendar;

public class Tabsentdate0_dwr extends DWR_base {
	
	DecimalFormat df = new DecimalFormat("0.00");

	public Tabsentdate0_dwr() { }
	
	public String getDWRData(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String emp = this.chkEmptyData(str, 0);
		String absent_date = this.chkEmptyData(str, 1);
	
		String chk1 = this.chkEmptyData(str, 2);
		String lineno1 = this.chkEmptyData(str, 3);
		String absent_type1 = this.chkEmptyData(str, 4);
		String start_time1 = this.chkEmptyData(str, 5);
		String end_time1 = this.chkEmptyData(str, 6);
		
		String chk2 = this.chkEmptyData(str, 7);
		String lineno2 = this.chkEmptyData(str, 8);
		String absent_type2 = this.chkEmptyData(str, 9);
		String start_time2 = this.chkEmptyData(str, 10);
		String end_time2 = this.chkEmptyData(str, 11);
		
		String chk3 = this.chkEmptyData(str, 12);
		String lineno3 = this.chkEmptyData(str, 13);
		String absent_type3 = this.chkEmptyData(str, 14);
		String start_time3 = this.chkEmptyData(str, 15);
		String end_time3 = this.chkEmptyData(str, 16);
		
		String chk4 = this.chkEmptyData(str, 17);
		String lineno4 = this.chkEmptyData(str, 18);
		String absent_type4 = this.chkEmptyData(str, 19);
		String start_time4 = this.chkEmptyData(str, 20);
		String end_time4 = this.chkEmptyData(str, 21);
		
		String chk5 = this.chkEmptyData(str, 22);
		String lineno5 = this.chkEmptyData(str, 23);
		String absent_type5 = this.chkEmptyData(str, 24);
		String start_time5 = this.chkEmptyData(str, 25);
		String end_time5 = this.chkEmptyData(str, 26);
		
		
		
			
		try {
			DbTable dbLeave = new InitialTable(this.up).getDbTable("TABSENTDATE1");
			int loop=1;			
			if (chk1.equals("1")) {
				DbRecord recLeave = dbLeave.getNewRecord(); 
				recLeave.set("ABSENTID","0");
				recLeave.set("COMPANYID", this.up.get("companyid"));
				recLeave.set("LINE_NO", loop);
				recLeave.set("START_TIME", start_time1);
				recLeave.set("END_TIME", end_time1);
				recLeave.set("TYPE_ABSENT", absent_type1);
				dbLeave.putNewRecord(recLeave);
				loop++;
			}
			
			if (chk2.equals("1")) {
				DbRecord recLeave = dbLeave.getNewRecord(); 
				recLeave.set("ABSENTID","0");
				recLeave.set("COMPANYID", this.up.get("companyid"));
				recLeave.set("LINE_NO", loop);
				recLeave.set("START_TIME", start_time2);
				recLeave.set("END_TIME", end_time2);
				recLeave.set("TYPE_ABSENT", absent_type2);
				dbLeave.putNewRecord(recLeave);
				loop++;
			}
			
			if (chk3.equals("1")) {
				DbRecord recLeave = dbLeave.getNewRecord(); 
				recLeave.set("ABSENTID","0");
				recLeave.set("COMPANYID", this.up.get("companyid"));
				recLeave.set("LINE_NO", loop);
				recLeave.set("START_TIME", start_time3);
				recLeave.set("END_TIME", end_time3);
				recLeave.set("TYPE_ABSENT", absent_type3);
				dbLeave.putNewRecord(recLeave);
				loop++;
			}
			
			if (chk4.equals("1")) {
				DbRecord recLeave = dbLeave.getNewRecord(); 
				recLeave.set("ABSENTID","0");
				recLeave.set("COMPANYID", this.up.get("companyid"));
				recLeave.set("LINE_NO", loop);
				recLeave.set("START_TIME", start_time4);
				recLeave.set("END_TIME", end_time4);
				recLeave.set("TYPE_ABSENT", absent_type4);
				dbLeave.putNewRecord(recLeave);
				loop++;
			}
			
			if (chk5.equals("1")) {
				DbRecord recLeave = dbLeave.getNewRecord(); 
				recLeave.set("ABSENTID","0");
				recLeave.set("COMPANYID", this.up.get("companyid"));
				recLeave.set("LINE_NO", loop);
				recLeave.set("START_TIME", start_time5);
				recLeave.set("END_TIME", end_time5);
				recLeave.set("TYPE_ABSENT", absent_type5);
				dbLeave.putNewRecord(recLeave);
				loop++;
			}
			 
			 
			Tabsentdate0 rec = (Tabsentdate0) new InitialRecord(up).getDbRecord("TABSENTDATE0");
			rec.set("ABSENTID","0");			 
			rec.set("EMPLOYEEID", emp);
			rec.set("ABSENT_DATE", absent_date);
			rec.set("COMPANYID", this.up.get("companyid"));
			rec.putChild(dbLeave);
			MyTreeMap hm = rec.getDWRData();
			MyLog.debug(this, "===="+hm);
			
			data += "<table cellspacing='1' cellpadding='1' width='100%' align='center' border='0'>";		
			data += "<tr align='center' bgcolor='#0099cc'>";
            if (((String)this.up.get("lang")).equalsIgnoreCase("ENG")) {
                data += "<td class='txt_normal'><strong>Date&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Day&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Working_Time&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Leave Type&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Start Time&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>End Time&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>Time Total&nbsp;</strong></td>";
            } else {
                data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ҷӧҹ&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>ش&nbsp;</strong></td>";
                data += "<td class='txt_normal'><strong>&nbsp;</strong></td>";
            }
			data += "</tr>";
			
			String lv_desc="";
			String time_desc = "";
			int hm_size = hm.size();
			int i=1;
			while (i<=hm_size) {
				MyHashMap hmData = (MyHashMap) hm.get(String.valueOf(i));
					
				DbInquiry inqTime = this.getInquiry("Mtime0", "*", "time0id='"+hmData.getString("TIME0ID")+"'", "", this.up);
				if (inqTime.next()) {
					time_desc = inqTime.getString("tdesc");
				}
				
				DbInquiry inqEvent = this.getInquiry("Meventgrp", "*", "eventgrpid='"+hmData.getString("EVENTGRP")+"'", "", this.up);
				if (inqEvent.next()) {
					lv_desc = inqEvent.getString("tdesc");
				}
				
				data += "<tr align='center'>";
				CscCalendar cs = new CscCalendar(hmData.getString("DT_BG"));
				data += "<td class='desc'>"+cs.getDDMMYYYY()+"</td>";
				data += "<td class='desc'>"+cs.getDOWTHI()+"</td>";
				data += "<td class='desc'>"+hmData.getString("TIME0ID")+" : "+time_desc+"</td>";
				data += "<td class='desc'>"+hmData.getString("EVENTGRP")+" : "+lv_desc+"</td>";
				data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("TM_BG")))+"</td>";
				data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("TM_EN")))+"</td>";				
				data += "<td class='desc'>"+df.format(Double.parseDouble(hmData.getString("LV")))+"</td>";		
				data += "</tr>";
				i++;
			}					
			data += "</table>";	
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		
		data += this.getBelowFrame();
		return data;
	}
}
