package com.csc.library.process;

import java.text.DecimalFormat;

import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class GPFSwipeProp {
	private String id ;
	private String TrDate ;
	private String TrTime ;
	private String CardNo ;
	private String UnitNo ;
	private String TrCode ;
 
	public void setId(String id){
		this.id = id;
	}
	
	public void setTrDate(String TrDate){
		this.TrDate = TrDate;
	}

	public void setTrTime(String TrTime){
		this.TrTime = TrTime;
	}

	public void setCardNo(String CardNo){
		this.CardNo = CardNo;
	}

	public void setUnitNo(String UnitNo){
		this.UnitNo = UnitNo;
	}
	
	public void setTrCode(String TrCode){
		this.TrCode = TrCode;
	}
	
	public String getId(){
		return this.id;
	}
	
	public String getTrDate(){
		CscCalendar cs = null;
		try {
			 cs = new CscCalendar(this.TrDate);
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return cs.getYYYYMMDD();
	}
	
	public String getTrTime(){
		DecimalFormat df = new DecimalFormat("00");
		StringBuffer tr = new StringBuffer();
		try {
			String tmp[] = this.TrTime.split(":");
			tr.append(df.format(Double.parseDouble(tmp[0]))).append(".");
			tr.append(df.format(Double.parseDouble(tmp[1])));
			
		}catch(Exception e){
			MyLog.error(this,e);
			tr.append("00:00:00");
		}
		return tr.toString();
	}
	
	public String getCardNo(){
		return this.CardNo;
	}
	
	public String getUnitNo(){
		return this.UnitNo;
	}
	
	public String getTrCode(){
		return this.TrCode;
	}

}
