package com.csc.library.process;

import java.util.Vector;

import org.jdom.Element;

import com.csc.library.cscimport.MyImport;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;

/*
 * class 㹡 import 
 */
public class ImportData extends MyProcess {
		
	public Vector getProcessList() {
		Vector v = new Vector();
		v.addElement("All");
		return v;
	}
		
	public void process() throws Exception {
		Vector vt = this.processList;
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
			String id = (String) vt.elementAt(i);
			MyLog.debug(this, "***** IMPORT DATA PROCESS *****");
			MyLog.debug(this, ">>data="+this.data);
			
			try {
				InitialEnvironment en = new InitialEnvironment("GLOBAL");
				String xmlPath = en.getValue("import-dir"); //path  xml ˹ format 㹡 import
				String importPath = en.getValue("dirimport-dir"); //path  import 
				String errorPath = en.getValue("dirimport_error-dir");
				String fileName = (String) this.data.get("fileName"); // file ͧ import
				String xmlName = (String) this.data.get("xmlName"); // xml ˹ٻẺͧ import
				
				ReadXml r = new ReadXml(xmlPath +"XML/"+ xmlName); //ӡҹ xml ٻẺͧ import  tableName  importGroup 
				Element root = r.getRootElement();
				String tableName  = root.getAttributeValue("table"); // table ͧùӢ仺ѹ֡ŧ
				String importGroup  = root.getAttributeValue("group"); //ͧ field ͧúѹ֡
				
				DbRecord rec = new InitialRecord(this.upf).getDbRecord(tableName);
				rec.setGroupfield(importGroup);
				MyImport myImp = new MyImport(rec, importPath + fileName, xmlPath +"XML/"+ xmlName);
				myImp.process(); //ӡ import
				StaticProperties.serverManager.writeFileResultProcess(this.processId, myImp.getSummaryResult());
				MyLog.debug(this, ">>>>>>>>>>>>>>> Import Data Result : Successful");
			} catch (Exception e) {
				MyLog.error(this, e);					
				MyLog.debug(this, ">>>>>>>>>>>>>>> Import Data Result : ERROR Not Successful !!!!");
			}	
			
			this.alive("Process Data: "+id+" ["+i+" of "+vt.size()+"]");
		}
		this.setMessage("Successful of ImportData : "+vt.size());
		this.setFullMessage("Successful of ImportData : "+vt.size()+"\n");
	}
	
}
