package com.csc.library.process;

import java.util.Vector;

import com.csc.library.databean.Memployee_working_summary;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

/*
 * class 㹡äӹǳš÷ӧҹ š Ш͹ ͹͡§ҹͧ KKB
 * ͡§ҹöǴ駢
 */
public class ProcessWorkingTimeReport extends ProcessTimeBase {
	
	private DbRecord empRec = null;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();
			if (!this.getParamValue("filterProcess").equals("")) {
				DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
				inq.setParam(this.data);
				inq.setSchemaName(this.upf.getSchemaName());
				inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");
				inq.setColumn("employeeid, time0, runno, bossid, bu1, bu2, bu3, bu4, bu5, " +
						"salatype,workarea,emp_level, companyid, startdate, resigndate, status, vacation0, vacation1");
				inq.setFatchAll(true);
				inq.refresh();
				while (inq.next()) {
					v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	}
	
	public void process() throws Exception {		
		this.setParamData();
		this.data.put("processDate", this.getParamValue("startDate"));
		CscCalendar c = new CscCalendar(this.getParamValue("startDate"));
		
		Vector vt = this.processList;
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
			String id = (String) vt.elementAt(i);
			if (this.empRec==null) {
				this.empRec = new InitialRecord(this.upf).getDbRecord("Memployee_working_summary");
				this.empRec.setColumn("employeeid, time0, bossid, bu1, bu2, bu3, bu4, bu5, " +
						"salatype,workarea, branch, emp_group, emp_position, startdate, resigndate");
			}
			this.empRec.clearField();
			this.empRec.setParam(this.data);
			this.empRec.set("employeeid", (String) vt.elementAt(i));
			this.empRec.set("companyid", (String) this.upf.get("companyid"));
        	int result = this.empRec.search();
        	
        	if (result==1) { //  ѧ
        		CscCalendar startDate = new CscCalendar(empRec.getString("startdate")); //ѹҹ
        		CscCalendar resignDate = new CscCalendar(empRec.getString("resigndate")); //ѹ͡
        		resignDate.decDate();
        		if (c.after(startDate) && c.before(resignDate)) { //Ҫǧѹż ͧ㹪ǧѧ͡
	        		Memployee_working_summary recSummary = (Memployee_working_summary) this.empRec;
	        		recSummary.calculate(); //¡ class 㹡äӹǳ
        		}
        	}
			this.alive("Process EmployeeID : "+id+" ["+i+" of "+vt.size()+"]");
		}
		this.setMessage("Successful of ProcessWorkingTimeReport : "+vt.size());
		this.setFullMessage("Successful of ProcessWorkingTimeReport : "+vt.size()+"\n");	
	}
}
