package com.csc.library.process;

import java.sql.ResultSet;
import java.sql.Statement;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

/*
 * NOT USED 2008/09/01
 */
public class ReCalculateDocument extends ProcessTimeBase {
	
	DbInquiry inqTABSENT_NSTDA = null;
	DbInquiry inqTABSENT_M_DATE = null;
	DbInquiry inqTABSENTDATE0 = null;
	DbTable dbTABSENTDATE1 = null;
	DbInquiry inqTOT = null;
	DbInquiry inqTOT_M_DATE0 = null;
	DbInquiry inqTOT_M_DATE1 = null;
	DbTable dbTOT_M_DATE1 = null;
	DbInquiry inqTOT0 = null;
	DbInquiry inqTOT1 = null;
	DbTable dbTOT1 = null;
	DbInquiry inqTCHSHIFT = null;
	DbInquiry inqTCHANGESHIFT_NSTDA = null;
	DbInquiry inqTEXCHANGESHIFT = null;
	DbInquiry inqTEXCHANGESHIFT_NSTDA = null;
	
	CscCalendar cscStart = null;
	CscCalendar cscEnd = null;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");			
			inq.setColumn("employeeid, runno, emp_position, emp_group, branch, job, bossid, emp_level," +
				"bu1, bu2, bu3, bu4, bu5, costcenter, salatype, currency, salary, emp_every, time0, companyid," + 
				"status, startdate, resigndate, workarea, emp_type");	
			inq.setFatchAll(true);
			inq.refresh();
			while (inq.next()) {
				v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	} 
	
	public void process() throws Exception {
		this.setParamData();
		this.cscStart = new CscCalendar(this.getParamValue("startDate"));
		this.cscEnd = new CscCalendar(this.getParamValue("endDate"));
					
		//Vector vt = this.getProcessList();
		Vector vt = this.processList;
		String errorProcess = "";
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
			String id = (String) vt.elementAt(i);
			try {
				DbInquiry inqEmp = new InitialInquiry(this.upf).getDbInquiry();
				inqEmp.setParam(this.data);
				inqEmp.setSchemaName(this.upf.getSchemaName());
				inqEmp.initMyTable("MEMPLOYEE","employeeid='"+(String) vt.elementAt(i)+"'","");
				inqEmp.setColumn("employeeid, companyid, status, emp_type, startdate, firsthiredate, status, vacation0, vacation1");
				inqEmp.refresh();
				if (inqEmp.next()) {
	        		MyLog.debug(this, "-----------> Employeeid : " + inqEmp.getString("employeeid"));
	        		MyLog.debug(this, "-----------> Start Date : " + this.cscStart.getYYYYMMDD());
	        		MyLog.debug(this, "-----------> End Date : " + this.cscEnd.getYYYYMMDD());
	        		DbRecord empRec = inqEmp.getCurrentDbRecord().cloneRecord(true);	  
	        		
	        		//============================Nuiss Code ======================
	        		String documentList = this.getParamData("processDocument");
	        		String[] docList = documentList.split(",");
	        		for(int ii=0;ii<docList.length;ii++) {
	        			this.processDocument(empRec.getString("employeeid"), docList[ii]);
	        		}//end for ii
	        		
	        		//ͧ
	        		/*
	        		StringTokenizer str = new StringTokenizer(this.getParamData("processDocument"), ",");
	        		while (str.hasMoreTokens()) {
	        			this.processDocument(empRec.getString("employeeid"), str.nextToken());
	        		}*/
	        		//============================Nuiss Code ======================
				}
			} catch (Exception e) {
				MyLog.error(this, e);
				errorProcess += id+",";
			}
			this.alive("Process EmployeeID : "+id+" ["+i+" of "+vt.size()+"]");
		} //End for
		this.setMessage("Successful of ReCalculateDocument : "+vt.size());
		this.setFullMessage("Successful of ReCalculateDocument : "+vt.size()+"\n"+				
				"Error Process : "+errorProcess);
	}
	
	private void processDocument(String employeeid, String documentType) {
		if (documentType.equals("0")) { //Ңͧ Ƿ
			this.cal_TABSENT_NSTDA(employeeid);
		} else if (documentType.equals("1")) { //ѹ
			this.cal_TABSENT_M_DATE(employeeid);
		} else if (documentType.equals("2")) { //ѹ
			this.cal_TABSENTDATE0(employeeid);
		} else if (documentType.equals("3")) { //㺢ͷ
			this.cal_TOT(employeeid);
		} else if (documentType.equals("4")) { //㺢ͷѹ
			this.cal_TOT_M_DATE0(employeeid);
		} else if (documentType.equals("5")) { //㺢ͷ¤
			this.cal_TOT0(employeeid);
		} else if (documentType.equals("6")) { //¹ Ƿ
			this.cal_TCHANGESHIFT_NSTDA(employeeid);
		} else if (documentType.equals("7")) { //¹
			this.cal_TCHSHIFT(employeeid);
		} else if (documentType.equals("8")) { //š Ƿ
			this.cal_TEXCHANGESHIFT_NSTDA(employeeid);
		} else if (documentType.equals("9")) { //š 
			this.cal_TEXCHANGESHIFT(employeeid);
		}
	}
	
	private void cal_TABSENT_NSTDA(String employeeid) {
		try {
			if (this.inqTABSENT_NSTDA == null) {
	 			this.inqTABSENT_NSTDA = new InitialInquiry(this.upf).getDbInquiry();
	 			this.inqTABSENT_NSTDA.setParam(this.data);
	 			this.inqTABSENT_NSTDA.setSchemaName(this.upf.getSchemaName());
	 			this.inqTABSENT_NSTDA.initMyTable("TABSENT_NSTDA","","");
	 			this.inqTABSENT_NSTDA.setColumn("*");
			}
			this.inqTABSENT_NSTDA.setFilter("employeeid='"+employeeid+"' and " +
					"(start_date between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqTABSENT_NSTDA.refresh();
			while (this.inqTABSENT_NSTDA.next()) {
        		MyLog.debug(this, "-----------> TABSENT_NSTDA : "
        				+ " absentid=" + this.inqTABSENT_NSTDA.getString("absentid") 
        				+ " employeeid=" + this.inqTABSENT_NSTDA.getString("employeeid"));
        		DbRecord rec = this.inqTABSENT_NSTDA.getCurrentDbRecord().cloneRecord(true);	       
        		rec.save();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}

	private void cal_TABSENT_M_DATE(String employeeid) {
		try {
			if (this.inqTABSENT_M_DATE == null) {
	 			this.inqTABSENT_M_DATE = new InitialInquiry(this.upf).getDbInquiry();
	 			this.inqTABSENT_M_DATE.setParam(this.data);
	 			this.inqTABSENT_M_DATE.setSchemaName(this.upf.getSchemaName());
	 			this.inqTABSENT_M_DATE.initMyTable("TABSENT_M_DATE","","");
	 			this.inqTABSENT_M_DATE.setColumn("*");
			}
			this.inqTABSENT_M_DATE.setFilter("employeeid='"+employeeid+"' and " +
					"(start_date between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqTABSENT_M_DATE.refresh();
			while (this.inqTABSENT_M_DATE.next()) {
        		MyLog.debug(this, "-----------> inqTABSENT_M_DATE : "
        				+ " absentid=" + this.inqTABSENT_M_DATE.getString("absentid") 
        				+ " employeeid=" + this.inqTABSENT_M_DATE.getString("employeeid"));
        		DbRecord rec = this.inqTABSENT_M_DATE.getCurrentDbRecord().cloneRecord(true);	       
        		rec.save();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private void cal_TABSENTDATE0(String employeeid) {
		try {
			if (this.inqTABSENTDATE0 == null) {
	 			this.inqTABSENTDATE0 = new InitialInquiry(this.upf).getDbInquiry();
	 			this.inqTABSENTDATE0.setParam(this.data);
	 			this.inqTABSENTDATE0.setSchemaName(this.upf.getSchemaName());
	 			this.inqTABSENTDATE0.initMyTable("TABSENTDATE0","","");
	 			this.inqTABSENTDATE0.setColumn("*");
	 			
	 			this.dbTABSENTDATE1 = new InitialTable(this.upf).getDbTable("TABSENTDATE1");
	 			this.dbTABSENTDATE1.setColumn("*");	 			
			}
			this.inqTABSENTDATE0.putChild(this.dbTABSENTDATE1);
			this.inqTABSENTDATE0.setFilter("employeeid='"+employeeid+"' and " +
					"(absent_date between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqTABSENTDATE0.refresh();
			while (this.inqTABSENTDATE0.next()) {
        		MyLog.debug(this, "-----------> inqTABSENTDATE0 : "
        				+ " absentid=" + this.inqTABSENTDATE0.getString("absentid") 
        				+ " employeeid=" + this.inqTABSENTDATE0.getString("employeeid"));
        		DbRecord rec = this.inqTABSENTDATE0.getCurrentDbRecord().cloneRecord(true);	       
        		rec.save();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private void cal_TOT(String employeeid) {
		try {
			if (this.inqTOT == null) {
	 			this.inqTOT = new InitialInquiry(this.upf).getDbInquiry();
	 			this.inqTOT.setParam(this.data);
	 			this.inqTOT.setSchemaName(this.upf.getSchemaName());
	 			this.inqTOT.initMyTable("TOT","","");
	 			this.inqTOT.setColumn("*");
			}
			this.inqTOT.setFilter("employeeid='"+employeeid+"' and " +
					"(start_date between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqTOT.refresh();
			while (this.inqTOT.next()) {
        		MyLog.debug(this, "-----------> inqTOT : "
        				+ " otid=" + this.inqTOT.getString("otid") 
        				+ " employeeid=" + this.inqTOT.getString("employeeid"));
        		DbRecord rec = this.inqTOT.getCurrentDbRecord().cloneRecord(true);	       
        		rec.save();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private void cal_TOT0(String employeeid) {
		try {
			try {
				/* ֧ҡ tot1 ҧͧҡ㹵ҧ´ 㺢ͷ ʾѡҹ ѹͷ 㹹繵ͧҧ link ҧ tot0 */
				String sql = "select distinct(otid) from tot1 where (start_date between '"+cscStart.getYYYYMMDD()+"' and '"+cscEnd.getYYYYMMDD()+"') " +
						"and employeeid='"+employeeid+"'";
				
				Vector loop = new Vector();
				loop = this.getData(sql, "otid");	/* ֧¡͡÷ͧѹ֡ */
				
				DbTable dtble = new InitialTable(this.upf).getDbTable("TOT1");
		 		dtble.setColumn("*");
		 		
		 		for (int i=0; i<=loop.size()-1; i++){
					DbRecord tot0 = new InitialRecord(this.upf).getDbRecord("TOT0");
					tot0.setColumn("*");
					tot0.set("otid", (String)loop.get(i));
					tot0.set("companyid", this.upf.getComCode());
					
					tot0.putChild(dtble); /* ֧ child TOT1 */
					
					if(tot0.search() == 1){	/*  */
						tot0.save();
					}
				}
			} catch (Exception e) {
				MyLog.error(this, e);
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private void cal_TOT_M_DATE0(String employeeid) {
		try {
			/* ֧ҡ tot_m_date0 ԧѺ tot_m_date1 ͡੾ Ŵ otid */
			String sql = "select distinct(t0.otid) from tot_m_date0 t0 left join tot_m_date1 t1 on t0.otid = t1.otid "
						+ " where (t1.start_date between '"+cscStart.getYYYYMMDD()+"' and '"+cscEnd.getYYYYMMDD()+"') " 
						+ " and t0.employeeid='"+employeeid+"'";
			
			Vector loop = new Vector();
			loop = this.getData(sql, "otid");	/* ֧¡͡÷ͧѹ֡ */
			
			DbTable dtble = new InitialTable(this.upf).getDbTable("TOT_M_DATE1");
	 		dtble.setColumn("*");
	 		
	 		for (int i=0; i<=loop.size()-1; i++){
				DbRecord tot_m_date0 = new InitialRecord(this.upf).getDbRecord("TOT_M_DATE0");
				tot_m_date0.setColumn("*");
				tot_m_date0.set("otid", (String)loop.get(i));
				tot_m_date0.set("companyid", this.upf.getComCode());
				
				tot_m_date0.putChild(dtble); /* ֧ child TOT_M_DATE1 */
				
				if(tot_m_date0.search() == 1){	/*  */
					tot_m_date0.save();
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private void cal_TCHSHIFT(String employeeid) {
		try {
			if (this.inqTCHSHIFT == null) {
	 			this.inqTCHSHIFT = new InitialInquiry(this.upf).getDbInquiry();
	 			this.inqTCHSHIFT.setParam(this.data);
	 			this.inqTCHSHIFT.setSchemaName(this.upf.getSchemaName());
	 			this.inqTCHSHIFT.initMyTable("TCHSHIFT","","");
	 			this.inqTCHSHIFT.setColumn("*");
			}
			this.inqTCHSHIFT.setFilter("employeeid='"+employeeid+"' and " +
					"(start_date between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqTCHSHIFT.refresh();
			while (this.inqTCHSHIFT.next()) {
        		MyLog.debug(this, "-----------> inqTCHSHIFT : "
        				+ " shiftid=" + this.inqTCHSHIFT.getString("shiftid") 
        				+ " employeeid=" + this.inqTCHSHIFT.getString("employeeid"));
        		DbRecord rec = this.inqTCHSHIFT.getCurrentDbRecord().cloneRecord(true);	       
        		rec.save();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private void cal_TCHANGESHIFT_NSTDA(String employeeid) {
		try {
			if (this.inqTCHANGESHIFT_NSTDA == null) {
	 			this.inqTCHANGESHIFT_NSTDA = new InitialInquiry(this.upf).getDbInquiry();
	 			this.inqTCHANGESHIFT_NSTDA.setParam(this.data);
	 			this.inqTCHANGESHIFT_NSTDA.setSchemaName(this.upf.getSchemaName());
	 			this.inqTCHANGESHIFT_NSTDA.initMyTable("TCHANGESHIFT_NSTDA","","");
	 			this.inqTCHANGESHIFT_NSTDA.setColumn("*");
			}
			this.inqTCHANGESHIFT_NSTDA.setFilter("employeeid='"+employeeid+"' and " +
					"(start_date between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqTCHANGESHIFT_NSTDA.refresh();
			while (this.inqTCHANGESHIFT_NSTDA.next()) {
        		MyLog.debug(this, "-----------> inqTCHANGESHIFT_NSTDA : "
        				+ " tchshiftid=" + this.inqTCHANGESHIFT_NSTDA.getString("tchshiftid") 
        				+ " employeeid=" + this.inqTCHANGESHIFT_NSTDA.getString("employeeid"));
        		DbRecord rec = this.inqTCHANGESHIFT_NSTDA.getCurrentDbRecord().cloneRecord(true);	       
        		rec.save();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private void cal_TEXCHANGESHIFT(String employeeid) {
		try {
			if (this.inqTEXCHANGESHIFT == null) {
	 			this.inqTEXCHANGESHIFT = new InitialInquiry(this.upf).getDbInquiry();
	 			this.inqTEXCHANGESHIFT.setParam(this.data);
	 			this.inqTEXCHANGESHIFT.setSchemaName(this.upf.getSchemaName());
	 			this.inqTEXCHANGESHIFT.initMyTable("TEXCHANGESHIFT","","");
	 			this.inqTEXCHANGESHIFT.setColumn("*");
			}
			this.inqTEXCHANGESHIFT.setFilter("employeeid='"+employeeid+"' and " +
					"(start_date between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqTEXCHANGESHIFT.refresh();
			while (this.inqTEXCHANGESHIFT.next()) {
        		MyLog.debug(this, "-----------> inqTEXCHANGESHIFT : "
        				+ " exshiftid=" + this.inqTEXCHANGESHIFT.getString("exshiftid") 
        				+ " employeeid=" + this.inqTEXCHANGESHIFT.getString("employeeid"));
        		DbRecord rec = this.inqTEXCHANGESHIFT.getCurrentDbRecord().cloneRecord(true);	       
        		rec.save();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private void cal_TEXCHANGESHIFT_NSTDA(String employeeid) {
		try {
			if (this.inqTEXCHANGESHIFT_NSTDA == null) {
	 			this.inqTEXCHANGESHIFT_NSTDA = new InitialInquiry(this.upf).getDbInquiry();
	 			this.inqTEXCHANGESHIFT_NSTDA.setParam(this.data);
	 			this.inqTEXCHANGESHIFT_NSTDA.setSchemaName(this.upf.getSchemaName());
	 			this.inqTEXCHANGESHIFT_NSTDA.initMyTable("TEXCHANGESHIFT_NSTDA","","");
	 			this.inqTEXCHANGESHIFT_NSTDA.setColumn("*");
			}
			this.inqTEXCHANGESHIFT_NSTDA.setFilter("employeeid='"+employeeid+"' and " +
					"(start_date between '"+this.cscStart.getYYYYMMDD()+"' and '"+this.cscEnd.getYYYYMMDD()+"')");
			this.inqTEXCHANGESHIFT_NSTDA.refresh();
			while (this.inqTEXCHANGESHIFT_NSTDA.next()) {
        		MyLog.debug(this, "-----------> inqTEXCHANGESHIFT_NSTDA : "
        				+ " texshiftid=" + this.inqTEXCHANGESHIFT_NSTDA.getString("texshiftid") 
        				+ " employeeid request=" + this.inqTEXCHANGESHIFT_NSTDA.getString("emp_exchange"));
        		DbRecord rec = this.inqTEXCHANGESHIFT_NSTDA.getCurrentDbRecord().cloneRecord(true);	       
        		rec.save();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	 /* Ң ੾͡ */
    private Vector getData(String sql,String keyfield) {
    	CscConnection conn = null;
    	Statement stmt = null;
    	ResultSet rs = null;
    	boolean autoCommit=true;
    	int count = 0;
    	Vector vData = new Vector();
    	
        try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			autoCommit = conn.getAutoCommit();
			conn.setAutoCommit(false);
			conn.setTransactionIsolation(conn.TRANSACTION_READ_UNCOMMITTED);

			stmt = conn.createStatement();
			rs = stmt.executeQuery(sql);
			
			while(rs.next()){
				vData.add(rs.getString(keyfield));
			}

			conn.commit();
			
        } catch (Exception e) {
            MyLog.error("!! Error in Tabsent_nstda.executeQuery !!", e);           
        } finally {
    		try{
    			if(stmt != null) stmt.close();
	    		if(conn!=null){
	    			conn.setAutoCommit(autoCommit);
	    			conn.close();
	    		}
    		}catch(Exception e){
    			MyLog.error("!! Error : can't close statement or connection in executeQuery!!",e);
    		}
        }
        return vData;
    }
	
}
