package com.csc.library.process;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.text.DecimalFormat;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.UProfile;

/*
 * class 㹡ûѴɵҧ  TA
 *  Ѵɡ âҴҹ ÷ͷ
 * ʢͧҧѴ ФҷͧûѴ
 * ҹ鹨й任Ѵ´٨ҡҧѴɷӡá˹
 */
public class RoundingTime {
	private String roundid = "";
	private double value=0;
	UProfile up=null;
	private DbRecord recRound =null;
	
	public RoundingTime(){		
	}
	
	public RoundingTime(String roundid) {
		this.roundid = roundid;
	}	
	
	public RoundingTime(String roundid, double value) {
		this.roundid = roundid;
		this.value = value;
	}
	
	public RoundingTime(String roundid, double value, UProfile up) {
		this.roundid = roundid;
		this.value = value;
		this.up = up;
	}
	
	public void setRoundValue(double value) {
		this.value = value;
	}
	
	public double getRounding() {
		return this.roundValue(this.value);
	}
	
	public double getRounding(double value) {
		return this.roundValue(value);
	}
	
	public void setUProfile(UProfile up) {
		this.up = up;
	}
	
	public UProfile getUProfile() {
		return this.up;
	}
	
	private double roundValue(double value) {
		double result=0;
		DecimalFormat dicimalFormula = new DecimalFormat("##.00");
		try {			
			if (this.recRound == null) {
				this.recRound = new InitialRecord(this.up).getDbRecord("Mround");
			}
			this.recRound.clearField();
			this.recRound.set("roundid", this.roundid);
			this.recRound.set("rounding", String.valueOf(value));
			return Double.parseDouble(this.recRound.getString("rounding"));
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return Double.parseDouble(dicimalFormula.format(String.valueOf(result)));
	}	
	
}
