package com.csc.library.timeattendance;

import com.csc.library.utilities.CscCalendar;

public class Workers implements ManageWorkers {
	protected String id ;
	protected String fullname ;
	protected CscCalendar start ;
	protected CscCalendar finish ;
	protected String pathway ;
	protected String waypoint ;
	protected String jobgrade ;
	protected String jobgrade_thaidesc ;
	protected String bu1 ;
	protected String bu1thai ;
	protected String bu2 ;
	protected String bu2thai ;
	protected String bu3 ;
	protected String bu3thai ;
	protected boolean ot ;
	
	public CscCalendar getFinish() {
		return finish;
	}

	public String getPathway() {
		return pathway;
	}

	public String getFullname() {
		return fullname;
	}

	public String getId() {
		return id;
	}
	
	public String getJobGrade(){
		return jobgrade;
	}

	public String getJobGradeThaiDesc(){
		return jobgrade_thaidesc;
	}

	public String getWayPoint() {
		return waypoint;
	}

	public String getBu1() {
		return bu1;
	}

	public String getBu1Thai() {
		return bu1thai;
	}

	public String getBu2() {
		return bu2;
	}

	public String getBu2Thai() {
		return bu2thai;
	}
	
	public String getBu3() {
		return bu3;
	}

	public String getBu3Thai() {
		return bu3thai;
	}
	
	public CscCalendar getStart() {
		return start;
	}

	public boolean isWorkingOT() {
		return ot;
	}
	
	public void setId(String id){
		this.id = id;
	}

	public void setWayPoint(String point){
		this.waypoint = point;
	}

	public void setFullname(String fullname){
		this.fullname = fullname;
	}
	
	public void setPathway(String pathway){
		this.pathway = pathway;
	}

	public void setStart(CscCalendar start){
		this.start = new CscCalendar(start.getYYYYMMDDHHMMSS());
	}
	
	public void setFinish(CscCalendar finish){
		this.finish = new CscCalendar(finish.getYYYYMMDDHHMMSS());
	}

	public void setIsWorkingOT(boolean ot){
		this.ot = ot;
	}
	
	public void setJobGrade(String jobgrade){
		this.jobgrade = jobgrade;
	}

	public void setJobGradeThai(String desc){
		this.jobgrade_thaidesc = desc;
	}

	public void setBu1(String bu1){
		this.bu1 = bu1;
	}

	public void setBu1Thai(String desc){
		this.bu1thai = desc;
	}

	public void setBu2(String bu2){
		this.bu2 = bu2;
	}

	public void setBu2Thai(String desc){
		this.bu2thai = desc;
	}

	public void setBu3(String bu3){
		this.bu3 = bu1;
	}

	public void setBu3Thai(String desc){
		this.bu3thai = desc;
	}
	
}
