package com.csc.library.timeinterface;

import com.csc.library.utilities.MyLog;
import java.util.Vector;

import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.SwipeVirtual;
import com.csc.library.timeattendance.TimeZone;

public interface SwipeTrans {	
	public long findTimeIn(TimeZone tz); //ҡٴѵáش
	public long findTimeOut(TimeZone tz); //ҡٴѵ÷ش
	public long findTimeBeforeLast(TimeZone tz); //ҡٴѵ÷ش
	public int getSwipeCount(TimeZone tz); //ҡٴѵ÷ش
	public Vector getSwipeList(TimeZone tz); //ҡٴѵ÷ش
	public TimeZone getTimeInNear();
	public TimeZone getTimeOutNear();
	public void reserve(long recordNo, String reserveCode);
	public Vector getTimeInList(); //get šٴѵ÷
	public Vector getTimeOutList(); //get šٴѵ÷
	public SwipeRecord getSwipeRecord(long RecordNo);
	public SwipeRecord getSwipeRecord(String ReserveCode);
	public long addRecord(SwipeVirtual SV);
	public void setTimesLength(float times)  ;
	public void setCurShift(Shift shift);
	public Shift getCurShift();
	public void addKeyDateIn(String key, SwipeRecord sr);
	public void addKeyDateOut(String key, SwipeRecord sr);
}