package com.csc.library.databean;
import com.csc.library.databean.Memployee;
import com.csc.library.session.DbInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;


public class Memployee_working_result extends Memployee {
	
	public void preInqNext() {
		try {
			CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
			CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
			String filter = "(dateid between '"+cscStart.getYYYYMMDD()+"' and '"+cscEnd.getYYYYMMDD()+"')";
			DbInquiry inqCurrent = (DbInquiry) this.getChild("vw_worktime");
			inqCurrent.setFilter(filter);
			this.refreshChild("vw_worktime");
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

}
