package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

import java.util.HashMap;
import java.util.StringTokenizer;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.timeinterface.GenDayShift;
import com.csc.library.timeinterface.StandardShift;

/*
 * Class 纵ҧ÷ӧҹͧѡҹ
 * 㹡ҧ Ἱ÷ӧҹͧѡҹ
 */
public class Mtime0 extends RecordCmp implements StandardShift, DbRecord {
	
	HashMap time0HM = new HashMap();
	HashMap empHM = null;
	MyTreeMap empSwipeTime = null;
	
	private DbInquiry inqTime1 = null;
	private DbInquiry inqTime2 = null;
	private DbInquiry inqHoliday = null;
	private DbRecord recTime1 = null;

	public Mtime0() {
		super("Mtime0", "Mtime0 Table");
	}

	/*
	 * ҧἹ÷ӧҹͧѡҹ ǧҷ
	 */
	public WorkingShift genWorkingShift(CscCalendar begDate, CscCalendar endDate) {	
		return this.genWorkingShift(begDate, endDate, "N");
	}
	
	/*
	 * ӡҧἹ÷ӧҹ ǧҷ
	 * ҡ param type=true 繡ҧἹ÷ӧҹ
	 * ѹش仴
	 */
	public WorkingShift genWorkingShift(CscCalendar begDate, CscCalendar endDate, String type) {		
		CscCalendar startDate=null, resignDate=null;
		CscCalendar sDate = new CscCalendar(begDate.getTimestamp()); //ѹ鹢ͧἹ
		CscCalendar eDate = new CscCalendar(endDate.getTimestamp()); //ѹشͧἹ
		
		CscCalendar bgDate = new CscCalendar(begDate.getTimestamp()); //ѹ鹢ͧἹ (ǹٻѹ )
		CscCalendar enDate = new CscCalendar(endDate.getTimestamp()); //ѹشͧἹ (ǹٻ)
		
		if (this.empHM!=null) { 
			startDate = new CscCalendar(this.empHM.get("startdate").toString()); //ѹ鹷ӧҹ
			resignDate = new CscCalendar(this.empHM.get("resigndate").toString()); //ѹ͡
			resignDate.decDate();
		}
		
		HashMap hmDataTime1 = new HashMap();
		
		CscCalendar buffDate = new CscCalendar(begDate.getYYYYMMDD());
		WorkingShift wShift = new WorkingShift(); //ҧἹ÷ӧҹ
		wShift.setShiftProperty(this.getHashMap()); //˹´ͧѺἹ÷ӧҹ
		wShift.setShiftCode(this.getString("time0id")); //˹ʡѺἹ÷ӧҹ
		HashMap hm = this.loadDataHoliday(sDate, eDate); //Ŵѹشѵġ
		DayShift ds1 = new DayShift();
		boolean isStopDay = false; //ѹش
		
		boolean b=false; //Ҿѡҹѧʶҹ繾ѡҹ
		//check status + regisndate --> U,S,X,Y,Z		
		String str=this.empHM.get("status").toString();
		if (str.equalsIgnoreCase("U")||str.equalsIgnoreCase("S")||str.equalsIgnoreCase("X")||
				str.equalsIgnoreCase("Y")||str.equalsIgnoreCase("Z")) b=true;
		HashMap hmTime1 = this.loadTime1Data();
		
		try { //ҧἹ÷ӧҹ 1 ѹ
			if (!hmTime1.isEmpty()) {
				Mtime1 tm1 = (Mtime1) hmTime1.get(String.valueOf(begDate.getCSCDOW()));
				GenDayShift rec = (GenDayShift) hmTime1.get(String.valueOf(begDate.getCSCDOW()));				
				ds1 = rec.generateDayShift(this.getString("time0id"), new CscCalendar(begDate.getDDMMYYYY()), hm, type, new HashMap(), "", sDate, eDate);
				if (hm.containsKey(begDate.getYYYYMMDD()) || tm1.getString("stopday").equalsIgnoreCase("1")) {	
					isStopDay = true; 
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}						
		
		//if (!ds1.isEmpty() || (isStopDay && !type.equals("N"))) {			
		//ҡἹ÷ӧҹ 1 ѹҧ ҧἹ÷ӧҹѹ
		if ((!ds1.isEmpty() || (isStopDay && !type.equals("OTM"))) || this.getString("status").equals("0")) {
			DayShift dShift = new DayShift();			
			while (bgDate.beforeEquals(enDate)) {	
				try {			
					if (startDate.beforeEquals(bgDate)&&resignDate.afterEquals(bgDate)) {
						GenDayShift rec = (GenDayShift) hmTime1.get(String.valueOf(bgDate.getCSCDOW()));
						
						dShift = rec.generateDayShift(this.getString("time0id"), 
									new CscCalendar(bgDate.getDDMMYYYY()), hm, type, hmDataTime1,
									"", sDate, eDate, this.empSwipeTime);
						
						wShift.put(bgDate.getYYYYMMDD(), dShift);
					}					
				} catch (Exception e) {
					MyLog.error(this, e);					
				}finally{
					bgDate.incDate();
				}//end try
			}//end while
		} else { //辺㹵ҧ÷ӧҹ ӡҧἹ÷ӧҹҡҧ
			DayShift dShift = new DayShift();
			HashMap hmData2 = new HashMap();
			HashMap hmData1 = new HashMap();
			
			String month="", year="", tmpmonth="", tmpyear="";
			int i=1;			
			
			while (bgDate.beforeEquals(enDate)) {
				try {
					//if (startDate.beforeEquals(begDate)&&((resignDate.afterEquals(begDate)&&b)||!b)) {					
					if (startDate.beforeEquals(bgDate)&&resignDate.afterEquals(bgDate)) {
						//Start edit for get Time2 per month in each day
						if (bgDate.getMM().substring(0,1).equals("0")) {
							month = bgDate.getMM().substring(1,2);							
						} else month = bgDate.getMM();				
						year = String.valueOf(bgDate.getYear());
						
						if (!month.equals(tmpmonth) || !year.equals(tmpyear)) {
							hmData2 = this.loadTime2Data(month, year); //Ŵ㹵ҧ ͹, շ
						}						
						
						if (!hmData2.isEmpty()) {
							GenDayShift rec = (GenDayShift) hmData2.get(this.getString("time0id"));
							dShift = rec.generateDayShift(this.getString("time0id"), 
									new CscCalendar(bgDate.getDDMMYYYY()), hm, type, hmDataTime1,"", sDate, eDate, this.empSwipeTime);
							wShift.put(bgDate.getYYYYMMDD(), dShift);
						}
						
						tmpmonth = month;
						tmpyear = year;
					}
				} catch (Exception e) {
					MyLog.error(this, e);					
				}finally{
					bgDate.incDate();
				}//end try
				
			}//end while
		}//end if 
		bgDate.decDate();
		//wShift.setWorkingShiftDate(buffDate, endDate);
		wShift.setWorkingShiftDate(sDate, eDate);
		MyLog.debug(this, "-------->wShift " + wShift);
		return wShift;
	}

	/*
	 * ӡҧἹ÷ӧҹ ӹǹ 1 ѹ
	 */
	public WorkingShift genWorkingShift(CscCalendar date) {
		return this.genWorkingShift(date, "N");
	}
	
	/*
	 * ӡҧἹ÷ӧҹ ӹǹ 1 ѹ
	 * ҡ param type=true 繡ҧἹ÷ӧҹ
	 * ѹش仴
	 */
	public WorkingShift genWorkingShift(CscCalendar date, String type) {
		CscCalendar startDate=null, resignDate=null;
		if (this.empHM!=null) {
			startDate = new CscCalendar(this.empHM.get("startdate").toString());
			resignDate = new CscCalendar(this.empHM.get("resigndate").toString());
			resignDate.decDate();
		}
		
		HashMap hmDataTime1 = new HashMap();
		
		WorkingShift wShift = new WorkingShift();
		wShift.setShiftProperty(this.getHashMap());
        wShift.setShiftCode(this.getString("time0id"));
		DayShift dShift = new DayShift();
		HashMap hm = this.loadDataHoliday();
		
		boolean b=false;
		//check status + regisndate --> U,S,X,Y,Z		
		String str=this.empHM.get("status").toString();
		if (str.equalsIgnoreCase("U")||str.equalsIgnoreCase("S")||str.equalsIgnoreCase("X")||
				str.equalsIgnoreCase("Y")||str.equalsIgnoreCase("Z")) b=true;
		
		HashMap hmData1 = this.loadTime1Data();		
		try {
			if (startDate.beforeEquals(date) && ((resignDate.afterEquals(date)&&b) || !b)) {
				GenDayShift rec = (GenDayShift) hmData1.get(String.valueOf(date.getCSCDOW()));
				dShift = rec.generateDayShift(this.getString("time0id"), 
						new CscCalendar(date.getDDMMYYYY()), hm, type, hmDataTime1,"", date, date, this.empSwipeTime);				
			} else MyLog.debug(this, "<<<<<<<< Not Genarate WorkingShift : This Day is Not Employee >>>>>>>>>>");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}

		if (!dShift.isEmpty()) {
			wShift.put(date.getYYYYMMDD(), dShift);
		} else {
			HashMap hmData2 = this.loadTime2Data();
			try {
				if (startDate.beforeEquals(date)&&((resignDate.afterEquals(date)&&b)||!b)) {
					GenDayShift rec = (GenDayShift) hmData2.get(this.getString("time0id"));						
					dShift = rec.generateDayShift(this.getString("time0id"), 
							new CscCalendar(date.getDDMMYYYY()), hm, type, hmDataTime1, "", date, date);
					wShift.put(date.getYYYYMMDD(), dShift);
				} else MyLog.debug(this, "<<<<<<<< Not Genarate WorkingShift : This Day is Not Employee >>>>>>>>>>");
			} catch (Exception e) {
				MyLog.error(this, e);				
			}
		}
		wShift.setWorkingShiftDate(date);
		//MyLog.debug(this, "-------->wShift " + wShift);
		return wShift;
	}

	/*
	 * ӡŴ㹵ҧѹشġ
	 */
	private HashMap loadDataHoliday() {
		HashMap holidayHM = new HashMap();
		try {
			if (this.inqHoliday == null) {
				this.inqHoliday = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqHoliday.setParam(this.param);
				this.inqHoliday.setSchemaName(this.userPro.getSchemaName());
				this.inqHoliday.initMyTable("Mholiday1", "", "");
				this.inqHoliday.setColumn("hdate, companyid");
			}
			this.inqHoliday.setFilter("holidayid='"	+ this.getString("holidaycode") + "'");
			this.inqHoliday.refresh();
			while (this.inqHoliday.next()) {
				CscCalendar csc = new CscCalendar(this.inqHoliday.getString("hdate"));
				holidayHM.put(csc.getYYYYMMDD(), csc.getYYYYMMDD());
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
		return holidayHM;
	}
	
	/** ӡŴ㹵ҧѹشġ ǧѹ֧ͧ   */
	private HashMap loadDataHoliday(CscCalendar st, CscCalendar en) {
		HashMap holidayHM = new HashMap();
		try {
			if (this.inqHoliday == null) {
				this.inqHoliday = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqHoliday.setParam(this.param);
				this.inqHoliday.setSchemaName(this.userPro.getSchemaName());
				this.inqHoliday.initMyTable("Mholiday1", "", "");
				this.inqHoliday.setColumn("hdate, companyid");
			}
			this.inqHoliday.setFilter("holidayid='"	+ this.getString("holidaycode") + "' and hdate between '" + st.getYYYYMMDD() + "' and '" + en.getYYYYMMDD() + "'");
			this.inqHoliday.refresh();
			while (this.inqHoliday.next()) {
				CscCalendar csc = new CscCalendar(this.inqHoliday.getString("hdate"));
				holidayHM.put(csc.getYYYYMMDD(), csc.getYYYYMMDD());
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
		return holidayHM;
	}
	
	/*
	 * 纤 properties ҧ  ͹, ͷ٧ش
	 * (ء field  MTIME0) ŧ HashMap 㹡ҧἹ÷ӧҹ
	 * ¡ŧ HashMap ͧ令Ң㹰ҹ
	 */
	private HashMap getHashMap(){
    	HashMap hm = new HashMap();
		StringTokenizer str = new StringTokenizer(this.getFieldList(),",");
		while (str.hasMoreTokens()) {
			String field = str.nextToken();
			hm.put(field.toUpperCase(),this.getString(field));
		}
    	return hm;
    }
	
	/*
	 * 纤 ʾѡҹ, ѡҹ, ѹӧҹ, ѹ͡
	 * ŧ HashMap ͹㹡ҧἹ÷ӧҹ
	 * Ἱ÷ӧҹҧ੾Ъǧҷѧӧҹҹ
	 */
	public void setEmpRec(DbRecord emp) {
		try {
			this.empHM = new HashMap();
			this.empHM.put("employeeid", emp.getString("employeeid"));
			this.empHM.put("status", emp.getString("status"));
			this.empHM.put("startdate", emp.getString("startdate"));
			this.empHM.put("resigndate", emp.getString("resigndate"));
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	public void setEmpSwipeTime(MyTreeMap tr) {
		try {
			this.empSwipeTime = tr;
			if (this.empSwipeTime==null) {
				this.empSwipeTime = new MyTreeMap();
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	/*
	 * ӡŴ㹵ҧ÷ӧҹ
	 */
	private HashMap loadTime1Data(){
		HashMap hm = new HashMap();
		try {
			if (this.inqTime1 == null) {
				this.inqTime1 = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTime1.setParam(this.param);
				this.inqTime1.setSchemaName(this.userPro.getSchemaName());
				this.inqTime1.initMyTable("Mtime1", "", "");
				this.inqTime1.setColumn("*");
			}
			this.putChild(this.inqTime1);
			this.refreshChild("mtime1");
			DbInquiry inq = (DbInquiry) this.getChild("mtime1");
			do { 
				if (inq.getString("time0id")!=null && !inq.getString("time0id").equals("")) {
					hm.put(inq.getString("dayweekid"), inq.getCurrentDbRecord().cloneRecord(false));
				}
			} while (inq.next());
			this.removeChild("Mtime1");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hm;
	}
	
	/*
	 * ӡŴ㹵ҧ÷ӧҹ
	 */
	private HashMap loadTime1Data(String timeCode, HashMap hm){	
		try {
			HashMap hmDay = new HashMap();
			if (this.inqTime1 == null) {
				this.inqTime1 = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTime1.setParam(this.param);
				this.inqTime1.setSchemaName(this.userPro.getSchemaName());
				this.inqTime1.initMyTable("Mtime1", "", "");
				this.inqTime1.setColumn("*");
			}
			this.inqTime1.setFilter("time0id='"+timeCode+"'");
			this.inqTime1.refresh();
			while (this.inqTime1.next()) {
				hmDay.put(this.inqTime1.getString("dayweekid"), this.inqTime1.getCurrentDbRecord().cloneRecord(false));
			}			
			hm.put(timeCode, hmDay);
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hm;
	}
	
	/*
	 * ӡŴ㹵ҧ
	 */
	private HashMap loadTime2Data() {
		HashMap hm = new HashMap();
		try {			
			if (this.inqTime2 == null) {
				this.inqTime2 = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTime2.setParam(this.param);
				this.inqTime2.setSchemaName(this.userPro.getSchemaName());
				this.inqTime2.initMyTable("Mtime2", "", "");
				this.inqTime2.setColumn("*");
			}
			this.putChild(this.inqTime2);
			this.refreshChild("mtime2");
			DbInquiry inq = (DbInquiry) this.getChild("mtime2");			
			do {
				if (inq.getString("time0id")!=null && !inq.getString("time0id").equals("")) {
					hm.put(inq.getString("time0id"), inq.getCurrentDbRecord().cloneRecord(false));
				}
			} while (inq.next());
			this.removeChild("Mtime2");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hm;
	}
	
	/*
	 * ӡŴ㹵ҧ ͹лշ
	 */
	private HashMap loadTime2Data(String month, String year) {
		HashMap hm = new HashMap();
		try {			
			if (this.inqTime2 == null) {
				this.inqTime2 = new InitialInquiry(this.userPro)	.getDbInquiry();
				this.inqTime2.setParam(this.param);
				this.inqTime2.setSchemaName(this.userPro.getSchemaName());
				this.inqTime2.initMyTable("Mtime2", "", "");
				this.inqTime2.setColumn("*");
			}
			this.inqTime2.setFilter("monthid="+month+" and yearid="+year);
			this.putChild(this.inqTime2);
			this.refreshChild("mtime2");
			DbInquiry inq = (DbInquiry) this.getChild("mtime2");		
			do {
				if (inq.getString("time0id")!=null && !inq.getString("time0id").equals("")) {
					hm.put(inq.getString("time0id"), inq.getCurrentDbRecord().cloneRecord(false));
				}
			} while (inq.next());
			this.removeChild("Mtime2");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return hm;
	}
	
	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();
		this.saveDefault();
	}
	
	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();
		this.saveDefault();
	}
	
	/*
	 * ӡõǨͺ ҡ繵ҧ÷ӧҹ
	 * դ MTIME1 ӡúѹ֡  MTIME1 ѵѵ
	 * ӹǹ 7 ѹ (-) ͹Ŵ˹Ҩ͵ҧ÷ӧҹ error
	 */
	private void saveDefault() {
		try {
			if (this.getString("status").equals("0")) {
				if (this.getChild("mtime1")==null) {
					if (this.inqTime1 == null) {
						this.inqTime1 = new InitialInquiry(this.userPro).getDbInquiry();
						this.inqTime1.initMyTable("Mtime1", "", "");
						this.inqTime1.setColumn("*");
					}
					this.putChild(this.inqTime1);
					this.refreshChild("mtime1");
					if (this.getChild("mtime1")!=null && this.getChild("mtime1").recCount()>1) {
						//Do not thing
						this.removeChild("mtime1");
					} else {
						if (this.recTime1 == null) {
							this.recTime1 = new InitialRecord(this.userPro).getDbRecord("MTIME1");			
						}
						
						int lineno = 1;						
						for (int i = 0; i < 7; i++) {
							int j = i + 1;
							this.recTime1.clearField();
							this.recTime1.set("TIME0ID", this.getString("TIME0ID"));
							this.recTime1.set("DAYWEEKID", j);
							this.recTime1.set("COMPANYID", this.getUProfile().get("companyid"));
							this.recTime1.set("STOPDAY", 0);
							this.recTime1.set("HOUR_D", "0.00");
							this.recTime1.set("TIMEIN1", "0.00");
							this.recTime1.set("TIMEIN2", "0.00");
							this.recTime1.set("TIMEOUT1", "0.00");
							this.recTime1.set("TIMEOUT2", "0.00");
							this.recTime1.set("LINE_NO", lineno++);
							this.recTime1.save();
						}
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	
	@Override
	protected boolean preUpdateTrigger() throws Exception {
		return super.preUpdateTrigger();
	}
	
	@Override
	protected boolean preInsertTrigger() throws Exception {
		return super.preInsertTrigger();
	}
}