package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.approve.Organization;

import com.csc.library.database.FieldManager;
import com.csc.library.database.FieldDate;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

/*
 * NOT USED 2008/09/17
 */
public class Simttime_current1 extends Ttime_current1 {

	HashMap colFormula, colDesc;
	Vector timeCur;
	CscCalendar startD, endD, pointD;
	boolean addAll = false;
	int hourD[] = new int[2];
	int recCount = 0;

	public Simttime_current1() {
		super();
		this.setActualName("Simttime_current1");
		colFormula = new HashMap();
		colDesc = new HashMap();
		timeCur = new Vector();
	}

	public String getString(String fieldname) {
		if (fieldname.equalsIgnoreCase("listsub")) {
			Organization org = (Organization) new InitialRecord(this.getUProfile(), this.param).getDbRecord("masfactor");
			org.setDaTaResult("Torgani", "bossid,employeeid,companyid,runno");
			org.setSub("1", "employeeid", "bossid", this.getUProfile().get(	"actor").toString());
			Vector listsub = org.getSub();
			DbRecord rec;
			String filter = "";
			for (int i = 0; i < listsub.size(); i++) {
				try {
					rec = (DbRecord) listsub.elementAt(i);
					if (filter.equals("")) {
						filter = filter + " employeeid='"+ rec.getString("employeeid") + "'";
					} else {
						filter = filter + " or employeeid='"+ rec.getString("employeeid") + "'";
					}
				} catch (Exception ex) {
					MyLog.error(this, ex);
				}
			}
			return filter;
		} else {
			return super.getString(fieldname);
		}
	}

	private void loadWgroup() {
		DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
		DbInquiry eventGrp = new InitialInquiry(this.getUProfile()).getDbInquiry();
		String formula, caption;
		try {
			MyLog.debug(this, "-------------------------- CODEID -- "+ this.getParam("__codeid"));
			inq.initMyTable("swork_group", "", "");
			inq.setColumn("*");
			inq.setFilter("codeid='" + this.getParam("__codeid") + "'");
			inq.refresh();
			if (inq.next()) {
				for (int point = 1; point < 15; point++) {
					MyLog.debug(this, "-------------------------- CODEID -- "+ point);
					if (point < 10) {
						formula = inq.getString("FORMULA0".toLowerCase() + String.valueOf(point));
						caption = inq.getString("CAPTION0".toLowerCase() + String.valueOf(point));
						colFormula.put("FORMULA0".toLowerCase() + String.valueOf(point), formula);
						colDesc.put("CAPTION0".toLowerCase() + String.valueOf(point), caption);
					} else {
						formula = inq.getString("FORMULA".toLowerCase() + String.valueOf(point));
						caption = inq.getString("CAPTION".toLowerCase() 	+ String.valueOf(point));
						colFormula.put("FORMULA".toLowerCase() + String.valueOf(point), formula);
						colDesc.put("CAPTION".toLowerCase() + String.valueOf(point), caption);
					}
				}
			}

			inq.initMyTable("ttime_current1", "", "");
			eventGrp.initMyTable("simmeventgrp", "", "");
			eventGrp.setColumn("*");
			inq.putChild(eventGrp);
			inq.setOrderBy("dateid");
			inq.setColumn("*");
			FieldDate fmDate1 = new FieldDate("fmDate1", "fmDate1");
			fmDate1.setWorking(true);
			fmDate1.set(this.getParam("__startdate"));

			startD = new CscCalendar(fmDate1.getSaveString());

			if ((this.getParam("__enddate") == null)	|| (this.getParam("__enddate").equals(""))) { 
				//  CONVERT(DATETIME,'2004-04-13 00:00:00', 102)
				inq.setFilter("EMPLOYEEID='" + this.getString("employeeid") + "' and  DATEID ='" + startD.getYYYYMMDD() + "' ");
			} else {
				FieldDate fmDate2 = new FieldDate("fmDate2", "fmDate2");
				fmDate2.setWorking(true);
				fmDate2.set(this.getParam("__enddate"));
				endD = new CscCalendar(fmDate2.getSaveString());
				inq.setFilter("EMPLOYEEID='" + this.getString("employeeid")
						+ "' and  DATEID >='" + startD.getYYYYMMDD()
						+ "'  and  DATEID <='" + endD.getYYYYMMDD() + "' ");
			}
			MyLog.debug(this, "--------------ttime_current1 0 ----------------");

			inq.refresh();
			while (inq.next()) {
				MyLog.debug(this, "--------------ttime_current1 1 ----------------"
								+ "EMPLOYEEID='"	+ this.getString("employeeid")
								+ "' and  DATEID ='"+ startD.getYYYYMMDD() + "' ");
				timeCur.add(inq.getCurrentDbRecord());
				this.recCount++;
				if (this.recCount == 1) {
					pointD = inq.getCurrentDbRecord().getCscCalendar("dateid");
				}
			}
			endD = inq.getCurrentDbRecord().getCscCalendar("dateid");
			DbInquiry emp = new InitialInquiry(this.getUProfile()).getDbInquiry();
			DbInquiry time0 = new InitialInquiry(this.getUProfile()).getDbInquiry();

			emp.initMyTable("memployee", "", "");
			emp.setColumn("employeeid,time0");
			time0.initMyTable("mtime0", "", "");
			time0.setColumn("*");
			Organization org = (Organization) new InitialRecord(this.getUProfile(), this.param).getDbRecord("masfactor");
			org.setDaTaResult("Torgani", "bossid,employeeid,companyid,runno");
			org.setSub("1", "employeeid", "bossid", this.getUProfile().get(	"actor").toString());
			Vector listsub = org.getSub();
			DbRecord rec;
			String filter = "";
			if (listsub.size() > 0) {
				for (int i = 0; i < listsub.size(); i++) {
					try {
						rec = (DbRecord) listsub.elementAt(i);
						if (filter.equals("")) {
							filter = filter + " employeeid='"+ rec.getString("employeeid") + "'";
						} else {
							filter = filter + " or employeeid='"+ rec.getString("employeeid") + "'";
						}
					} catch (Exception ex) {
						MyLog.error(this, ex);
					}
				}
			} else {
				filter = " employeeid='" + this.getString("employeeid") + "'";
			}

			emp.putChild(time0);
			emp.setFilter(filter);
			emp.refresh();
			if (emp.next()) {
				DecimalFormat dFormat = new DecimalFormat("00.00");
				StringTokenizer token = new StringTokenizer(dFormat.format(((DbInquiry) emp.getChild("mtime0"))
								.getCurrentDbRecord().getDouble("hour_d")), ".");
				this.hourD[0] = Integer.parseInt(token.nextToken());
				this.hourD[1] = Integer.parseInt(token.nextToken());
			}

		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
	}

	public FieldManager getField(String FieldName) {
		FieldManager fm = super.getField("companyid");
		FieldName = FieldName.toLowerCase();
		MyLog.debug(this, "  :::::::::::::::::::: " + FieldName + " :::::::::::::::  ");
		if (FieldName.equalsIgnoreCase("addall:true")) {
			this.addAll = true;
			MyLog.debug(this, "       :::::::::::::::::   GETFIELD ADDDLL:TRUE  RETURN TRUE");
		} else {
			MyLog.debug(this, "       :::::::::::::::::   GETFIELD ADDDLL:FALSE  RETURN FALSE");
			if (FieldName.equalsIgnoreCase("addall:false")) {
				this.addAll = false;
				MyLog.debug(this, "       :::::::::::::::::   GETFIELD ADDDLL:FALSE  RETURN FLASE IF");
			} else {
				MyLog.debug(this, "       :::::::::::::::::   GETFIELD ADDDLL:TRUE  RETURN FALSE ELSE");
				if (FieldName.equalsIgnoreCase("nextday")) {
					this.pointD.incDate();
				} else {
					if (FieldName.equalsIgnoreCase("prvday")) {
						this.pointD.decDate();
					} else {
						if (FieldName.equalsIgnoreCase("simdateid")) {
							fm = this.getSimFieldDate();
						} else {
							if (FieldName.indexOf("formula") >= 0) {
								fm = this.getSimFieldFormula(FieldName);
							} else {
								if (FieldName.equalsIgnoreCase("load")) {
									MyLog.debug(this, " LOAD FORMULAR AND CAPTION OF LABEL");
									this.loadWgroup();
								} else {
									if (FieldName.indexOf("count") >= 0) {
										fm = this.initField("String",	FieldName, 20, 0, FieldName);
										fm.setWorking(true);
										fm.setUProfile(this.userPro);
										if (FieldName.indexOf("ot") >= 0) {
											fm.set(this.countOT());
										} else {
											if (FieldName.indexOf("lv4") >= 0) {
												fm.set(this.countLV4());
											} else {
												if (FieldName.indexOf("lv_ty") >= 0) {
													fm.set(this.countLV_TY());
												} else {
													if (FieldName
															.indexOf("rec") >= 0) {
														fm.set(this.recCount);
													} else {
														fm.set(this.countLT());
													}
												}
											}
										}
									} else {
										if (FieldName.indexOf("sum") >= 0) {
											fm = this.initField("String", FieldName, 20, 0, FieldName);
											fm.setWorking(true);
											fm.setUProfile(this.userPro);
											fm.set(this.sumValue(FieldName.substring(FieldName.indexOf(":") + 1)));
										} else {
											MyLog.debug(this, "--------Loop Caption--------");
											if (FieldName.indexOf("caption") >= 0) {
												String tmpCaption = "";
												fm = this.initField("String", FieldName, 20, 0, FieldName);
												fm.setWorking(true);
												fm.setUProfile(this.userPro);

												if (this.colDesc.get(FieldName) != null) {
													tmpCaption = (String) this.colDesc	.get(FieldName);
												}
												MyLog.debug(this, "   tmpCaption : +" + tmpCaption + "+");
												fm.set(tmpCaption);
											} else {
												fm = super.getField(FieldName);
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
		return fm;
	}

	private FieldManager getSimFieldDate() {
		FieldManager fm = null;
		fm = super.getField("dateid");

		fm.set(this.pointD.getDDMMYYYY());
		MyLog.debug(this, "---see------>" + this.pointD.getYYYYMMDD()+ "<--------------" + fm.getString());
		return fm;
	}

	private FieldManager getSimFieldFormula(String FieldName) {
		FieldManager fm = this.initField("String", FieldName, 20, 0, (String) this.colDesc.get(FieldName));
		fm.setWorking(true);
		fm.setUProfile(this.userPro);
		fm.set(this.simValue(FieldName));
		return fm;
	}

	private String sumValue(String fieldName) {
		String addTime = "00.00.00";
		DbRecord rec;
		try {
			DecimalFormat dFormat = new DecimalFormat("00.00");
			for (Enumeration enu = this.timeCur.elements(); enu.hasMoreElements();) {
				rec = (DbRecord) enu.nextElement();
				if ((addAll) || (rec.getCscCalendar("dateid").getYYYYMMDD().equals(pointD.getYYYYMMDD()))) {
					addTime = this.addTime(addTime, "00." + dFormat.format(rec.getDouble(fieldName)));
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
		return addTime;
	}

	private String countLT() {
		int cLT = 0;
		DbRecord rec;
		try {
			MyLog.debug(this, "countLT size " + this.timeCur.size());
			for (Enumeration enu = this.timeCur.elements(); enu.hasMoreElements();) {
				rec = (DbRecord) enu.nextElement();
				MyLog.debug(this, "countLT  in for "+ rec.getString("employeeid"));
				if ((addAll) || (rec.getCscCalendar("dateid").getYYYYMMDD().equals(pointD.getYYYYMMDD()))) {
					if (rec.getFloat("LT") > 0) {
						cLT++;
					}
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);

			
		}
		return String.valueOf(cLT);
	}

	private String countOT() {
		int OT = 0;
		DbRecord rec;
		try {
			for (Enumeration enu = this.timeCur.elements(); enu.hasMoreElements();) {
				rec = (DbRecord) enu.nextElement();
				if ((addAll) || (rec.getCscCalendar("dateid").getYYYYMMDD().equals(pointD.getYYYYMMDD()))) {
					if (rec.getFloat("AC_OT") > 0) {
						OT++;
					}
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
		return String.valueOf(OT);
	}

	private String countLV_TY() {
		int LV_TY = 0;
		DbRecord rec;
		try {
			MyLog.debug(this, "countLV_TY");
			for (Enumeration enu = this.timeCur.elements(); enu.hasMoreElements();) {
				rec = (DbRecord) enu.nextElement();

				if ((addAll)|| (rec.getCscCalendar("dateid").getYYYYMMDD().equals(pointD.getYYYYMMDD()))) {
					MyLog.debug(this, "countLV_TY in for "	+ rec.getString("LV_TY"));
					if (!rec.getString("LV_TY").equalsIgnoreCase("")) {
						LV_TY++;
					}
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
		return String.valueOf(LV_TY);
	}

	private String countLV4() {
		int LV4 = 0;
		DbRecord rec;
		try {
			for (Enumeration enu = this.timeCur.elements(); enu.hasMoreElements();) {
				rec = (DbRecord) enu.nextElement();
				if ((addAll) || (rec.getCscCalendar("dateid").getYYYYMMDD().equals(pointD.getYYYYMMDD()))) {
					if (((DbInquiry) rec.getChild("simmeventgrp")).getString("daytype").equalsIgnoreCase("4")) {
						LV4++;
					}
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
		return String.valueOf(LV4);
	}

	private String simValue(String colFor) {
		String command;
		command = (String) this.colFormula.get(colFor);
		String eventGRP;
		String addTime = "00.00.00";
		if ((command != null) && (command.indexOf(",") >= 0)) {
			for (StringTokenizer token = new StringTokenizer(command, ","); token.hasMoreTokens();) {
				eventGRP = token.nextToken();
				addTime = this.addTime(addTime, this.addValue(eventGRP));
			}
		} else {
			eventGRP = command;
			addTime = this.addTime(addTime, this.addValue(eventGRP));
		}
		return addTime;
	}

	private String addValue(String evnetGRP) {
		String addTime = "00.00.00";
		DbRecord rec;
		try {
			for (Enumeration enu = this.timeCur.elements(); enu.hasMoreElements();) {
				rec = (DbRecord) enu.nextElement();
				if ((addAll) || (rec.getCscCalendar("dateid").getYYYYMMDD().equals(pointD.getYYYYMMDD()))) {
					if (rec.getString("lv_ty").equals(evnetGRP)) {
						addTime = this.addTime(addTime, "00." + rec.getString("M_LV"));
					}
				}
			}
			MyLog.debug(this, "addTime  <" + addTime + ">");
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
		return addTime;
	}

	private String addTime(String date1, String date2) {
		int temp = 0;
		int plus = 0;
		int timeBox[][] = new int[3][3];

		timeBox[2][0] = timeBox[2][0] = timeBox[2][0] = 0;
		String add = "";
		int counter = 0;
		for (StringTokenizer token = new StringTokenizer(date1, "."); token
				.hasMoreTokens();) {
			timeBox[0][counter++] = Integer.parseInt(token.nextToken());
		}
		counter = 0;
		for (StringTokenizer token = new StringTokenizer(date2, "."); token.hasMoreTokens();) {
			timeBox[1][counter++] = Integer.parseInt(token.nextToken());
		}

		// minute
		temp = timeBox[0][2] + timeBox[1][2];
		if (temp >= 60) {
			plus = timeBox[2][2] = temp / 60;
			timeBox[2][2] = temp % 60;
		} else {
			timeBox[2][2] = temp;
		}

		// Hour
		temp = timeBox[0][1] + timeBox[1][1] + plus;
		plus = 0;
		if (temp >= this.hourD[0]) {
			int minute;
			while (temp >= this.hourD[0]) {
				minute = timeBox[2][2];
				if (minute < this.hourD[1]) { // 㹡óշҨҡ  Фҹҷź
					if ((temp - 1) < this.hourD[0])
						break; // ¶֧ҤҢͧҷ͹ҷӧҹ
					minute = (minute + 60) - this.hourD[1];
					timeBox[2][2] = minute;
					temp--;
				} else {
					timeBox[2][2] = minute - this.hourD[1];
				}
				temp = temp - this.hourD[0];
				plus++;
			}
			timeBox[2][1] = temp;
		} else {
			plus = 0;
			timeBox[2][1] = temp;
		}

		// Day
		timeBox[2][0] = timeBox[0][0] + timeBox[1][0] + plus;		
		return timeBox[2][0] + "." + timeBox[2][1] + "." + timeBox[2][2];
	}
}