package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscTime;

public class Temp_leave extends RecordCmp {
    
    public Temp_leave() {
        super("Temp_leave", "Temp_leave Table");
    }
    
    public void decData(String emp, String lv_type, String table_type, float lv_time, float hour_s) {
    	this.set("EMPLOYEEID", emp);
    	this.set("LV_TYPE", lv_type);
    	this.set("COMPANYID", this.userPro.get("companyid"));
    	if (this.search()==1) {
    		// A=Adjust, T=Time Current, H=History
    		float h_lv = 0; // 
    		float d_lv=0; //ѹ 
    		int c_lv=0; // 
    		String name = "";
    		if (table_type.equalsIgnoreCase("A")) {
    			h_lv = this.getFloat("AHOUR");
    			d_lv = this.getFloat("ADAY");
    			c_lv = this.getInt("ACOUNT"); 
    			name = "A";
    		} else if (table_type.equalsIgnoreCase("T")) {
    			h_lv = this.getFloat("THOUR");
    			d_lv = this.getFloat("TDAY");
    			c_lv = this.getInt("TCOUNT");
    			name = "T";
    		} else if (table_type.equalsIgnoreCase("H")) {
    			h_lv = this.getFloat("HHOUR");
    			d_lv = this.getFloat("HDAY");
    			c_lv = this.getInt("HCOUNT");
    			name = "H";
    		}
    		
    		CscTime ct = new CscTime(h_lv);
    		ct.sub(lv_time);
    		this.set(name+"HOUR", ct.getFloat());
    		if (lv_time/hour_s > 0) {
    			this.set(name+"DAY", d_lv - (lv_time/hour_s));
    		} else {
    			this.set(name+"DAY", d_lv);
    		}
    		this.set(name+"COUNT", c_lv-1);
    		this.save();
    	}
    }
    
    public void incData(String emp, String lv_type, String table_type, float lv_time, float hour_s) {
    	this.set("EMPLOYEEID", emp);
    	this.set("LV_TYPE", lv_type);
    	this.set("COMPANYID", this.userPro.get("companyid"));
    	if (this.search()==1) {
    		// A=Adjust, T=Time Current, H=History
    		float h_lv = 0; // 
    		float d_lv=0; //ѹ 
    		int c_lv=0; // 
    		String name = "";
    		if (table_type.equalsIgnoreCase("A")) {
    			h_lv = this.getFloat("AHOUR");
    			d_lv = this.getFloat("ADAY");
    			c_lv = this.getInt("ACOUNT"); 
    			name = "A";
    		} else if (table_type.equalsIgnoreCase("T")) {
    			h_lv = this.getFloat("THOUR");
    			d_lv = this.getFloat("TDAY");
    			c_lv = this.getInt("TCOUNT");
    			name = "T";
    		} else if (table_type.equalsIgnoreCase("H")) {
    			h_lv = this.getFloat("HHOUR");
    			d_lv = this.getFloat("HDAY");
    			c_lv = this.getInt("HCOUNT");
    			name = "H";
    		}
    		
    		CscTime ct = new CscTime(h_lv);
    		ct.add(lv_time);
    		this.set(name+"HOUR", ct.getFloat());
    		this.set(name+"DAY", d_lv + (lv_time/hour_s));
    		this.set(name+"COUNT", c_lv+1);    		
    	} else {
    		String name = "";
    		if (table_type.equalsIgnoreCase("A")) {
    			name = "A";
    		} else if (table_type.equalsIgnoreCase("T")) {
    			name = "T";
    		} else if (table_type.equalsIgnoreCase("T")) {
    			name = "H";
    		}
    		this.set(name+"HOUR", lv_time);
    		if (lv_time/hour_s > 0) {
    			this.set(name+"DAY", lv_time/hour_s);
    		} else {
    			this.set(name+"DAY", 0);
    		}
    		this.set(name+"COUNT", 1);    	
    	} 
    	this.save();
    }

}
