package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.util.StringTokenizer;

import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;

public class Trequestshift_nstda extends RecordCmp {
			
	public Trequestshift_nstda() {
		super("Trequestshift_nstda", "Trequestshift_nstda Table");
	}	

	protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();				
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.saveShift();
		}		
	}

	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();
		if (this.getString("wf_status").equalsIgnoreCase("4") || this.getString("wf_status").equalsIgnoreCase("6")) {
			this.saveShift();
		} 
	}
	
	private void saveShift() {
		try {
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("MTIME2");
			rec.setColumn("*");
			
			String field="";
			StringTokenizer str = new StringTokenizer(this.getFieldList(),",");
			while (str.hasMoreTokens()) {
				field = str.nextToken();
				rec.set(field, this.getString(field));				
			}			
			
			rec.save();
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
	}
	
}
