package com.csc.library.databean;

import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;

/*
 * Error_Type
 *		ٴ = FORGOT-IN ---> 0
 * 		ٴ͡ = FORGOT-OUT ---> 1
 * 		 = LATE ---> 2		
 * 		ͷա͹ = OT-BEFORE ---> 3
 * 		ͷѧ = OT-AFTER ---> 4
 * 		͡͹ = OUT-ABSENT ---> 5
 * 		Ҫ = IN-ABSENT ---> 6
 * 		//ٴ¤ = IN-MORE ---> 7
 * 		//ٴ͡¤ = OUT-MORE ---> 8
 * 		//ӧҹ͹ҧҹ WK-BEFORE ---> 9
 * 		//ӧҹѧҧҹ WK-AFTER ---> 10
 * 		ٴѵѹشҹ WK-HOLIDAY ---> 11
 * 		ͷԹ͹ OT-OVER-BEFORE ---> 12
 * 		ͷԹѧ OT-OVER-AFTER ---> 13
 *    	ͷբҴ͹ OT-LESS-BEFORE ---> 14
 * 		ͷբҴѧ OT-LESS-AFTER ---> 15
 */

/*
 * ֧šüԴҴǨͺ
 *  Ҵ   ͷ ʴ˹Ҩ §ҹ
 */
public class Ttime_current1_warning extends Ttime_current1 {
	
	public Ttime_current1_warning() {
		super();
		this.setActualName("Ttime_current1_warning");
	}
	
	private boolean isLoad = false;
	private String warn_col01, warn_col02, warn_col03, warn_col04, warn_col05;
	private MyHashMap hmColumn = null; //纪ͤͧüԴҴ
	private MyHashMap hmUnit = null;
	
	public void postInqNext() {
		super.postInqNext();
		if (this.isLoad==false) {
			this.warn_col01 = (String) this.param.get("warn_col01");
			this.warn_col02 = (String) this.param.get("warn_col02");
			this.warn_col03 = (String) this.param.get("warn_col03");
			this.warn_col04 = (String) this.param.get("warn_col04");
			this.warn_col05 = (String) this.param.get("warn_col05");
			
			if (this.hmColumn==null) {
				this.hmColumn = new MyHashMap();
			} 			
			if (this.warn_col01==null) this.warn_col01="warn00";
			if (this.warn_col02==null) this.warn_col02="warn01";
			if (this.warn_col03==null) this.warn_col03="warn02";
			if (this.warn_col04==null) this.warn_col04="warn05";
			if (this.warn_col05==null) this.warn_col05="warn11";
						
			this.hmColumn.put(this.warn_col01, this.warn_col01);
			this.hmColumn.put(this.warn_col02, this.warn_col02);
			this.hmColumn.put(this.warn_col03, this.warn_col03);
			this.hmColumn.put(this.warn_col04, this.warn_col04);
			this.hmColumn.put(this.warn_col05, this.warn_col05);
			
			if (this.hmUnit==null) {
				this.hmUnit = new MyHashMap();
			} 	
			if (((String)this.userPro.get("lang")).equalsIgnoreCase("THA")) {
				this.hmUnit.put("warn00", "");
				this.hmUnit.put("warn01", "");
				this.hmUnit.put("warn02", ".");
				this.hmUnit.put("warn03", ".");
				this.hmUnit.put("warn04", ".");
				this.hmUnit.put("warn05", ".");
				this.hmUnit.put("warn06", ".");
				this.hmUnit.put("warn07", "");
				this.hmUnit.put("warn08", "");
				this.hmUnit.put("warn09", ".");
				this.hmUnit.put("warn10", ".");
				this.hmUnit.put("warn11", "");
				this.hmUnit.put("warn12", ".");
				this.hmUnit.put("warn13", ".");
				this.hmUnit.put("warn14", ".");
				this.hmUnit.put("warn15", ".");
			} else {
				this.hmUnit.put("warn00", "");
				this.hmUnit.put("warn01", "");
				this.hmUnit.put("warn02", "Hour");
				this.hmUnit.put("warn03", "Hour");
				this.hmUnit.put("warn04", "Hour");
				this.hmUnit.put("warn05", "Hour");
				this.hmUnit.put("warn06", "Hour");
				this.hmUnit.put("warn07", "");
				this.hmUnit.put("warn08", "");
				this.hmUnit.put("warn09", "Hour");
				this.hmUnit.put("warn10", "Hour");
				this.hmUnit.put("warn11", "");
				this.hmUnit.put("warn12", "Hour");
				this.hmUnit.put("warn13", "Hour");
				this.hmUnit.put("warn14", "Hour");
				this.hmUnit.put("warn15", "Hour");
			}			
			this.isLoad = true;
		}
    }
	
	private FieldManager createField(String fieldName) {
		FieldManager fm = this.initField("String", "", 100, 0, "");
        fm.setWorking(true);
        fm.setUProfile(this.userPro);
        fm.setName(fieldName);
        return fm;
	}
	
	public FieldManager getField(String fieldName) {
		FieldManager fm = super.getField(fieldName);
		if (fieldName.equalsIgnoreCase("warn_col01")) {	
			fm = this.createField(fieldName);
			fm.setDescription(this.getField(this.warn_col01).getDescription());
			if (this.getString(this.warn_col01).equals("")) {
				fm.set("-");
			} else fm.set(this.getString(this.warn_col01));
		} else if (fieldName.equalsIgnoreCase("warn_col02")) {
			fm = this.createField(fieldName);
			fm.setDescription(this.getField(this.warn_col02).getDescription());
			if (this.getString(this.warn_col02).equals("")) {
				fm.set("-");
			} else fm.set(this.getString(this.warn_col02));
		} else if (fieldName.equalsIgnoreCase("warn_col03")) {
			fm = this.createField(fieldName);
			fm.setDescription(this.getField(this.warn_col03).getDescription());
			if (this.getString(this.warn_col03).equals("")) {
				fm.set("-");
			} else fm.set(this.getString(this.warn_col03));
		} else if (fieldName.equalsIgnoreCase("warn_col04")) {
			fm = this.createField(fieldName);
			fm.setDescription(this.getField(this.warn_col04).getDescription());
			if (this.getString(this.warn_col04).equals("")) {
				fm.set("-");
			} else fm.set(this.getString(this.warn_col04));
		} else if (fieldName.equalsIgnoreCase("warn_col05")) {
			fm = this.createField(fieldName);
			fm.setDescription(this.getField(this.warn_col05).getDescription());
			if (this.getString(this.warn_col05).equals("")) {
				fm.set("-");
			} else fm.set(this.getString(this.warn_col05));
		} else if (fieldName.equalsIgnoreCase("warn_col06")) {
			fm = this.createField(fieldName);
			if (((String)this.userPro.get("lang")).equalsIgnoreCase("THA")) {
				fm.setDescription("");
				fm.set("");
			} else {
				fm.setDescription("Other");
				fm.set("NO");
			}			
			for (int i=0;i<=15;i++) {				
				String colName = "warn"+i;
				if (i<10) { 
					colName = "warn0"+i;
				}
				if (!this.hmColumn.containsKey(colName)) {
					if (!this.getString(colName).equals("")) {
						if (((String)this.userPro.get("lang")).equalsIgnoreCase("THA")) {
							fm.set("");
						} else {
							fm.set("YES");
						}
						break;
					}
				}
			}			
		} else if (fieldName.equalsIgnoreCase("warning")) {
			String value = "";		
			for (int i=0;i<=15;i++) {				
				String colName = "warn"+i;
				if (i<10) { 
					colName = "warn0"+i;
				}
				if (!this.getString(colName).equals("")) {
					if (!value.equals("")) {
						value += ", ";
					}
					value += this.getField(colName).getDescription() + " " + this.getString(colName)  + " " + this.hmUnit.getString(colName);
				}
			}
			fm = this.createField(fieldName);
			fm.setDescription("Warning");
			fm.set(value);
		}
				
		return fm;
	}

}
