package com.csc.library.dwr;

import java.util.Vector;

import com.csc.library.database.DataSet;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadFile;

public class Createemployeelist_dwr extends DWR_base {
	
	/* ѺҨҡ˹Ҩ кѹ֡šѡҹŧ㹵ҧ EMP_CREATE_LIST_TEMP */
	public String createlist(String path, String filename){
		this.setUProfile();	/* ҧ uprofile */
		CscCalendar csctime = new CscCalendar();
		
		String Listid = String.valueOf(csctime.getTimeInMillis());
		String fullpath = path+""+filename;
		ReadFile rf = new ReadFile(fullpath);
		StringBuffer data = new StringBuffer();
		String result = "";
		while(rf.hasMoreData()){
			data.append("'"+rf.readLine()+"',");	
		}
		result = data.toString().substring(0,data.toString().length()-1);
		StringBuffer sql = new StringBuffer();
		sql.append("insert into EMP_CREATE_LIST_TEMP(COMPANYID,CREATOR,LISTID,EMPLOYEEID,CREATE_DATE) ");
		sql.append("select COMPANYID,'"+this.up.get("employeeid")+"','"+Listid+"',EMPLOYEEID,replace(convert(varchar, getdate(), 111), '/', '-') from MEMPLOYEE ");
		sql.append("where employeeid in ("+result+")");
		System.out.println(">>>> createlist Sql >>>> "+sql.toString());
		try {
			DataSet ds = new DataSet(sql.toString(),this.up.get("dbname"),"EMP_CREATE_LIST_TEMP");
			boolean chkInsert = ds.excuteUpdate(this.up);
			ds.closeConnection();
			if(chkInsert){
				String SqlChk = "select count(listid) as numrow from EMP_CREATE_LIST_TEMP where listid = '"+Listid+"'";
				DataSet dsChk = new DataSet(SqlChk,this.up.get("dbname"),"EMP_CREATE_LIST_TEMP");
				dsChk.initConnection(this.up);
				dsChk.next();
				boolean chkData = Integer.parseInt(dsChk.getString("numrow")) > 0;
				dsChk.closeConnection();
				if(chkData){
					System.out.println(">>>>> Import Success is = >>>"+Listid);
					return Listid;
				}
				return "ImportUnsuccess";
			}else{
				MyLog.error(">>>>>>>>> ImportUnsuccess<<<<<<<<<<<");
				return "ImportUnsuccess";
			}	
		}catch(Exception e){
			MyLog.error(this,e);
			MyLog.error(">>>>>>>>> ImportUnsuccess<<<<<<<<<<<");
			return "ImportUnsuccess";
		}
	}
	
	/* ѺҨҡ˹Ҩ кѹ֡šѡҹŧ㹵ҧ EMP_CREATE_LIST_TEMP ´ǧҡ÷ͷ*/
	public String createlistWithDetails(String path, String filename){
		this.setUProfile();	/* ҧ uprofile */
		CscCalendar csctime = new CscCalendar();
		
		String Listid = String.valueOf(csctime.getTimeInMillis());
		String fullpath = path+""+filename;
		ReadFile rf = new ReadFile(fullpath);
		StringBuffer data = new StringBuffer();
		String result = "";
		Vector vc = new Vector();
		
		try {
			/* read from csv */
			MyLog.debug("!! File name : " + fullpath);
			while(rf.hasMoreData()) {
				vc.add(rf.readLine());	
			}
			MyLog.debug("!! number of emp in file : " + vc.size());
			
			/* insert */
			String raw = "";
			String tmp[] ;
			boolean rst = false;
			for(int i=0 ; i < vc.size(); i++){
				try {
					raw = (String) vc.get(i);
					if(!raw.trim().equals("")){
						tmp = raw.split(",");
						
						rst = exeQuery(getInsertTag(tmp, Listid));
					}
				}catch(Exception e){
					MyLog.error("Error while insert data [" + raw + "]");
					MyLog.error(this,e);
				}
			}
			
			/* check inserted row */
			String SqlChk = "select count(listid) as numrow from EMP_CREATE_LIST_TEMP where listid = '"+Listid+"'";
			DataSet dsChk = new DataSet(SqlChk,this.up.get("dbname"),"EMP_CREATE_LIST_TEMP");
			dsChk.initConnection(this.up);
			dsChk.next();
			boolean chkData = Integer.parseInt(dsChk.getString("numrow")) > 0;
			dsChk.closeConnection();
			if(chkData){
				System.out.println(">>>>> Import Success is = >>>"+Listid);
				result = Listid;
			}
		}catch(Exception e){
			MyLog.error(this,e);
			result = "ImportUnsuccess";
		}
		return result ;
	}
	
	private String getInsertTag(String[] dat, String listid){
		String rtn = "";
		try {
			CscCalendar st = new CscCalendar(dat[1]);	/* start date */
			st.setCSCTime(Float.parseFloat(dat[2]));
			
			CscCalendar en = new CscCalendar(dat[3]);	/* end date */
			en.setCSCTime(Float.parseFloat(dat[4]));

			StringBuffer sb = new StringBuffer();
			sb.append("insert into EMP_CREATE_LIST_TEMP (COMPANYID,CREATOR,LISTID,EMPLOYEEID,CREATE_DATE,START_DATE,START_TIME,END_DATE,END_TIME,PATHWAYID,TOTAL_TIME)");
			sb.append("select COMPANYID,'"+this.up.get("employeeid")+"','"+listid+"',EMPLOYEEID,CONVERT (date, GETDATE())");
			sb.append(" ,'").append(st.getYYYYMMDD()).append("'");
			sb.append(" ,'").append(dat[2]).append("'");
			sb.append(" ,'").append(en.getYYYYMMDD()).append("'");
			sb.append(" ,'").append(dat[4]).append("'");
			sb.append(" , pathwayid");
			sb.append(" , ").append(Float.toString(en.subForHour(st)));			
			sb.append(" from MEMPLOYEE ");
			sb.append(" where employeeid = '").append(dat[0]).append("'");
			rtn = sb.toString();
		}catch(Exception e){
			MyLog.error(this,e);
		}
		MyLog.debug("!! insert query : " + rtn.toString());
		return rtn;
	}
	
	private boolean exeQuery(String sql){
		boolean chkInsert = false;
		try {
			DataSet ds = new DataSet(sql,this.up.get("dbname"),"EMP_CREATE_LIST_TEMP");
			chkInsert = ds.excuteUpdate(this.up);
			ds.closeConnection();
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return chkInsert;
	}
	
	public void removeList(String listid){
		try {
			this.setUProfile();
			String sql = "delete EMP_CREATE_LIST_TEMP where listid = '"+listid+"'";
			System.out.println(">>>> removeList Sql >>>> "+sql);
			DataSet ds = new DataSet(sql,this.up.get("dbname"),"EMP_CREATE_LIST");
			ds.excuteUpdate(this.up);
			ds.closeConnection();

		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void moveToEmpList(String listid,String stdate,String endate,String sttime,String entime){
		this.setUProfile();	/* ҧ uprofile */
		CscCalendar st_date = new CscCalendar(stdate);
		CscCalendar en_date = new CscCalendar(endate);
		CscTime total_time = new CscTime();
		Float sf = new Float(sttime);
		Float ef = new Float(entime);
		
		CscCalendar run_stdate = new CscCalendar(stdate);
		CscCalendar run_endate = new CscCalendar(stdate);
		
		if(ef<sf){
			total_time.addHour(24);
			run_endate.incDate();
		}
		total_time.add(ef);
		total_time.sub(sf);
		
		while(run_stdate.beforeEquals(en_date)){
			StringBuffer sql = new StringBuffer();
			sql.append("insert into EMP_CREATE_LIST(COMPANYID,CREATOR,LISTID,EMPLOYEEID,START_DATE,END_DATE,START_TIME,END_TIME,TOTAL_TIME) ");
			sql.append("select COMPANYID,'"+this.up.get("employeeid")+"','"+listid+"',EMPLOYEEID,");
			sql.append("'"+run_stdate.getYYYYMMDD()+"','"+run_endate.getYYYYMMDD()+"',");
			sql.append(sttime+","+entime+","+total_time.getDouble()+" from EMP_CREATE_LIST_TEMP ");
			sql.append("where listid = '"+listid+"'");
			System.out.println(">>>> moveToEmpList Sql >>>> "+sql.toString());
			try {
				DataSet ds = new DataSet(sql.toString(),this.up.get("dbname"),"EMP_CREATE_LIST");
				ds.excuteUpdate(this.up);
				ds.closeConnection();
			}catch(Exception e){
				MyLog.error(this,e);
			}
			run_stdate.incDate();
			run_endate.incDate();
		}			
	}
	
	public void moveToEmpListWithoutDetail(String listid){
		this.setUProfile();	/* ҧ uprofile */
		
		StringBuffer sql = new StringBuffer();
		sql.append("insert into EMP_CREATE_LIST(COMPANYID,CREATOR,LISTID,EMPLOYEEID,START_DATE,END_DATE,START_TIME,END_TIME,PATHWAYID,TOTAL_TIME) ");
		sql.append(" select COMPANYID,CREATOR,LISTID,EMPLOYEEID,START_DATE,END_DATE,START_TIME,END_TIME,PATHWAYID,TOTAL_TIME");
		sql.append(" from EMP_CREATE_LIST_TEMP");
		sql.append(" where listid = '"+listid+"'");
		System.out.println(">>>> moveToEmpList Sql >>>> "+sql.toString());
		try {
			DataSet ds = new DataSet(sql.toString(),this.up.get("dbname"),"EMP_CREATE_LIST");
			ds.excuteUpdate(this.up);
			ds.closeConnection();
		}catch(Exception e){
			MyLog.error(this,e);
		}		
	}
}
