package com.csc.library.dwr;

import java.rmi.RemoteException;
import java.util.Iterator;

import com.csc.library.databean.Mtime0;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class GenWorkingTime extends DWR_base {
	private DbRecord emp;
	private DbRecord time;
	public String GetWorkingTime(String[] str){
		StringBuffer sb = new StringBuffer();
		try {
			if(this.up==null){
			this.setUProfile();
			}
		DbRecord dbEmp = getEmp(str[0]);
		Mtime0 dbTime0 = (Mtime0) getMTime0(dbEmp.getString("time0"));
		dbTime0.setEmpRec(dbEmp);
		WorkingShift wstmp = ((Mtime0) dbTime0).genWorkingShift(new CscCalendar(str[1]), new CscCalendar(str[2]), "true");	//ѹش
		wstmp.setUProfile(this.up);
		wstmp.setEmployeeid(dbEmp.getString("employeeid"));
        wstmp.setEmpTimeCode(dbTime0.getString("time0id"));
        Iterator it = wstmp.keySet().iterator();
        while(it.hasNext()){
			DayShift ds = (DayShift)wstmp.get(it.next().toString());
			Iterator it1 = ds.keySet().iterator();
			while(it1.hasNext()){
				Shift sh = (Shift)ds.get(it1.next().toString());
				sb.append(sh.get_c_dt_in().getYYYYMMDD()).append("#").append(sh.getTimeIn().getHHMM().replace(":", ".")).append("#").append(sh.getTimeOut().getHHMM().replace(":", ".")).append(",");
			}
        }
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		return sb.toString();
	}
	
	private DbRecord getEmp(String empid){
		try {
			 emp = new InitialRecord(up).getDbRecord("memployee");
    		 emp.setColumn("*");
    		 emp.set("employeeid", empid);
  	 		 emp.search();
  	 		 
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return emp;
	}
	
	private DbRecord getMTime0(String time0id){
		try {
			 time = new InitialRecord(this.up).getDbRecord("MTIME0");
			 time.setColumn("*");
			 time.set("TIME0ID", time0id);
			 time.search();
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return time;
	}
}