package com.csc.library.dwr;

import com.csc.library.databean.Tchholiday0;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.UProfile;

public class Tchholiday0_dwr extends DWR_base{

    public Tchholiday0_dwr() {}

    public String chkChHoliday(String str[][]){
        this.setUProfile();
        String result = "true";
        if (str.length > 0){
            Tchholiday0 rec = (Tchholiday0) new InitialRecord(this.up).getDbRecord("TCHHOLIDAY0");        	
            for (int i = 0; i < str.length; i++) {
                String empid = str[i][0];
                CscCalendar chdate1 = new CscCalendar(str[i][1]);
                CscCalendar chdate2 = new CscCalendar(str[i][2]);
                rec.clearField();
                rec.set("CHHOLIDAYID","0");
                rec.set("COMPANYID", this.up.get("companyid"));
                if(!rec.chkChHoliday(empid, chdate1, chdate2))
                    return ""+(i+1);
            }
        }
        return result;
    }

}
