package com.csc.library.dwr;

import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class Time0transaction_dwr extends DWR_base {
	
	public void saveRow(String[] data){
		try {
			this.setUProfile();
			
			DbRecord db = new InitialRecord(this.up).getDbRecord("Mempl_time0trans");
			db.setColumn("*");
			db.set("employeeid", data[0]);
			db.set("companyid", data[1]);
			db.set("start_date", new CscCalendar(data[2]));
			db.set("end_date", new CscCalendar(data[3]));
			db.set("time0id", data[4]);
			db.save();
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void delRow(String[] data){
		try {
			this.setUProfile();
			
			DbRecord db = new InitialRecord(this.up).getDbRecord("Mempl_time0trans");
			db.setColumn("*");
			db.set("employeeid", data[0]);
			db.set("companyid", data[1]);
			db.set("start_date", data[2]);
			db.set("end_date", data[3]);
			db.set("time0id", data[4]);
			if(db.search() ==  1){
				db.delete();
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}

}
