package com.csc.library.process;

import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Tabsent_nstda;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadFile;

/*
 * NOT USED 2008/09/01
 */
public class AutomateLeave extends ProcessTimeBase {

	public Vector getProcessList() {
		Vector v = new Vector();
		v.addElement("All");
		return v;
	}
	
	public void process() throws Exception {
		long start=System.currentTimeMillis();		
		//Vector vt = this.getProcessList();
		Vector vt = this.processList;
		String errorResult = "";
		String errorProcess = "";
		String data = "";
		String result = "";
		String fileName = (String) this.data.get("fileName");
		
		InitialEnvironment en = new InitialEnvironment("GLOBAL");
		String xmlPath = en.getValue("import-dir");
		String importPath = en.getValue("dirimport-dir");
		String errorPath = en.getValue("dirimport_error-dir");
		
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
			String id = (String) vt.elementAt(i);			
			
			//ReadFile r = new ReadFile("c:/testleave_liteon.txt");
			ReadFile r = new ReadFile(importPath+fileName);
			String x = r.readLine();
			while (x!=null) {
				System.out.println("===> "+x);				
				StringTokenizer str = new StringTokenizer(x, ",");
				String emp = str.nextToken();
				String lv_type = str.nextToken();
				String lv_date = str.nextToken();
				String lv_format = str.nextToken();
				String lv_count = str.nextToken();
				
				Tabsent_nstda rec = (Tabsent_nstda) new InitialRecord(this.upf).getDbRecord("TABSENT_NSTDA");
				rec.setParam(this.data);
				rec.set("ABSENTID","0");			 
				rec.set("EMPLOYEEID", emp);
				rec.set("TYPE_ABSENT", lv_type);
				rec.set("START_DATE", lv_date);
				rec.set("START_TIME", "0.00");
				rec.set("END_DATE", lv_date);
				rec.set("END_TIME", "23.59");
				rec.set("WF_STATUS", "4");
				rec.set("COMPANYID", this.upf.get("companyid"));
				/* LEAVE FORMAT
				 * 0 = ѹ
				 * 1 = Ҥѹ
				 * 2 = Ҥչ
				*/
				rec.set("LEAVE_FORMAT", lv_format);
				if (rec.getString("LEAVE_FORMAT").equals("1")) {
					 rec.set("LEAVE_HOUR",  lv_count);
				} else rec.set("LEAVE_HOUR",  lv_count);
				String flag  = rec.calulateLeaveRemain(Integer.parseInt(lv_count), 
						Integer.parseInt(lv_format), 0, "0");
				System.out.println("*** step 1 Leave All Day====> "+flag);
				data+=flag+"\n";
				if (flag.substring(0,1).equals("7")) {
					//ԹԷԷ
					if (lv_format.equals("2") || lv_format.equals("3")) {
						rec.set("TYPE_ABSENT", "AAL");
						flag  = rec.calulateLeaveRemain(Integer.parseInt(lv_count), 
								Integer.parseInt(lv_format), 0, "0");
						System.out.println("step 2 Leave Haft of Day====> "+flag);
						data+=flag+"\n";
					} else if (lv_format.equals("0")) {
						rec.set("LEAVE_FORMAT",  "2");
						rec.set("LEAVE_HOUR",  lv_count);
						flag  = rec.calulateLeaveRemain(Integer.parseInt(lv_count), 
								2, 0, "0");
						System.out.println("step 3 Leave 1 Haft ====> "+flag);
						data+=flag+"\n";
						if (!flag.substring(0,1).equals("7")) {
							//ԹԷԷ
							rec.set("LEAVE_FORMAT",  "3");
							rec.set("LEAVE_HOUR",  lv_count);
							rec.set("TYPE_ABSENT", "AAL");
							flag  = rec.calulateLeaveRemain(Integer.parseInt(lv_count), 
									3, 0, "0");
							System.out.println("step 4 Leave 2 Haft [New] ====> "+flag);
							data+=flag+"\n";
						} else {						
							rec.set("LEAVE_FORMAT",  "0");
							rec.set("TYPE_ABSENT", "AAL");
							flag  = rec.calulateLeaveRemain(Integer.parseInt(lv_count), 
									0, 0, "0");
							System.out.println("step 5 Leave All Day [New]====> "+flag);
							data+=flag+"\n";
						}
					}
				}
				result += (x+" ==> "+flag+" \n");
				x = r.readLine();				
			}
			System.out.println("=== RESULT ===");
			System.out.println(result);
			System.out.println("DATA===>"+data);
			
        	this.alive("Process EmployeeID : "+id+" ["+i+" of "+vt.size()+"]");
		}
		this.setMessage("Successful of  : "+vt.size());
		this.setFullMessage("Successful of  : "+vt.size()+"\n"+				
				"Error Process : "+errorProcess);	
		long end=System.currentTimeMillis();
		MyLog.debug(this, "Process >>> End Process :>>> time  : "+(end-start)/10000 + "Total Process="+vt.size());
	}
}
