package com.csc.library.process;

import com.csc.library.utilities.MyLog;
import java.util.Vector;

import com.csc.library.databean.Mtime0;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;

/*
 * ǡѺҧù͹ͧ LPN
 * NOT USED 2008/09/01
 */
public class CheckSleepPattern extends MyProcess {
	
	public Vector getProcessList() {
		Vector v = new Vector();
		v.addElement("All");
		return v;
	}
	
	protected String getParamData(String filedName) {
		if (this.data.containsKey(filedName))
			return this.data.get(filedName).toString();
		return "";
	}
	
	public void process() throws Exception {	
		String workarea = this.getParamData("workarea");
		String yearid = this.getParamData("yearid");
		String monthid = this.getParamData("monthid");
		
		String filter = "sleep_workarea='"+workarea+"' and yearid="+yearid+" and monthid="+monthid;
		DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
		inq.setSchemaName(this.upf.getSchemaName());
		inq.initMyTable("Msleep_pattern", filter, "");
		inq.setColumn("*");
		inq.refresh();
		while (inq.next()) {
			DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
			
			CscCalendar cs = new CscCalendar(rec.getString("dateid")+"-"+monthid+"-"+yearid);
			MyTreeMap tr = this.getSwipeRecord(rec.getString("employeeid"), cs.getYYYYMMDD());
			
			try {
				if (tr!=null && !tr.isEmpty()) {
					String x = (String) tr.get("0");
					String y = (String) tr.get(String.valueOf(tr.size()-1));
						
					if (!x.equals("")) {
						rec.set("DATE_SW_IN", x.substring(0, x.indexOf(",")));
						rec.set("TIME_SW_IN", x.substring(x.indexOf(",")+1, x.length()));
						if (!y.equals("")) {
							rec.set("DATE_SW_OUT", y.substring(0, y.indexOf(",")));
							rec.set("TIME_SW_OUT", y.substring(y.indexOf(",")+1, y.length()));
							
							if (x.equals(y)) { //͡ǡѹ ֧ù͹
								rec.set("APPROVE_STATUS", "0");
								rec.set("SLEEP_STATUS", "0");
							} else {
								rec.set("APPROVE_STATUS", "1");
								rec.set("SLEEP_STATUS", "1");
							}
						} else {
							rec.set("APPROVE_STATUS", "0");
							rec.set("SLEEP_STATUS", "0");
						}					
						rec.save();				
					}
				}
			} catch (Exception e) {
				MyLog.error(this, e);

				
			}
		}	
	}
		
	public MyTreeMap getSwipeRecord(String empID, String date) {
		MyTreeMap tr_time = new MyTreeMap();
		try {			
			CscCalendar cs1 = new CscCalendar(date);
			CscCalendar cs2 = new CscCalendar(date);
			cs2.incDate();
			int i=0;
			String filter = "employeeid='"+empID+"' " +
					"and ((swipedate = '"+cs1.getYYYYMMDD()+"' and swipetime>='20.00') " +
					"or (swipedate = '"+cs2.getYYYYMMDD()+"' and swipetime<='8.00'))";
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("Ttimetemp", filter, "swipedate,swipetime");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord();
				tr_time.put(String.valueOf(i),(rec.getString("swipedate")+","+rec.getString("swipetime")));								
				i++;
			}			
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		return tr_time;
	}


}
