package com.csc.library.process;

import com.csc.library.utilities.MyLog;
import java.util.StringTokenizer;
import java.util.Vector;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

/*
 * class ѺźšèѺ ÷ӧҹ --> ٴѵ
 * TTIMERESERVE
 * NOT USED 2008/09/01
 */
public class ClearTimeReserve extends ProcessTimeBase {
	
	DbRecord recTimeReserve = null;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();
			if (!this.employeeCondition().equals("")) {
				CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));				
				CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
				DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
				inq.setParam(this.data);
				inq.setSchemaName(this.upf.getSchemaName());
				inq.initMyTable("Ttimereserve", this.employeeCondition(), "employeeid");
				inq.setColumn("reservecode, employeeid, runno, companyid, bu1, bu2, bu3, bu4, bu5, costcenter, salatype, workarea, job");
				inq.refresh();
				while (inq.next()) {
					DbRecord rec = inq.getCurrentDbRecord();
					String key="";
					Vector vKey = rec.getAllKey();
					for (int i=0;i<vKey.size();i++) {
						String field = (String) vKey.elementAt(i);
						if (field.equalsIgnoreCase("reservecode")) {
							CscCalendar cscReserve = new CscCalendar(rec.getString(field).substring(0,10));
							if (cscReserve.afterEqualsDate(cs1) && cscReserve.beforeEqualsDate(cs2)) {
								key += field+"="+rec.getString(field)+",";
							} else {
								key = "";
								break;
							}
						} else key += field+"="+rec.getString(field)+",";
					}
					
					if (!key.equals(""))
						v.addElement(key);
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	}
	
	public void process() throws Exception {		
		this.setParamData();
		if (this.getParamValue("cmdValue").toString().equalsIgnoreCase("clear")) {	
			this.clearTimeReserve();
		}		
	}
	
	private String employeeCondition(){
		String filter="";
		try {
			int i=0;			
			DbRecord empRec;
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("Memployee", this.getParamValue("filterProcess").toString(), "employeeid");
			inq.setColumn("employeeid, runno, companyid");
			inq.refresh();
			while (inq.next()) {
				empRec = inq.getCurrentDbRecord();
				if (i==0) {
					filter = "'"+empRec.getString("employeeid")+"'";
				} else filter = filter + ",'"+empRec.getString("employeeid")+"'";
				i++;
			}			
			if (i==1){
				filter = "(employeeid="+filter+")";
			} else filter = "(employeeid in ("+filter+"))";
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return filter;
	}
	
	private void clearTimeReserve(){
		try {
			Vector vt = this.processList;
			for (int i=0;i<vt.size() && !this.isCancle();i++) {
				String id = (String) vt.elementAt(i);
				String data="",field="", value="";
				String key = (String) vt.elementAt(i);		
				
				if (this.recTimeReserve == null) {
					this.recTimeReserve = new InitialRecord(this.upf).getDbRecord("TTIMERESERVE");
				}
				this.recTimeReserve.clearField();
			
				StringTokenizer str = new StringTokenizer(key,",");				
				while (str.hasMoreTokens()) {
					data = str.nextToken(); 
					field = data.substring(0,data.indexOf("="));
					value = data.substring(data.indexOf("=")+1,data.length());
					this.recTimeReserve.set(field, value);
				}
				this.recTimeReserve.search();	        	
				this.recTimeReserve.delete();
				this.alive("Process Record : "+id+" ["+i+" of "+vt.size()+"]");
			}
			this.setMessage("Successful of ClearTimeReserve : "+vt.size());
			this.setFullMessage("Successful of ClearTimeReserve : "+vt.size()+"\n");
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}
}
