package com.csc.library.process;

import com.csc.library.utilities.MyLog;
import java.util.StringTokenizer;
import java.util.Vector;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

/*
 * źŨҡõǨͺ TTIME_ERROR
 * NOT USED 2008/09/01
 */
public class DeleteCheckTimeProcess extends ProcessTimeBase{
	
	DbRecord recError = null;
	
	/*public Vector getProcessList() {
		Vector v = new Vector();
		try {
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("Ttimeerror", " emp_process='"+this.data.get("employeeProcess").toString()+"'", "");
			inq.setColumn("emp_process, companyid, line_no, runno");
			inq.setFatchAll(true);
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord();
				String key="";
				Vector vKey = rec.getAllKey();
				for (int i=0;i<vKey.size();i++) {	
					String field = (String) vKey.elementAt(i);
					key += field+"="+rec.getString(field)+",";
				}
				v.addElement(key);
			}
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}		
		return v;
	}*/
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();		
			if (!this.getCondition().equals("")) {
				DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
				inq.setParam(this.data);
				inq.setSchemaName(this.upf.getSchemaName());
				inq.initMyTable("Ttimeerror", this.getCondition(), "employeeid");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {			
					DbRecord rec = inq.getCurrentDbRecord();
					String key="";
					Vector vKey = rec.getAllKey();
					for (int i=0;i<vKey.size();i++) {	
						String field = (String) vKey.elementAt(i);
						key += field+"="+rec.getString(field)+",";
					}
					v.addElement(key);
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	}
	
	private String getCondition(){ 
		String filter="";
		try {
			filter = this.getParamValue("filterProcess").toString();
			if (!this.getParamValue("startDate").equals("")&&!this.getParamValue("endDate").equals("")) {
				CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));				
				CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
				if (filter.length()>0) {
					filter = filter + " and ";
				} 
				filter = filter + " (dateshift between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"')"; 
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return filter;
	}
	
	private String employeeCondition(){
		String filter="";
		try {
			int i=0;			
			DbRecord empRec;
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.setParam(this.data);
			inq.setSchemaName(this.upf.getSchemaName());
			inq.initMyTable("Memployee", this.getParamValue("filterProcess").toString(), "employeeid");
			inq.setColumn("employeeid, runno, companyid");
			inq.refresh();
			while (inq.next()) {
				empRec = inq.getCurrentDbRecord();
				if (i==0) {
					filter = "'"+empRec.getString("employeeid")+"'";
				} else filter = filter + ",'"+empRec.getString("employeeid")+"'";
				i++;
			}			
			if (i==1){
				filter = "(employeeid="+filter+")";
			} else filter = "(employeeid in ("+filter+"))";
			
			//Add filter StartDate and EndDate
			if (!this.getParamValue("startDate").equals("")&&!this.getParamValue("endDate").equals("")) {
				CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));				
				CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
				if (filter.length()>0) {
					filter = filter + " and ";
				} 
				filter = filter + " (dateshift between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"')"; 
			}
			
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return filter;
	}
	
	public void process() throws Exception {
		if (this.data.get("cmdValue").toString().equalsIgnoreCase("clear")) {			
			this.deleteCheckTimeProcess();
		}
	}
	
	private void deleteCheckTimeProcess() {
		try {			
			Vector vt = this.processList;
			for (int i=0;i<vt.size() && !this.isCancle();i++) {
				String id = (String) vt.elementAt(i);
				String data="",field="", value="";
				String key = (String) vt.elementAt(i);		
				
				if (this.recError == null) {
					this.recError = new InitialRecord(this.upf).getDbRecord("TTIMEERROR");
				}
				this.recError.clearField();
				
				StringTokenizer str = new StringTokenizer(key,",");				
				while (str.hasMoreTokens()) {
					data = str.nextToken(); 
					field = data.substring(0,data.indexOf("="));
					value = data.substring(data.indexOf("=")+1,data.length());
					this.recError.set(field, value);
				}
				this.recError.search();	        	
				this.recError.delete();
				this.alive("Process Record : "+id+" ["+i+" of "+vt.size()+"]");
			}
			this.setMessage("Successful of DeleteCheckTimeProcess : "+vt.size());
			this.setFullMessage("Successful of DeleteCheckTimeProcess : "+vt.size()+"\n");  	
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
}
