package com.csc.library.timeattendance;

import com.csc.library.database.StaticConfig;
import com.csc.library.timeinterface.SwipeRecord;
import com.csc.library.timeinterface.SwipeTrans;
import com.csc.library.timeinterface.TimeResult;
import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Vector;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.UProfile;

public class Shift implements TimeResult {
	UProfile upf;
	SwipeTrans swipeData; //Transaction of swipe card
	CscCalendar shiftDate; //ѹͧ
	String timeCode; //ʡ
	String oldTimeCode; //ʡ
	String eventGroup; //ѹ
	String oldEventGroup; //ѹ
	String docType; //͡
	String docNo; //͡
	CscCalendar c_dt_in; //ѹҧҹѷ
	CscCalendar c_dt_out; //ѹ͡ҹѷ
	float hour_d; //ӹǹӧҹѹ
	String lv_type; //
	float lv; //Һѷ
	String tr_type; //Ź
	float ac_ot; //ӹǹ OT Өԧ
	float ap_ot; //ӹǹ OT 
	float ac_ot_before; //ӹǹ OT Өԧ
	float ap_ot_before; //ӹǹ OT 
	char forget_in; //ٴ
	char forget_out; //ٴ͡
	String remark; //˵
	TimeZone inZone; //ǧѹٴҷӧҹ
	TimeZone outZone; //ǧѹٴ͡ҡҹ
	long inRecord; //record ٴ -1 :  0 : ѧ 1 <= // Ҿ
	long outRecord; //record ٴ͡-1 :  0 : ѧ 1 <= // Ҿ
	TimeZone inTimeNear; //ٴѵá͹˹ ѧ ҷͧٴ
	TimeZone outTimeNear; //ٴѵá͹˹ ѧ ҷͧٴ͡
	Vector inTimeList; //¡âٴѵҷ
	Vector outTimeList; //¡âٴѵ͡
	Vector swipeBeforeIn; // ¡ٴѵêǧ͹ҷӧҹ
	Vector swipeAfterOut; //¡ٴѵêǧѧҡ÷ӧҹ
	Shift previousShift; //С͹˹
	Shift nextShift; //жѴ
    Shift previousFullShift; //С͹˹ +ͷ
    Shift nextFullShift; //жѴ +ͷ
	boolean joinTimeIn, joinTimeOut, overLapTimeIn, overLapTimeOut;
	TimeZone midDayStop; //ѡǧҧ㹡óٴѵ 1 // ǧѺѺ㹡óٴ ͡ǧѡ
	HashMap errorResult;
	private HashMap propertyShf;
	private boolean find;
	private boolean beforeLast=false;
	private String status=""; //ʶҹ Ѻͧᾷ ? 
	private String adjustTemp=""; //šᵡͷբѹ
	float hour_s; //ӹǹӧҹѹ ֧Ҩҡҧ
	CscCalendar o_dt_in; //ѹҧҹѷ
	CscCalendar o_dt_out; //ѹ͡ҹѷ
	CscCalendar sh_dt_in; //ѹҧҹҧ÷ӧҹ
	CscCalendar sh_dt_out; //ѹ͡ҹҧ÷ӧҹ
	
	String workarea; //ʶҹӧҹѹ
	String salatype; //ٻẺèԹͷ
	String ot_type; //ٻẺͷ
	String ot_time0; //ʡ㹡÷ͷ
	String oldDocType = ""; //ʻ͡
	String oldDocNo = ""; //͡
	String docStatus; //ʶҹ͡ 4=ѡҹ 6=HR  [ٵ wf_status]
	String actual_event ; // ѹͧѹ  ͹ adjust (ͧ礡óշ繡ͷ ҷͷѹӧҹѹش лԷͷ͡ зͷѹش eventgrp  O ͹ѹ)
	String actual_date ; //	ѹͧзͧŧ仨ѴἹ
	long next_shift_swipe;
	long prev_shift_swipe;
	
	boolean secondloop = false ;
	
	public Shift() {
		this(new CscCalendar());
	}

	public Shift(CscCalendar dDate) {
		this.shiftDate = dDate;
		this.clear();
	}
	
	public void setUProfile(UProfile upf){
		this.upf = upf;
	}
	
	public UProfile getUProfile(){
		return this.upf;
	}

	public void setSecondLoop(boolean status){
		this.secondloop = status ;
	}

	public void clear() {
		this.swipeData = null;
		this.timeCode = " ";
		this.oldTimeCode = " ";
		this.oldEventGroup = " ";
		this.eventGroup = " ";
		this.docType = " ";
		this.docNo = " ";
		this.c_dt_in = new CscCalendar(this.shiftDate.getYYYYMMDD());
		this.c_dt_out = new CscCalendar(this.shiftDate.getYYYYMMDD());
		this.hour_d = 0;
		this.lv_type = " ";
		this.lv = 0;
		this.tr_type = " ";
		this.ac_ot = 0;
		this.ap_ot = 0;
		this.ac_ot_before = 0;
		this.ap_ot_before = 0;
		this.forget_in = ' ';
		this.forget_out = ' ';
		this.remark = " ";
		this.inZone = null;
		this.outZone = null;
		this.inRecord = 0;
		this.outRecord = 0;
		this.inTimeList = null;
		this.outTimeList = null;
		this.swipeBeforeIn = new Vector();
		this.swipeAfterOut = new Vector();
		this.previousShift = null; //С͹˹
		this.nextShift = null; //жѴ
		this.joinTimeIn = false;
		this.joinTimeOut = false;
		this.overLapTimeIn = false;
		this.overLapTimeOut = false;
		this.midDayStop = null;
		this.find = false;
		this.errorResult = new HashMap();
		this.hour_s = 0;
		this.o_dt_in = new CscCalendar(this.shiftDate.getYYYYMMDD()); //ѹһԢͧ
		this.o_dt_out = new CscCalendar(this.shiftDate.getYYYYMMDD()); //ѹ͡Ԣͧ
		this.workarea = "";
		this.salatype = "";
		this.ot_type = "";
		this.ot_time0= "";
		this.sh_dt_in = new CscCalendar(this.shiftDate.getYYYYMMDD()); //ѹһԢͧ
		this.sh_dt_out = new CscCalendar(this.shiftDate.getYYYYMMDD()); //ѹ͡Ԣͧ
		this.actual_event = "";
	}

	/*
	 * ֧ҵҧ 㹵ҧ÷ӧҹ/ҧ͡
	 *  return  String
	 */
	private String getStringPropertyShift(String field) {
		return (String) this.propertyShf.get(field);
	}

	/*
	 * ֧ҵҧ 㹵ҧ÷ӧҹ/ҧ͡
	 *  return  float
	 */
	private float getFloatPropertyShift(String field) {
		try {
			return Float.valueOf(this.getStringPropertyShift(field)).floatValue();
		} catch (Exception e) {
			MyLog.error(this, e);
			MyLog.debug(this, "ERROR : "+field);			
			return 0f;
		}		
	}

	/*
	 * ֧ҵҧ 㹵ҧ÷ӧҹ/ҧ͡
	 *  return  int
	 */
	private int getIntPropertyShift(String field) {
		return Integer.valueOf(this.getStringPropertyShift(field)).intValue();
	}

	public void setPropertyShift(HashMap PropertyShift) {
		this.propertyShf = PropertyShift;
	}
	
	public HashMap getPropertyShift() {
		return this.propertyShf;
	}

	/* 
	 * ҧ zone 㹡ٴѵ÷ 
	 * ٴ 8.00  zone Ҩ 6.00 - 10.00
	 * ٴ͡ 17.00 zone Ҩ 14.00 - 20.00
	 */
	public void genTimeZone() {
		this.genTimeInZone();
		this.genTimeOutZone();
	}

	/*
	 * ҧҡ÷ӧҹǧ
	 */
	public void genTimeInZone() {
		this.inZone = new TimeZone(this.getBeginingInZoneTime(), this.getEndingInZoneTime());
	}

	/*
	 * ҧҡ÷ӧҹǧ͡
	 */
	public void genTimeOutZone() {
		this.outZone = new TimeZone(this.getBeginingOutZoneTime(), this.getEndingOutZoneTime());
	}

	/*
	 * ӡҧ zone ٴѵêǧáͧ
	 */
	public CscCalendar getBeginingInZoneTime() {
		// support when calculate timezone of out time transaction for begining zone
		CscCalendar buff = null;
		float gap;
		if (this.inRecord <= 0) {
			if(this.getEventGroup().equals("O")){
				buff = new CscCalendar(this.get_c_dt_in().getTime());	
			}else{
				buff = new CscCalendar(this.get_sh_dt_in().getTime());
			}
			
			if (this.ap_ot>0) { // OT ͹ ӡźա 2007/08/16				
				buff.decTime(this.ap_ot);
			}
			if (buff.before(this.get_c_dt_in())) {
				buff = new CscCalendar(this.get_c_dt_in().getTime());	
			}
			buff.decTime(this.getFloatPropertyShift("MAXTMIN")); 
			if (this.previousShift != null && !this.previousShift.isHoliday()) {
				CscCalendar prvSwipe;
				if (this.joinTimeIn) {
					prvSwipe = this.previousShift.get_c_dt_in();
				} else {
					prvSwipe = this.previousShift.get_c_dt_out();
					/*if (this.previousShift.outZone!=null) {
						prvSwipe = this.previousShift.getOutZone().getEndZone();
						prvSwipe.incMinute();
					} else {
						prvSwipe = this.previousShift.get_c_dt_out();
					}*/
				}
				if (buff.beforeEquals(prvSwipe) && this.previousShift.getType() != 'A' ) {
					if (this.previousShift.getOutRecord()>0) {
						buff = new CscCalendar(this.previousShift.getTimeOut().getTime());
					}else{
						if( this.secondloop ){
							buff = new CscCalendar(this.previousShift.getBeginingOutZoneTime().getTime());
						}else{
							buff = new CscCalendar(prvSwipe.halfhalp(this.get_c_dt_in()).getTime());
						}
					}
					buff.incMinute();
				}
			}
		} else {
			if (this.get_m_dt_in().before(this.get_c_dt_in())) {
				buff = new CscCalendar(this.get_m_dt_in().getTime());
			} else {
				buff = new CscCalendar(this.get_c_dt_in().getTime());
			}
		}		
		return buff;
	}

	/*
	 * ӡҧ zone ٴѵêǧѧͧ
	 */
	public CscCalendar getEndingInZoneTime() {
		// support when calculate timezone of out time transaction for ending zone
		CscCalendar buff = null;
		if (this.inRecord <= 0) {
			buff = new CscCalendar(this.get_c_dt_in().getTimeInMillis());
			buff.incTime(this.getFloatPropertyShift("MAXTMLATE")); 
			if (this.get_c_dt_out().beforeEquals(buff)) {
				buff = this.get_c_dt_in().halfhalp(this.get_c_dt_out());
			} else {
				if (this.outRecord > 0) {
					if (this.get_c_dt_out().before(this.swipeData.getSwipeRecord(this.outRecord).getDate())) {
						buff = new CscCalendar(this.get_c_dt_out().getTimeInMillis());
					} else {
						buff = new CscCalendar(this.swipeData.getSwipeRecord(this.outRecord).getDate().getTimeInMillis());
					}
					buff.decMinute();
				}
			}
		} else {
			if (this.get_m_dt_in().before(this.get_c_dt_in())) {
				buff = new CscCalendar(this.get_c_dt_in().getTime());
			} else {
				buff = new CscCalendar(this.get_m_dt_in().getTime());
			}
		}
		return buff;
	}

	/*
	 * ӡҧ zone ٴѵêǧáͧ͡
	 */
	public CscCalendar getBeginingOutZoneTime() {
		// support when calculate timezone of in time transaction for ending zone
		CscCalendar buff = null;
		if (this.outRecord <= 0) {
			buff = new CscCalendar(this.get_c_dt_out().getTime());
			buff.decTime(this.getFloatPropertyShift("MAXTMSTOP"));
			// ͧҡٴ͡͹§ çѺ zone öѺ ֧ӡâ zone ѵѵ
			//if (buff.before(this.getEndingInZoneTime())) {
			//	buff = this.getEndingInZoneTime();
			//	buff.incMinute();
			//}
		
			buff = this.getEndingInZoneTime();
			buff.incMinute();
			
			//buff = this.getEndingInZoneTime();
			//buff.incTime(this.getFloatPropertyShift("MAXLATE")); 
			//buff.incMinute();
		} else {
			if (this.get_m_dt_out().before(this.get_c_dt_out())) {
				buff = new CscCalendar(this.get_m_dt_out().getTime());
			} else {
				buff = new CscCalendar(this.get_c_dt_out().getTime());
			}
		}
		return buff;
	}

	/*
	 * ӡҧ zone ٴѵêǧѧͧ͡
	 */
	public CscCalendar getEndingOutZoneTime() {
		// support when calculate timezone of in time transaction for begining zone
		CscCalendar buff = null;
		if (this.outRecord <= 0) {
			//buff = new CscCalendar(this.get_c_dt_out().getTime());
			/* 08-08-2014  o_dt_out  ͧҡóշ OT ͹ѧ   o_dt_out ҡ OT ͹ zone Ѻ᤺ŧ by Tong_Zuu
			 * ¹ҡ o  sh Ǩзͧ ¨Ѻ 繨Ѻ  zone ᤺ŧ 
			 * ¨ ѹ˹ ŷشѹ ҧ o Ѻ sh 
			 * */
			//buff = new CscCalendar(this.get_o_dt_out().getTime());
			if( this.get_sh_dt_out().afterDateTime(this.get_o_dt_out()) ){
				buff = new CscCalendar(this.get_sh_dt_out().getTime());
			}else{
				buff = new CscCalendar(this.get_o_dt_out().getTime());
			}
			buff = new CscCalendar(this.get_sh_dt_out().getTime());
			buff.incTime(this.getFloatPropertyShift("MAX_OT")); 
			if (this.nextShift != null) {
				if (this.getJoinTimeOut()) {
					if( this.secondloop && this.nextShift.getTR_Type().startsWith("A") ){
						buff = this.nextShift.getEndingOutZoneTime();
					}else{
						buff = this.nextShift.getEndingInZoneTime();
					}
				} else {
					if (this.nextShift.getBeginingInZoneTime().beforeEquals(buff)) {
						// if next shift is holiday let end timezone as it was 
						// if next shift is T or O set end timezone to nextshif start
						if((this.nextShift.getEventGroup().equals("H") || this.nextShift.getEventGroup().equals("I")) 
								&& !(this.nextShift.getDocType().equals("OM") || this.nextShift.getDocType().equals("O") || this.nextShift.getDocType().equals("B")) ){
							//next shift is holiday let end timezone as it was 
						}else if(this.secondloop){
							if( buff.afterDateTime(this.nextShift.getEndingInZoneTime())){
								buff = this.nextShift.getEndingInZoneTime();
								buff.decMinute();
							}
						}else{
							buff = this.nextShift.getBeginingInZoneTime();
							buff.decMinute();
						}
						/* old coding 06-02-2013
						buff = this.nextShift.getBeginingInZoneTime();
						buff.decMinute();
						*/
					} else this.beforeLast = false;
					
					/*if (this.nextShift.inRecord >= 1 
							|| this.nextShift.getDocType().equals("A")
							|| ((this.nextShift.getEventGroup().equals("H") || this.nextShift.getEventGroup().equals("I")) 
							&& !this.nextShift.getDocType().equals("O"))) { //ҡжѴҡٴѵâ ⫹ѧҹ -1 ҷ ֧жѴ  ѹش ͷ ö
						buff = this.nextShift.getBeginingInZoneTime();
						buff.decMinute();
					}*/
					if (this.nextShift.inRecord >= 1 ) { //ҡжѴҡٴѵâ ⫹ѧҹ -1 ҷ ֧жѴ  ѹش ͷ ö
						//buff = this.nextShift.getBeginingInZoneTime();
						buff = new CscCalendar(this.nextShift.get_m_dt_in().getTime());
						buff.decMinute();
					}
					
				}
			}
		} else {
			if (this.get_m_dt_out().before(this.get_c_dt_out())) {
				buff = new CscCalendar(this.get_c_dt_out().getTime());
			} else {
				buff = new CscCalendar(this.get_m_dt_out().getTime());
			}
		}
		return buff;
	}
	/*public CscCalendar getBeginingInZoneTime() {
		// support when calculate timezone of out time transaction for begining zone
		CscCalendar buff = null;
		float gap;
		if (this.inRecord <= 0) {
			buff = new CscCalendar(this.get_c_dt_in().getTime());
			buff.decTime(this.getFloatPropertyShift("MAXTMIN")); 
			if (this.previousShift != null) {
				CscCalendar prvSwipe;
				if (this.joinTimeIn) {
					prvSwipe = this.previousShift.get_c_dt_in();
				} else {
					prvSwipe = this.previousShift.get_c_dt_out();
				}
				if (buff.beforeEquals(prvSwipe)) {
					if (this.previousShift.getOutRecord()>0) {
						buff = this.previousShift.getTimeOut();
					}else{
						buff = prvSwipe.halfhalp(this.get_c_dt_in());
					}
					buff.incMinute();
				}
			}
		} else {
			if (this.get_m_dt_in().before(this.get_c_dt_in())) {
				buff = new CscCalendar(this.get_m_dt_in().getTime());
			} else {
				buff = new CscCalendar(this.get_c_dt_in().getTime());
			}
		}
		return buff;
	}

	public CscCalendar getEndingInZoneTime() {
		// support when calculate timezone of out time transaction for ending zone
		CscCalendar buff = null;
		if (this.inRecord <= 0) {
			buff = new CscCalendar(this.get_c_dt_in().getTimeInMillis());
			buff.incTime(this.getFloatPropertyShift("MAXTMLATE")); 
			if (this.get_c_dt_out().beforeEquals(buff)) {
				buff = this.get_c_dt_in().halfhalp(this.get_c_dt_out());
			} else {
				if (this.outRecord > 0) {
					if (this.get_c_dt_out().before(
							this.swipeData.getSwipeRecord(this.outRecord).getDate())) {
						buff = new CscCalendar(this.get_c_dt_out().getTimeInMillis());
					} else {
						buff = new CscCalendar(this.swipeData.getSwipeRecord(
								this.outRecord).getDate().getTimeInMillis());
					}
					buff.decMinute();
				}
			}
		} else {
			if (this.get_m_dt_in().before(this.get_c_dt_in())) {
				buff = new CscCalendar(this.get_c_dt_in().getTime());
			} else {
				buff = new CscCalendar(this.get_m_dt_in().getTime());
			}
		}
		return buff;
	}

	public CscCalendar getBeginingOutZoneTime() {
		// support when calculate timezone of in time transaction for ending zone
		CscCalendar buff = null;
		if (this.outRecord <= 0) {
			buff = new CscCalendar(this.get_c_dt_out().getTime());
			buff.decTime(this.getFloatPropertyShift("MAXTMSTOP"));
			// ????????????????????????????? ????????????? zone ??????????????? ???????????? zone ??????????
			//if (buff.before(this.getEndingInZoneTime())) {
			//	buff = this.getEndingInZoneTime();
			//	buff.incMinute();
			//}
			buff = this.getEndingInZoneTime();
			buff.incMinute();
		} else {
			if (this.get_m_dt_out().before(this.get_c_dt_out())) {
				buff = new CscCalendar(this.get_m_dt_out().getTime());
			} else {
				buff = new CscCalendar(this.get_c_dt_out().getTime());
			}
		}
		return buff;
	}

	public CscCalendar getEndingOutZoneTime() {
		// support when calculate timezone of in time transaction for begining zone
		CscCalendar buff = null;
		if (this.outRecord <= 0) {
			buff = new CscCalendar(this.get_c_dt_out().getTime());
			buff.incTime(this.getFloatPropertyShift("MAX_OT")); 
			if (this.nextShift != null) {
				if (this.getJoinTimeOut()) {
					buff = this.nextShift.getEndingInZoneTime();
				} else {
					if (this.nextShift.getBeginingInZoneTime().beforeEquals(buff)) {
						if (this.getType()!='O')
							this.beforeLast = true;						
						//buff = this.nextShift.get_c_dt_in();
						buff = this.nextShift.getBeginingInZoneTime();
						buff.decMinute();
					} else this.beforeLast = false;
 
				}
			}
		} else {
			if (this.get_m_dt_out().before(this.get_c_dt_out())) {
				buff = new CscCalendar(this.get_c_dt_out().getTime());
			} else {
				buff = new CscCalendar(this.get_m_dt_out().getTime());
			}
		}
		return buff;
	}*/

	public void setSwipeTrans(SwipeTrans trans) {
        this.swipeData = trans;
        SwipeRecord SR;
        this.inRecord = 0;
        this.outRecord = 0;
        SR = this.swipeData.getSwipeRecord(this.getTimeinReserveCode());
        if (SR!=null) {
        	this.inRecord = SR.getRecordNo();
        }
        SR = this.swipeData.getSwipeRecord(this.getTimeoutReserveCode());
        if (SR!=null) {
        	this.outRecord = SR.getRecordNo();
        }
    }

	public SwipeTrans getSwipeTrans() {
		return this.swipeData;
	}

	/*
	 * ӡٴѵêǧ
	 */
	public long findTimein() {
		if (this.inRecord <= 0 && this.swipeData != null) {
			this.genTimeInZone();
			float dbswipe = 0;
			try {
				if (this.outRecord>0) { //ҡٴѵâ
					dbswipe = Float.parseFloat((String) this.getPropertyShift().get("DBSWIPE"));
				}
			} catch (Exception e) {}
			this.swipeData.setTimesLength(dbswipe);
			this.swipeData.setCurShift(this);
			
			this.inRecord = this.swipeData.findTimeIn(this.inZone);
			this.inTimeNear = this.swipeData.getTimeInNear();
			this.inTimeList = this.swipeData.getTimeInList();
			if (this.inRecord >0) {
				this.swipeData.reserve(this.inRecord, this.getTimeinReserveCode());
			}
		}
		return this.inRecord;
	}

	/*
	 * ӡٴѵêǧ͡
	 */
	public long findTimeout() {
		if (this.outRecord <= 0 && this.swipeData != null) {
			this.genTimeOutZone();
			if (this.beforeLast) {
				this.outRecord = this.swipeData.findTimeBeforeLast(this.outZone);
			} else {
				float dbswipe = 0;
				try {
					if (this.inRecord>0) { //ҡٴѵâ
						dbswipe = Float.parseFloat((String) this.getPropertyShift().get("DBSWIPE"));
					}
				} catch (Exception e) {}
				this.swipeData.setTimesLength(dbswipe);
				this.swipeData.setCurShift(this);
				this.outRecord = this.swipeData.findTimeOut(this.outZone);
			}
			this.outTimeNear = this.swipeData.getTimeOutNear();
			this.outTimeList = this.swipeData.getTimeOutList();
			if (this.outRecord >0) {
				this.swipeData.reserve(this.outRecord, this.getTimeoutReserveCode());
			}
		}
		return this.outRecord;
	}

	public void findTime() {
		if (this.swipeData != null && this.isWorking()) {
			this.find = true;
			this.findTimein();
			this.findTimeout();
		}
	}
	
	public CscCalendar get_o_dt_in() {
		return new CscCalendar(this.o_dt_in.getTimestamp());
	}

	public void set_o_dt_in(CscCalendar dt_in) {
		this.o_dt_in = dt_in;
	}

	public CscCalendar get_o_dt_out() {
		return new CscCalendar(this.o_dt_out.getTimestamp());
	}

	public void set_o_dt_out(CscCalendar dt_out) {
		this.o_dt_out = dt_out;
	}

	public float get_m_tm_in() {
		return this.swipeData.getSwipeRecord(this.inRecord).getTime();
	}

	public float get_m_tm_out() {
		return this.swipeData.getSwipeRecord(this.outRecord).getTime();
	}

	public CscCalendar get_m_dt_in() {
		try {
			/**
			 * Author : Nuiss
			 * Date : 21/10/2552
			 * Logic : ʹٴ͡ҧ ҨҡἹ
			 */
			if(this.getPropertyShift().get("STICKTM").toString().equals("O")){
				return this.get_c_dt_in();
			}else{
				return this.swipeData.getSwipeRecord(this.inRecord).getDate();
			}
		} catch (Exception e) {
			return null;
		}
	}

	public CscCalendar get_m_dt_out() {
		try {
			/**
			 * Author : Nuiss
			 * Date : 21/10/2552
			 * Logic : ʹٴҧ ͡ҨҡἹ
			 */
			if(this.getPropertyShift().get("STICKTM").toString().equals("I")){
				return this.get_c_dt_out();
			}else{
				return this.swipeData.getSwipeRecord(this.outRecord).getDate();
			}//end if 
		} catch (Exception e) {
			return null;
		}
	}

	public CscCalendar get_c_dt_in() {
		return new CscCalendar(this.c_dt_in.getTimestamp());
	}

	public void set_c_dt_in(CscCalendar dt_in) {
		this.c_dt_in = dt_in;
	}

	public CscCalendar get_c_dt_out() {
		return new CscCalendar(this.c_dt_out.getTimestamp());
	}

	public void set_c_dt_out(CscCalendar dt_out) {
		this.c_dt_out = dt_out;
	}

	public String getTimeinReserveCode() {
		DecimalFormat df = new DecimalFormat("00.00");		
		return this.shiftDate.getYYYYMMDD() +  df.format(this.get_c_dt_in().getCSCTime()) +  this.getTimeCode()+ this.getTR_Type() + "0";
	}

	public String getTimeoutReserveCode() {
		DecimalFormat df = new DecimalFormat("00.00");		
		return this.shiftDate.getYYYYMMDD() +  df.format(this.get_c_dt_out().getCSCTime()) + this.getTimeCode()+ this.getTR_Type() + "1";
	}
	
	public String get_sourceout() {
		if (this.swipeData!=null && this.swipeData.getSwipeRecord(this.outRecord)!=null)
			return this.swipeData.getSwipeRecord(this.outRecord).getSource();
		else return ""; 
	}
	
	public String get_sourcein() {
		if (this.swipeData!=null && this.swipeData.getSwipeRecord(this.inRecord)!=null)
			return this.swipeData.getSwipeRecord(this.inRecord).getSource();
		else return "";
	}
	
	public void setWorkarea(String workarea) {
		this.workarea = workarea;
	}
	
	public String getWorkarea() {
		return this.workarea;
	}
	
	public void setSalatype(String salatype) {
		this.salatype = salatype;
	}
	
	public String getSalatype() {
		return this.salatype;
	}
	
	public void setOT_type(String ot_type) {
		this.ot_type = ot_type;
	}
	
	public String getOT_type() {
		return this.ot_type;
	}
	
	public void setOT_time0(String ot_time0) {
		this.ot_time0 = ot_time0;
	}
	
	public String getOT_time0() {
		return this.ot_time0;
	}

	public void setPreviousShift(Shift s) {
		this.previousShift = s;
	}

	public Shift getPreviousShift() {
		return this.previousShift;
	}

	public void setNextShift(Shift s) {
		this.nextShift = s;
	}

	public Shift getNextShift() {
		return this.nextShift;
	}
    
    public void setPreviousFullShift(Shift s) {
        this.previousFullShift = s;
    }

    public Shift getPreviousFullShift() {
        return this.previousFullShift;
    }

    public void setNextFullShift(Shift s) {
        this.nextFullShift = s;
    }

    public Shift getNextFullShift() {
        return this.nextFullShift;
    }

	public void setInRecord(long inRec) {
		this.inRecord = inRec;
	}

	public long getInRecord() {
		return this.inRecord;
	}

	public void setOutRecord(long outRec) {
		this.outRecord = outRec;
	}

	public long getOutRecord() {
		return this.outRecord;
	}

	public CscCalendar getActualSwipeIn() {
		CscCalendar c;
		if (this.inRecord > 0) {
			c = this.swipeData.getSwipeRecord(this.inRecord).getDate();
			if (c.after(this.get_c_dt_in()))
				c = this.get_c_dt_in();
		} else {
			c = this.inZone.getBeginZone();
		}
		return c;
	}

	public CscCalendar getActualSwipeOut() {
		CscCalendar c;
		if (this.inRecord > 0) {
			c = this.swipeData.getSwipeRecord(this.outRecord).getDate();
			if (c.before(this.get_c_dt_out()))
				c = this.get_c_dt_out();
		} else {
			c = this.get_c_dt_out();
		}
		return c;
	}

	public boolean isWorking() { //A=, M=еԴѹ, H=ѹشШѻ, I=ѹشġ
		//if (this.getType()=='A' || this.getType()=='M' || this.getType()=='H' || this.getType()=='I')
		if (this.getType()=='A' || this.getType()=='M') /* Ƿ ͡ ....22-08-2010  è */
			return false;
		return true;
	}
	
	public boolean isOverTimeShift() {
        if (this.tr_type.substring(0,1).equalsIgnoreCase("O"))
        	return false;
        return true;
    }

	public void setTimeCode(String tCode) {
		this.timeCode = tCode;
	}

	public String getTimeCode() {
		return this.timeCode;
	}

	public String getTR_Type() {
		return this.tr_type;
	}
	
	public char getType() {
		return this.tr_type.charAt(0);
	}

	public void setTR_Type(String tr) {
		this.tr_type = tr;
	}

	public void setOldTimeCode(String old_tCode) {
		this.oldTimeCode = old_tCode;
	}

	public String getOldTimeCode() {
		return this.oldTimeCode;
	}

	public void setShiftDate(CscCalendar shDate) {
		this.shiftDate = shDate;
	}

	public CscCalendar getShiftDate() {
		return this.shiftDate;
	}

	public void setEventGroup(String eGroup) {
		this.eventGroup = eGroup;
	}

	public String getEventGroup() {
		return this.eventGroup;
	}

	public void setOldEventGroup(String old_eGroup) {
		this.oldEventGroup = old_eGroup;
	}

	public String getOldEventGroup() {
		return this.oldEventGroup;
	}

	public void setDocType(String doc_type) {
		this.docType = doc_type;
	}

	public String getDocType() {
		return this.docType;
	}

	public void setDocNo(String doc_no) {
		this.docNo = doc_no;
	}

	public String getDocNo() {
		return this.docNo;
	}

	public void setOldDocType(String old_doc_type) {
		this.oldDocType = old_doc_type;
	}
	
	public String getResultOldDocType() {
		return this.getOldDocType();
	}
	
	public String getResultOldDocNo() {
		return this.getOldDocNo();
	}

	public String getOldDocType() {
		return this.oldDocType;
	}

	public void setOldDocNo(String old_doc_no) {
		this.oldDocNo = old_doc_no;
	}

	public String getOldDocNo() {
		return this.oldDocNo;
	}
	
	public void setRemark(String remark) {
		this.remark = remark;
	}

	public String getRemark() {
		return this.remark;
	}
	
	public void setHour_s(float hd) {
		this.hour_s = hd;
	}

	public float getHour_s() {
		return this.hour_s;
	}

	public void setHour_d(float hd) {
		this.hour_d = hd;
	}

	public float getHour_d() {
		return this.hour_d;
	}

	public void setLV_Type(String lv_ty) {
		this.lv_type = lv_ty;
	}

	public String getLV_Type() {
		return this.lv_type;
	}

	public void setLv(float lv) {
		this.lv = lv;
	}

	public float getLv() {
		return this.lv;
	}

	public void setAc_ot(float ac_ot) {
		this.ac_ot = ac_ot;
	}

	public float getAc_ot() {
		return this.ac_ot;
	}

	public void setAp_ot(float ap_ot) {
		this.ap_ot = ap_ot;
	}

	public float getAp_ot() {
		return this.ap_ot;
	}

	public void setAc_ot_before(float ac_ot_before) {
		this.ac_ot_before = ac_ot_before;
	}

	public float getAc_ot_before() {
		return this.ac_ot_before;
	}

	public void setAp_ot_before(float ap_ot_before) {
		this.ap_ot_before = ap_ot_before;
	}

	public float getAp_ot_before() {
		return this.ap_ot_before;
	}
	
	public void setForget_in(char f_in) {
		this.forget_in = f_in;
	}

	public char getForget_in() {
		return this.forget_in;
	}

	public void setForget_out(char f_out) {
		this.forget_out = f_out;
	}

	public char getForget_out() {
		return this.forget_out;
	}

	public void setInZone(TimeZone tz) {
		this.inZone = tz;
	}

	public TimeZone getInZone() {
		return this.inZone;
	}

	public void setOutZone(TimeZone tz) {
		this.outZone = tz;
	}

	public TimeZone getOutZone() {
		return this.outZone;
	}

	public void setInTimeNear(TimeZone tz) {
		this.inTimeNear = tz;
	}

	public TimeZone getInTimeNear() {
		return this.inTimeNear;
	}

	public void setOutTimeNear(TimeZone tz) {
		this.outTimeNear = tz;
	}

	public TimeZone getOutTimeNear() {
		return this.outTimeNear;
	}

	public void setInTimeList(Vector in_tList) {
		this.inTimeList = in_tList;
	}

	public Vector getInTimeList() {
		return this.inTimeList;
	}
		
	public void setOutTimeList(Vector out_tList) {
		this.outTimeList = out_tList;
	}

	public Vector getOutTimeList() {
		return this.outTimeList;
	}

	public String toString() {
		return this.getTimeCode() + " - " + this.eventGroup + " - " +  this.lv_type + " - "
				+ this.tr_type + " - " + this.c_dt_in.toString() + " - "
				+ this.c_dt_out.toString() + this.getStrTimeInZone()				
				+ this.getStrTimeOutZone()
				+" - OT="+String.valueOf(this.getAp_ot())
				+" - LV="+String.valueOf(this.getLv())
				+ " $ "+this.timeCode + " DOC :> "+ this.docNo + " : "+this.hour_s			
				+ " o_in="+this.o_dt_in + " - " + " o_out="+this.o_dt_out
				+ " workarea="+this.workarea + " "+ this.shiftDate
				+ " s_in="+this.get_sourcein()+" s_out="+this.get_sourceout()
				//+ " Next Shift="+this.getNextShift() + " Working="+this.isWorking()
				//+ " JoinTimeOut="+this.joinTimeOut + " JoinTimeIn="+this.joinTimeIn
				+ this.oldDocNo + " : " + this.oldDocType + " # "+this.hour_s + " : " +this.hour_d
				+ " actual_event : " + this.getActualEvent()
				+ " actual_date : " + this.getActualDate()
				 ; 
	}

	public String getKey() {
		return this.c_dt_in.getYYYYMMDDHHMMSS();
	}
	
	/*
	 * ҧٴѵѵѵ
	 * 㹡óշ繡зͧѹ
	 *  	T 8.00 - 17.00 
	 * 			O 17.00 - 20.00
	 * ҧ 17.00 ѵѵ · . ٴѵ 8.00  20.00
	 */
	public void genVirtualSwipeForJoinShift() {
		if (this.swipeData != null && this.isWorking()) {
			//if (this.joinTimeIn && this.inRecord == 0) {
			if ((this.joinTimeIn || isAutoTimeOverlapIn(this, this.previousShift)) && this.inRecord == 0) {
				if(isAutoTimeOverlapIn(this, this.previousShift)){
					if(!this.previousShift.getDocType().equals("A")) {	/* ҧٴѵѵѵԡóշС͹˹ҹ աҡз͡ѹ繡 (24-12-2013) */
					//if(!this.previousShift.getDocType().equals("A")  && this.getPreviousShift().getTR_Type().indexOf("T") < 0) {	/* ҧٴѵѵѵԡóշС͹˹ҹ աҡз͡ѹ繡 (24-12-2013) */
						SwipeRecord SR = this.swipeData.getSwipeRecord(this.getTimeinReserveCode());
						if (SR == null) {
							SwipeVirtual SV = new SwipeVirtual(this.c_dt_in, this.getTimeinReserveCode());
							SV.setSource("9");
							//SV.setReserveCode(this.getTimeinReserveCode());
							//this.inRecord = this.swipeData.addRecord(SV);
							this.swipeData.addRecord(SV);
							this.swipeData.addKeyDateIn(SV.getDate().getYYYYMMDDHHMMSS(), SV);
						} else {
							this.inRecord = SR.getRecordNo();
						}
					}
				}else{
					if(!this.previousShift.getDocType().equals("A") && this.getPreviousShift().getTR_Type().indexOf("T") < 0) {	/* ҧٴѵѵѵԡóշС͹˹ҹ աҡз͡ѹ繡 (24-12-2013) */
						SwipeRecord SR = this.swipeData.getSwipeRecord(this.getTimeinReserveCode());
						if (SR == null) {
							SwipeVirtual SV = new SwipeVirtual(this.c_dt_in, this.getTimeinReserveCode());
							SV.setSource("9");
							//SV.setReserveCode(this.previousShift.getTimeoutReserveCode());
							//this.inRecord = this.swipeData.addRecord(SV);
							this.swipeData.addRecord(SV);
						} else {
							this.inRecord = SR.getRecordNo();
						}
					}
				}
			}

			//if (this.joinTimeOut && this.outRecord == 0) {
			if((this.joinTimeOut || isAutoTimeOverlapOut(this, this.nextShift)) && this.outRecord == 0){
				if(isAutoTimeOverlapOut(this, this.nextShift)){/* ҧٴѵ͹͡ лѨغѹ */
					SwipeRecord SR = this.swipeData.getSwipeRecord(this.getTimeoutReserveCode());
					if (SR == null) {
						//for essilor жѴ  T 
						if(this.getEventGroup().equals("T") && !this.getNextShift().getDocType().equals("A")){	/* ҧ͹óաе͡ѹ ¡鹡зӧҹз͡ѹ繡 ҧ */
						//if(this.getEventGroup().equals("T") && !this.getNextShift().getDocType().equals("A") && this.getNextShift().getTR_Type().indexOf("T") < 0){	/* ҧ͹óաе͡ѹ ¡鹡зӧҹз͡ѹ繡 ҧ */
							SwipeVirtual SV = new SwipeVirtual(this.c_dt_out, this.getTimeoutReserveCode());
							SV.setSource("9");
							//SV.setReserveCode(this.getTimeoutReserveCode());
							//this.outRecord = this.swipeData.addRecord(SV);
							this.swipeData.addRecord(SV);
							this.swipeData.addKeyDateOut(SV.getDate().getYYYYMMDDHHMMSS(), SV);
						}
					} else {
						this.outRecord = SR.getRecordNo();
					}
				}else{
					SwipeRecord SR = this.swipeData.getSwipeRecord(this.getTimeoutReserveCode());
					if (SR == null) {
						SwipeVirtual SV = new SwipeVirtual(this.c_dt_out, this.getTimeoutReserveCode());
						SV.setSource("9");
						//SV.setReserveCode(this.getNextShift().getTimeinReserveCode());
						if(this.getEventGroup().equals("T") && !this.getNextShift().getDocType().equals("A") && this.getNextShift().getTR_Type().indexOf("T") < 0){	/* ҧ͹óաе͡ѹ ¡鹡зӧҹз͡ѹ繡 ҧ */
							//this.outRecord = this.swipeData.addRecord(SV);
							this.swipeData.addRecord(SV);
						}
					} else {
						this.outRecord = SR.getRecordNo();
					}
				}
			}
		}
	}
	
	public boolean getJoinTimeIn() {
		return this.joinTimeIn;
	}

	public void setJoinTimeOut(boolean jsh) {
		this.joinTimeOut = jsh;
	}

	public boolean getJoinTimeOut() {
		return this.joinTimeOut;
	}

	public void setJoinTimeIn(boolean jsh) {
		this.joinTimeIn = jsh;
	}

	public boolean getOverLapTimeIn() {
		return this.overLapTimeIn;
	}

	public void setOverLapTimeOut(boolean lap) {
		this.overLapTimeOut = lap;
	}

	public boolean getOverLapTimeOut() {
		return this.overLapTimeOut;
	}

	public void setOverLapTimeIn(boolean lap) {
		this.overLapTimeIn = lap;
	}

	public String getStringTimeIn() {
		return this.c_dt_in.getYYYYMMDDHHMMSS()+ this.c_dt_in.getYYYYMMDDHHMMSS() + "+";
	}

	public String getStringTimeOut() {
		return this.c_dt_out.getYYYYMMDDHHMMSS()	+ this.c_dt_in.getYYYYMMDDHHMMSS() + "-";
	}

	public boolean isInShift(CscCalendar d) {
		boolean result = false;
		if (this.c_dt_out.afterEquals(d) && this.c_dt_in.beforeEquals(d)) {
			result = true;
		}
		return result;
	}

	private String getStrTimeInZone() {
		String result = "";
		if (this.inZone != null) {
			result = "\n IN -ZONE : " + this.inZone.toString();
			if (this.inRecord > 0) {
				result += "\t Found : "+ String.valueOf(this.inRecord)+ " \t : "
						+ this.swipeData.getSwipeRecord(this.inRecord).getDate().getDDMMYYHHMMSS();
			}
		}
		return result;
	}

	private String getStrTimeOutZone() {
		String result = "";
		if (this.outZone != null) {
			result = "\n OUT-ZONE : " + this.outZone.toString();
			if (this.outRecord > 0) {
				result += "\t Found : "+ String.valueOf(this.outRecord)+ " \t : "
						+ this.swipeData.getSwipeRecord(this.outRecord).getDate().getDDMMYYHHMMSS();
			}
		}
		return result;
	}

	public boolean getFindingStatus() {
		boolean result = false;
		if (this.inRecord > 0 && this.outRecord > 0) {
			result = true;
		}
		return result;
	}

	public boolean isFind() { //·ӡäҢ
		return this.find;
	}

	/*
	 * ӡҧ error ҧ Դ͡
	 * ****** ͹ ͧҡաõǨͺ ******
	 * ****** ͹价 ttime_current1 ᷹ ******
	 */
	public void genProcessResult() {
		/*
		 * Error_Type
		 *		ٴ = FORGOT-IN ---> 0
		 * 		ٴ͡ = FORGOT-OUT ---> 1
		 * 		 = LATE ---> 2		
		 * 		ͷա͹ = OT-BEFORE ---> 3
		 * 		ͷѧ = OT-AFTER ---> 4
		 * 		͡͹ = OUT-ABSENT ---> 5
		 * 		Ҫ = IN-ABSENT ---> 6
		 * 		//ٴ¤ = IN-MORE ---> 7
		 * 		//ٴ͡¤ = OUT-MORE ---> 8
		 * 		//ӧҹ͹ҧҹ WK-BEFORE ---> 9
		 * 		//ӧҹѧҧҹ WK-AFTER ---> 10
		 * 		ٴѵѹشҹ WK-HOLIDAY ---> 11
		 * 		ͷԹ͹ OT-OVER-BEFORE ---> 12
		 * 		ͷԹѧ OT-OVER-AFTER ---> 13
		 *    	ͷբҴ͹ OT-LESS-BEFORE ---> 14
		 * 		ͷբҴѧ OT-LESS-AFTER ---> 15
		 */
		this.errorResult.clear();
    	if (isFind()) {
    		DayCalculation DC = new DayCalculation();
    		DC.calculate(this.propertyShf, this.get_c_dt_in(), this.get_c_dt_out(), this.getTimeIn(), this.getTimeOut(), 
                    this.midDayStop, this.getResultPreviousShiftType(), this.getResultNextShiftType(),
                    this.get_o_dt_in(), this.get_o_dt_out(), this.get_sh_dt_in(), this.get_sh_dt_out(), this.tr_type , this.docType);
    		if (this.inRecord==0) {
    			this.errorResult.put("0", this.get_c_dt_in());
    		}
    		if (this.outRecord==0) {
    			this.errorResult.put("1", this.get_c_dt_out());
    		}
       		if (this.inRecord<0) {
       			this.errorResult.put("7", this.get_c_dt_in());
    		}
    		if (this.outRecord<0) {
    			this.errorResult.put("8", this.get_c_dt_out());
    		}
    		if (this.getEventGroup().equals("O")) {
    			if (DC.getOT_Before()>0) {
    				this.errorResult.put("12", DC.getCscTimeOT_Before());    			
    			}
    			if (DC.getOT_After()>0) {
    				this.errorResult.put("13", DC.getCscTimeOT_After());    			
    			}
    			if (DC.getLate()>0 || DC.getAbsentIn()>0) {
    				CscTime ct = DC.getCscTimeLate();
					ct.add(DC.getCscTimeAbsentIn());
    				this.errorResult.put("14", ct);    			
    			}
    			if (DC.getAbsentOut()>0) {
    				this.errorResult.put("15", DC.getCscTimeAbsentOut());    			
    			}		
    		}else{
    			if (DC.getOT_Before()>0) {
    				this.errorResult.put("3", DC.getCscTimeOT_Before());    			
    			}
    			if (DC.getOT_After()>0) {
    				this.errorResult.put("4", DC.getCscTimeOT_After());    			
    			}
    			if (DC.getLate()>0) {
    				this.errorResult.put("2", DC.getCscTimeLate());    			
    			}
    			if (DC.getAbsentIn()>0) {
    				this.errorResult.put("6", DC.getCscTimeAbsentIn());    			
    			}
    			if (DC.getAbsentOut()>0) {
    				this.errorResult.put("5", DC.getCscTimeAbsentOut());    			
    			}
    		}
   			/*if (this.swipeBeforeIn.size() > 0) {
   				this.errorResult.put("9",this.swipeBeforeIn);    			  				
   			}
   			if (this.swipeAfterOut.size() > 0) {
   				this.errorResult.put("10",this.swipeAfterOut);    			  				
   			}*/
   		} 
    	
    	//Check Error For Join Shift
    	if (this.joinTimeIn==true) {
    		if (this.errorResult.containsKey("2")) {
    			this.errorResult.remove("2");
    		}
    		if (this.errorResult.containsKey("5")) {
    			this.errorResult.remove("5");
    		}
    		if (this.errorResult.containsKey("6")) {
    			this.errorResult.remove("6");
    		}
    	}
    	if (this.joinTimeOut==true) {
    		if (this.errorResult.containsKey("4")) {
    			this.errorResult.remove("4");
    		}
    	}
    }

	public CscCalendar getTimeIn() {
		//CscCalendar result = new CscCalendar();
		if (this.inRecord > 0) {
			//result.setTimeInMillis(this.get_m_dt_in().getTimeInMillis());
			return this.get_m_dt_in();
		} else {
			//result.setTimeInMillis(this.get_c_dt_in().getTimeInMillis());
			return this.get_c_dt_in(); 
		}
		//return result;
	}

	public CscCalendar getTimeOut() {
		//CscCalendar result = new CscCalendar();
		if (this.outRecord > 0) {
			//result.setTimeInMillis(this.get_m_dt_out().getTimeInMillis());
			return this.get_m_dt_out();
		} else {
			//result.setTimeInMillis(this.get_c_dt_out().getTimeInMillis());
			return this.get_c_dt_out();
		}
		//return result;
	}

	public TimeZone getGapIn() {
		TimeZone result = new TimeZone();
		CscCalendar cs = new CscCalendar(this.getTimeIn().getTimestamp());
		cs.decMinute();
		if (this.previousShift != null) {
			CscCalendar csIn = new CscCalendar(this.previousShift.getEndingOutZoneTime().getTimestamp());
			csIn.incMinute();
			result.setBeginZone(csIn);
			result.setEndZone(cs);
		} else {
			result.setBeginZone(cs);
			result.setEndZone(cs);
		}
		return result;
	}

	public TimeZone getGapOut() {
		TimeZone result = new TimeZone();
		CscCalendar cs = new CscCalendar(this.getTimeOut().getTimestamp());
		cs.incMinute();
		if (this.nextShift != null) {
			CscCalendar csOut = new CscCalendar(this.nextShift.getBeginingInZoneTime().getTimestamp());
			csOut.decMinute();
			result.setBeginZone(cs);
			result.setEndZone(csOut);			
		} else {
			result.setBeginZone(cs);
			result.setEndZone(cs);
		}
		return result;
	}

	public void findSwipeBeforeIn() {
		this.swipeBeforeIn.clear();
		//if (this.getGapIn().getDecimalGap() >= 1) {
		if (this.getGapIn().getDecimalGap() >= 1 && this.getGapIn().getDecimalGap() <= 24) { //ҵա 24  Թ
			this.swipeBeforeIn = this.swipeData.getSwipeList(this.getGapIn());
		}
	}

	public void findSwipeAfterOut() {
		this.swipeAfterOut.clear();
		//if (this.getGapOut().getDecimalGap() >= 1) {
		if (this.getGapOut().getDecimalGap() >= 1 && this.getGapOut().getDecimalGap() <= 24) { //ҵա 24  Թ
			this.swipeAfterOut = this.swipeData.getSwipeList(this.getGapOut());
		}
	}
	
	public HashMap getErrorResult() {
		return this.errorResult;
	}
	
	public TimeZone getMidDayStop() {
		return this.midDayStop;
	}
	
	public void setMidDayStop(TimeZone tz) {
		this.midDayStop = tz;
	}	
	
	// =========== Start Implement TimeResult ==========//
	public String getResultTimeCode() {
		return this.getTimeCode();
	}
	
	public String getResultOldTimeCode() {
		return this.getOldTimeCode();
	}
	
	public CscCalendar getResultShiftCalendar() {
		return this.getShiftDate();
	}
	
	public String getResultEventGroup() {
		return this.getEventGroup();
	}
	
	public String getResultOldEventGroup() {
		return this.getOldEventGroup();
	}
	
	public String getResultIsWork() {
		boolean st = this.isWorking();
		if (st==true) 
			return "0";
		else return "1";
	}
	
	public String getResultDocType() {
		return this.getDocType();
	}
	
	public String getResultDocNo() {
		return this.getDocNo();
	}
	
	public CscCalendar getResult_c_dt_in() {
		return this.get_c_dt_in();
	}
	
	public CscCalendar getResult_c_dt_out() {
		return this.get_c_dt_out();
	}
	
	public CscCalendar getResult_m_dt_in() {
		CscCalendar c = this.get_m_dt_in();
		if (c==null) {
			return null;
		} else return c;
	}
	
	public CscCalendar getResult_m_dt_out() {
		CscCalendar c = this.get_m_dt_out();
		if (c==null) {
			return null;
		} else return c;
	}
	
	public float getResultLT() {
		return 0;
	}
	
	public float getResultC_LV() {
		return this.getLv();
	}
	
	public float getResultM_LV() {
		return 0;
	}
	
	public String getResultLV_Type() {
		return this.getLV_Type();
	}
	
	public String getResultTR_Type() {
		return this.getTR_Type();
	}
	
	public float getResultAc_ot() {
		return this.getAc_ot();
	}
	
	public float getResultAp_ot() {
		return this.getAp_ot();
	}
	
	public String getResultForget_in() {
		return String.valueOf(this.getForget_in());
	}
	
	public String getResultForget_out() {
		return String.valueOf(this.getForget_out());
	}

	public CscCalendar getResult_Inzone_begin() {
		if(this.getInZone()==null){
			return c_dt_in;
		}else{
			return this.getInZone().getBeginZone();
		}//end if 
	}
	
	public CscCalendar getResult_Inzone_end() {
		if(this.getInZone()==null){
			return c_dt_in;
		}else{
			return this.getInZone().getEndZone();
		}//end if 
	}
	
	public CscCalendar getResult_Outzone_begin() {
		if(this.getOutZone()==null){
			return c_dt_out;
		}else{
			return this.getOutZone().getBeginZone();
		}//end if 
	}
	
	public CscCalendar getResult_Outzone_end() {
		if(this.getOutZone()==null){
			return c_dt_out;
		}else{
			return this.getOutZone().getEndZone();
		}//end if 
	}
	
	public float getResultOT1() {
		return 0;
	}
	
	public float getResultOT5() {
		return 0;
	}
	
	public float getResultOT2() {
		return 0;
	}
	
	public float getResultOT3() {
		return 0;
	}
	
	public HashMap getResultError() {
		return this.getErrorResult();
	}
	
	public TimeZone getResultMidDayStop() {
		return this.getMidDayStop();		
	}
    
    public String getResultPreviousShiftType() {
        String result="";
        if (this.getPreviousFullShift()!=null) {        
        	if (this.getShiftDate().subForDay(this.getPreviousFullShift().getShiftDate()) > 1) {
        		result = "";
        	} else {
	        	String type = this.getPreviousFullShift().tr_type;
	            if (type.length()>0) {
	                result = type.substring(0,1);
	            }
        	}
        }
        return result;
    }
    
    public String getResultNextShiftType() {
        String result="";
        if (this.getNextFullShift()!=null) {
        	if (this.getNextFullShift().getShiftDate().subForDay(this.getShiftDate()) > 1) {
        		result = "";
        	} else {        		
	            String type = this.getNextFullShift().tr_type;            
	            if (type.length()>0) {
	                result = type.substring(0,1);
	            }
        	}
        }
        return result;
    }
    
    public String getResultStatus() {
		return this.getStatus();
	}
    
    public String getResultAdjustTemp() {
		return this.getAdjustTemp();
	}
	
	public float getResultHour_s() {
		return this.getHour_s();
	}
	
	public CscCalendar getResult_o_dt_in() {
		return this.get_o_dt_in();
	}
	
	public CscCalendar getResult_o_dt_out() {
		return this.get_o_dt_out();
	}
	
	public String getResult_Sourcein() {
		return this.get_sourcein();
	}
	
	public String getResult_Sourceout() {
		return this.get_sourceout();
	}
	
	public String getResult_Workarea() {
		return this.getWorkarea();
	}

	public String getResult_Salatype() {
		return this.salatype;
	}

	public String getResult_OT_type() {
		return this.ot_type;
	}
	
	public String getResult_OT_time0() {
		return this.ot_time0;
	}
	
	public CscCalendar getResult_sh_dt_in() {
		return this.get_sh_dt_in();
	}
	
	public CscCalendar getResult_sh_dt_out() {
		return this.get_sh_dt_out();
	}

	public String getResult_Machinein() {
		return this.get_Machinein();
	}

	public String getResult_Machineout() {
		return this.get_Machineout();
	}
	
	public String getResult_DocStatus() {
		return this.getDocStatus();
	}
	// =========== End Implement TimeResult ==========//
	
	public float getBreakOT() {
		return this.getFloatPropertyShift("STP_OT");        
	}   
	
	public HashMap getResultPropertyShf() {
		return this.propertyShf;
	}
	
	public void setStatus(String str) {
		this.status = str;
	}
	
	public String getStatus() {
		return this.status;
	}
		
	public void setAdjustTemp(String tmp) {
		this.adjustTemp = tmp;
	}
	
	public String getAdjustTemp() {
		return this.adjustTemp;
	}
		
	public CscCalendar get_sh_dt_in() {
		return new CscCalendar(this.sh_dt_in.getTimestamp());
	}

	public void set_sh_dt_in(CscCalendar dt_in) {
		this.sh_dt_in = dt_in;
	}

	public CscCalendar get_sh_dt_out() {
		return new CscCalendar(this.sh_dt_out.getTimestamp());
	}

	public void set_sh_dt_out(CscCalendar dt_out) {
		this.sh_dt_out = dt_out;
	}
		
	public String get_Machinein() {
		if (this.swipeData!=null && this.swipeData.getSwipeRecord(this.inRecord)!=null)
			return this.swipeData.getSwipeRecord(this.inRecord).getMachineName();
		else return "";
	}
	
	public String get_Machineout() {
		if (this.swipeData!=null && this.swipeData.getSwipeRecord(this.outRecord)!=null)
			return this.swipeData.getSwipeRecord(this.outRecord).getMachineName();
		else return ""; 
	}
	
	public void setDocStatus(String docStatus) {
		this.docStatus = docStatus;
	}
	
	public String getDocStatus() {
		return this.docStatus;
	}
	
	public String getActualEvent(){
		return this.actual_event;
	}
	
	public void setActualEvent(String event){
		this.actual_event = event;
	}
	
	public String getActualDate(){
		if(this.actual_date != null){
			return this.actual_date;
		}else{
			return this.getShiftDate().getDDMMYYYY();
		}
	}
	
	public void setActualDate(String date){
		this.actual_date = date;
	}
	
	public float getSwipeTimeInHourZone(){
		float DEFAULT = 12;
		float val = 0;
		try{
			String s_val = StaticConfig.getConfigCompany(this.upf, "TAINZ");
			val = Float.parseFloat(s_val);
			return val;
		}catch(Exception ex){
			MyLog.error("!! Can't find TAINZ in Mconfig table or data is not number !!");
			return DEFAULT;
		}
	}
	
	public Shift clone(){
		Shift sh_new = new Shift();
		try {
			sh_new.upf = this.upf;
			sh_new.swipeData = this.swipeData;
			sh_new.timeCode = this.timeCode;
			sh_new.oldTimeCode = this.oldTimeCode;
			sh_new.oldEventGroup = this.oldEventGroup;
			sh_new.eventGroup = this.eventGroup;
			sh_new.docType = this.docType;
			sh_new.docNo = this.docNo;
			sh_new.c_dt_in = this.c_dt_in ;
			sh_new.c_dt_out = this.c_dt_out;
			sh_new.hour_d = this.hour_d;
			sh_new.lv_type = this.lv_type;
			sh_new.lv = this.lv;
			sh_new.tr_type = this.tr_type;
			sh_new.ac_ot = this.ac_ot;
			sh_new.ap_ot = this.ap_ot;
			sh_new.ac_ot_before = this.ac_ot_before;
			sh_new.ap_ot_before = this.ap_ot_before;
			sh_new.forget_in = this.forget_in;
			sh_new.forget_out = this.forget_out;
			sh_new.remark = this.remark;
			sh_new.inZone = this.inZone;
			sh_new.outZone = this.outZone;
			sh_new.inRecord = this.inRecord;
			sh_new.outRecord = this.outRecord;
			sh_new.inTimeList = this.inTimeList;
			sh_new.outTimeList = this.outTimeList;
			sh_new.swipeBeforeIn = this.swipeBeforeIn;
			sh_new.swipeAfterOut = this.swipeAfterOut;
			sh_new.previousFullShift = this.previousShift; //С͹˹
			sh_new.nextShift = this.nextShift; //жѴ
			sh_new.joinTimeIn = this.joinTimeIn;
			sh_new.joinTimeOut = this.joinTimeOut;
			sh_new.overLapTimeIn = this.overLapTimeIn;
			sh_new.overLapTimeOut = this.overLapTimeOut;
			sh_new.midDayStop = this.midDayStop;
			sh_new.find = this.find;
			sh_new.errorResult = this.errorResult;
			sh_new.hour_s = this.hour_s;
			sh_new.o_dt_in = this.o_dt_in; //ѹһԢͧ
			sh_new.o_dt_out = this.o_dt_out; //ѹ͡Ԣͧ
			sh_new.workarea = this.workarea ;
			sh_new.salatype = this.salatype;
			sh_new.ot_type = this.ot_type;
			sh_new.ot_time0 = this.ot_time0 ;
			sh_new.sh_dt_in = this.sh_dt_in ; //ѹһԢͧ
			sh_new.sh_dt_out = this.sh_dt_out ; //ѹ͡Ԣͧ
			sh_new.actual_event = this.actual_event;
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return sh_new ;
	}
	
	/* Ѻ flexible е͡óշС͹˹ ǧҷ ѺѺлѨغѹ*/
    private boolean isAutoTimeOverlapIn(Shift sh1, Shift sh2){
    	try {
    		float shfcode1 = Float.parseFloat(getStringPropertyShift("TIMESAUTO"));
    		
			CscCalendar cs1 = new CscCalendar(sh1.get_c_dt_in().getYYYYMMDDHHMMSS());
			cs1.decTime(shfcode1);
			
			if(cs1.beforeEqualsDateTime(sh2.get_c_dt_out())){
				return true ;
			}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	
    	return false ;
    }
    
    /* Ѻ flexible е͡óշС͹˹ ǧҷ ѺѺлѨغѹ*/
    private boolean isAutoTimeOverlapOut(Shift sh1, Shift sh2){
    	try {
    		float shfcode1 = Float.parseFloat(getStringPropertyShift("TIMESAUTO"));
    		
    		CscCalendar cs1 = new CscCalendar(sh1.get_c_dt_out().getYYYYMMDDHHMMSS());
			cs1.incTime(shfcode1);
			
			if(cs1.afterEqualsDateTime(sh2.get_c_dt_in())){
				return true ;
			}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	
    	return false ;
    }
    
    public void setNextShiftSwipe(long c){
    	this.next_shift_swipe = c;
    }
    
    public void setPrevShiftSwipe(long c){
    	this.prev_shift_swipe = c;
    }
    
    public CscCalendar getResultNextShiftSwipe(){
    	if( this.next_shift_swipe == 0){
    		return null;
    	}
    	return this.swipeData.getSwipeRecord(this.next_shift_swipe).getDate();
    }
    
    public CscCalendar getResultPrevShiftSwipe(){
    	if( this.prev_shift_swipe == 0){
    		return null;
    	}
    	return this.swipeData.getSwipeRecord(this.prev_shift_swipe).getDate();
    }
    
    private boolean isHoliday(){
    	return (this.getEventGroup().equalsIgnoreCase("H") || this.getEventGroup().equalsIgnoreCase("I"));
    }
}