package com.csc.library.timeattendance;

import com.csc.library.timeinterface.SwipeRecord;
import com.csc.library.utilities.MyLog;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.utilities.CscCalendar;

/*
 * 㹡ҧšٴѵ 㹡óշٴ Ҩӧҹ͡Сѹ
 */
public class SwipeVirtual implements SwipeRecord {

	private CscCalendar swipeDate = null;
	private Vector reserve = new Vector();
	private long recordNo = 0;
	private String source = "";

	public SwipeVirtual() {
		super();
	}

	public SwipeVirtual(CscCalendar d, String reserve) {
		super();
		this.setDate(d);
		this.setReserveCode(reserve);
	}

	public CscCalendar getDate() {
		return swipeDate;
	}

	public float getTime() {
		return swipeDate.getCSCTime();
	}

	public Vector getReserveCode() {
		return this.reserve;
	}

	public void setReserveCode(Object o) {
		this.reserve.add(o);
	}

	public void setDate(CscCalendar d) {
		this.swipeDate = d;
	}

	public boolean isReserved() {
		boolean result = true;
		if (this.reserve.size() > 0)
			result = false;
		return result;
	}

	public String getSwipeType() { // IN OR OUT
		String result = "";
		return result;
	}
	
	public void setSource(String source) {
		this.source = source;
	}
	
	public String getSource() { 
		//Look from systemcode ---> SWIPE_SOURCE
		return "9";
	}

	public String getMachineName() {
		//String result = "System";
		//return result;
		return "System";
	}

	public String getJobCode() {
		//String result = "";
		//return result;
		return "";
	}

	public String getTimeCode() { //
		 //String result = "Server";
		//return result;
		return "Server";
	}

	public long getRecordNo() { 
		return this.recordNo;
	}

	public void setRecordNo(long rec) {
		this.recordNo = rec;
	}

	public String getStringRecordNo() { 
		return String.valueOf(this.recordNo);
	}

	public String toString() {
		String result = "";
		result = String.valueOf(this.getRecordNo()) + "\t : "
				+ this.getDate().getDDMMYYYYHHMMSS() 
				+ "[" + this.getReserveList() + "]" + "\n";
		return result;
	}

	public String getReserveList() {
		String result = "";
		Shift s;
		String key;
		for (Iterator IT = this.reserve.iterator(); IT.hasNext();) {
			key = (String) IT.next().toString();
			result += key + ",";
		}
		return result;
	}
	
}