package com.csc.library.timeattendance;

import com.csc.library.utilities.CscCalendar;

/*
 * Class 㹡 ѹ ӹǹ 2 ش
 *  ѹ ѹش
 *  CscCalendar
 */
public class TimeZone {

	CscCalendar bg; //ǧѹ
	CscCalendar en; //ǧѹش

	public TimeZone() {
		this.clear();
	}

	public TimeZone(CscCalendar z1, CscCalendar z2) {
		this.clear();
		this.bg = z1;
		this.en = z2;
	}

	public void clear() {
		this.bg = new CscCalendar();
		this.en = new CscCalendar();
	}

	public String toString() {
		return this.bg.toString() + "-" + this.en.toString();
	}

	public void setBeginZone(CscCalendar z) {
		this.bg = z;
	}

	public void setEndZone(CscCalendar z) {
		this.en = z;
	}

	public void setTimeZone(CscCalendar z1, CscCalendar z2) {
		this.bg = z1;
		this.en = z2;
	}

	public CscCalendar getBeginZone() {
		return this.bg;
	}

	public CscCalendar getEndZone() {
		return this.en;
	}

	public void setExtendBeginZone(CscCalendar z) {
		if (this.bg.after(z))
			this.bg = z;
	}

	public void setExtendEndZone(CscCalendar z) {
		if (this.en.before(z))
			this.en = z;
	}

	public boolean inZone(CscCalendar z) {
		if (this.bg.beforeEquals(z) && this.en.afterEquals(z)) {
			return true;
		} else {
			return false;
		}
	}

	public float getGap() {
		return this.en.subForHour(this.bg);
	}

	public float getDecimalGap() {
		return this.en.subForDecimal(this.bg);
	}

}