package com.csc.library.timeinterface;

import com.csc.library.timeattendance.TimeZone;
import com.csc.library.utilities.MyLog;
import java.util.HashMap;

import com.csc.library.utilities.CscCalendar;

public interface TimeResult {	
	public String getResultTimeCode();
	public String getResultOldTimeCode();
	public CscCalendar getResultShiftCalendar();
	public String getResultEventGroup();
	public String getResultOldEventGroup();
	public String getResultIsWork();
	public String getResultDocType();
	public String getResultDocNo();
	public CscCalendar getResult_c_dt_in();
	public CscCalendar getResult_c_dt_out();
	public CscCalendar getResult_m_dt_in();
	public CscCalendar getResult_m_dt_out();
	public float getResultLT();
	public float getResultC_LV();
	public float getResultM_LV();
	public String getResultLV_Type();
	public String getResultTR_Type();
	public float getResultAc_ot();
	public float getResultAp_ot();
	public String getResultForget_in();
	public String getResultForget_out();
	public CscCalendar getResult_Inzone_begin();
	public CscCalendar getResult_Inzone_end();
	public CscCalendar getResult_Outzone_begin();
	public CscCalendar getResult_Outzone_end();
	public float getResultOT1();
	public float getResultOT5();
	public float getResultOT2();
	public float getResultOT3();	
	public HashMap getResultError();
	public TimeZone getResultMidDayStop();	
    public String getResultPreviousShiftType();    
    public String getResultNextShiftType();
    public HashMap getResultPropertyShf();
    public String getResultStatus();
    public String getResultAdjustTemp();
    public float getResultHour_s();
    public CscCalendar getResult_o_dt_in();
	public CscCalendar getResult_o_dt_out();
	public String getResult_Sourcein();
	public String getResult_Sourceout();
	public String getResult_Workarea();
	public String getResult_Salatype();
	public String getResult_OT_type();	
	public CscCalendar getResult_sh_dt_in();
	public CscCalendar getResult_sh_dt_out();
	public String getResult_Machinein();
	public String getResult_Machineout();	
	public String getResult_OT_time0();
	public String getResultOldDocType();
	public String getResultOldDocNo();
	public String getResult_DocStatus();
	public String getActualEvent();
	public String getActualDate();
	public CscCalendar getResultNextShiftSwipe();
	public CscCalendar getResultPrevShiftSwipe();
}
